<?php
/**
 * parameters.php
 * Parameters management
 *
 * PHP versions 4 and 5
 *
 * @".PARAM_DB_PREFIX."framework_ Scripts
 * @package  Project_Mngt:administration
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  http://www.php.net/license/3_01.txt  PHP License 3.01
 * */     
define("PATHBASE",'../');
require_once PATHBASE.'header.php';
$targetFile='parameters.php?';
$cnx=new connexion_db();

$displayTable=true;

// check token  
if (appUtils::checkToken())
{        
  // action allowed 
  switch ($_REQUEST['action'])
  {
    case 'modify':
      $request=new sqlRequest("SELECT parameter_translation_value AS parameter_name,parameter_value,parameter_type 
                               FROM ".PARAM_DB_PREFIX."framework_parameters,".PARAM_DB_PREFIX."framework_parameters_translations 
                               WHERE parameter_translation_language='".$_SESSION['language']."' 
                                 AND parameter_tag_id=parameter_tag_id_fk 
                                 AND parameter_tag_id='".$_REQUEST['id_to_modify']."'",$cnx->num);
      $parameter=$request->getObject(); ?>
      <form class="pure-form pure-form-aligned" action="<?php echo $targetFile;?>&action=submit_modify" method="post" enctype="multipart/form-data" name="form_parameter">
       <fieldset class="fieldset">
         <legend class="legend"><?php echo $legend_changing_m.' '.lcfirst($text_parameter).' : '.$parameter->parameter_name;?></legend>
         <input type="hidden" name="form_item_parameter_tag_id" value="<?php echo $_REQUEST['id_to_modify'];?>">
         <?php appUtils::insertTokenInForm();?>
         <label class="label required_field50" ><?php echo $text_value;?></label><?php
          // change display depending on the parameter type    
          if ($parameter->parameter_type=='LIST' || $parameter->parameter_type=='REQUEST')
          {
            // switch between REQUEST and LIST  
            if ($parameter->parameter_type=='LIST')
            {
              // get values for LIST
              $request->sqlGet("SELECT parameter_value_label,parameter_value  
                               FROM ".PARAM_DB_PREFIX."framework_parameters_values_lists 
                               WHERE parameter_tag_id_fk='".$_REQUEST['id_to_modify']."'");  
              $listValues=$request->getArrayFields();
            }
            else
            {
              // GET for REQUEST
              // get items to build the request  
              $request->sqlGet("SELECT *
                                FROM ".PARAM_DB_PREFIX."framework_parameters_requests 
                                WHERE parameter_tag_id_fk='".$_REQUEST['id_to_modify']."'");
              $itemsForRequest=$request->getObject();
              // Get data with the built request
              $request->sqlGet("SELECT ".$itemsForRequest->request_label." AS parameter_value_label,".$itemsForRequest->request_value." AS parameter_value  
                               FROM ".$itemsForRequest->request_table."   
                               WHERE ".$itemsForRequest->request_clause);
              $listValues=$request->getArrayFields();  
            }?>
         
            <select name="form_item_parameter_value" class="std_form_field_liste" ><?php
            for ($i=0;$i<count($listValues);$i++)
            {?> 
               <option  value="<?php echo $listValues[$i]['parameter_value'];?>" <?php if ($listValues[$i]['parameter_value']==$parameter->parameter_value) {echo 'selected="selected"';}?> /><?php 
                 if (isset($$listValues[$i]['parameter_value_label']))
                 {
                   echo $$listValues[$i]['parameter_value_label'];  
                 }     
                 else 
                 {
                     echo $listValues[$i]['parameter_value_label'];
                 }?>
               </option><?php
            }?>
            </select> <div class="clearleft"></div> <?php
          }
          else 
          {?>
            <input class="std_form_field" name="form_item_parameter_value" type="text" size="30" value="<?php echo $parameter->parameter_value;?>" /><div class="clearleft"></div><?php
          }?>
         <br /><?php
           displayButton($button_submit,'','javascript:CheckFormParameter()','tsc_awb_medium tsc_awb_green tsc_flat');	
           displayButton($button_cancel,'',$targetFile,'tsc_awb_medium tsc_awb_orange tsc_flat');	?>
	
       </fieldset><div class="clearleft"></div>
      </form><?php
      $displayTable=false;  	
    break;	
     
    case 'submit_modify':
  	  $request=new sqlRequest("UPDATE ".PARAM_DB_PREFIX."framework_parameters SET parameter_value='".$_POST['form_item_parameter_value']."' WHERE parameter_tag_id='".$_REQUEST['form_item_parameter_tag_id']."'",$cnx->num);?>
  	  <div class="MessageBox ConfirmationMessageBox"><?php echo $msg_object_updated;?></div><?php
    break;  
     
	case 'change_button':
	  // switch between use or no use of country field
  	  $request=new sqlRequest("UPDATE ".PARAM_DB_PREFIX."framework_parameters SET parameter_value=NOT(parameter_value) WHERE parameter_tag_id='".$_REQUEST['parameter_id']."'",$cnx->num);
	break;		 
  }  	 
}

  if ($displayTable)
  {
    // set token  
    appUtils::initToken(); 
    // add token to target file
    $targetFile=addParamUrl($targetFile,'token='.appUtils::getToken());        
    // display parameters with switch?>
	<div class="MessageBox InformationMessageBox"><?php echo $msg_managing_parameters_switch;?></div><br />
        <div><?php
    $sqlParametersSW="SELECT parameter_tag_id,parameter_translation_value AS parameter_name,parameter_value 
	              FROM ".PARAM_DB_PREFIX."framework_parameters,".PARAM_DB_PREFIX."framework_parameters_translations 
		      WHERE parameter_translation_language='".$_SESSION['language']."' AND parameter_type='SWITCH' 
		        AND parameter_tag_id=parameter_tag_id_fk AND parameter_display=1"; 
    $request=new sqlRequest($sqlParametersSW,$cnx->num); 	  	         
    $resultsArray=$request->getArrayFields();
    for ($i=0;$i<count($resultsArray);$i++)
    {
        $buttonText=$resultsArray[$i]['parameter_name'];
        $urlButtonOnOff=$targetFile.'&action=change_button&parameter_id='.$resultsArray[$i]['parameter_tag_id'];
        $boolOnOff=$resultsArray[$i]['parameter_value'];
        include  $pathCommons.'on_off_button.php';
    }?>
    <div class="clearleft"></div></div><br /> <?php
		
    unset($resultsArray);
    // display parameters in INT, STRING, LIST or REQUEST format?>
	<div class="MessageBox InformationMessageBox"><?php echo $msg_managing_parameters;?></div><?php
     $sqlParameters="(SELECT parameter_tag_id,parameter_translation_value AS parameter_name,parameter_value,parameter_type 
	             FROM ".PARAM_DB_PREFIX."framework_parameters,".PARAM_DB_PREFIX."framework_parameters_translations 
		     WHERE parameter_translation_language='".$_SESSION['language']."' AND parameter_type IN ('INT','STRING','REQUEST') 
		       AND parameter_tag_id=parameter_tag_id_fk AND parameter_display=1)
                     UNION
                     (SELECT parameter_tag_id,parameter_translation_value AS parameter_name,lst.parameter_value_label,parameter_type   
	             FROM ".PARAM_DB_PREFIX."framework_parameters prm,".PARAM_DB_PREFIX."framework_parameters_translations trans,".PARAM_DB_PREFIX."framework_parameters_values_lists lst
		     WHERE parameter_translation_language='".$_SESSION['language']."' AND parameter_type='LIST'  
                       AND lst.parameter_value=prm.parameter_value  
		       AND parameter_tag_id=lst.parameter_tag_id_fk 
                       AND parameter_tag_id=trans.parameter_tag_id_fk 
                       AND parameter_display=1)"; 
           
     // init sorting object
     $sortColumn=new sortColumn('param_sort',$targetFile,$pathImages);?>
     <table class="zebraTable">
       <tr>
         <th><?php echo $text_parameter; $sortColumn->displaySortButtons('parameter_name');?></th>
         <th><?php echo $text_value;?></th>
         <th><center><a href="#" tooltip="<?php echo $text_management;?>"><img src="<?php echo $pathImages;?>tools.png" border="0" /></a></center></th>       
       </tr><?php
       $request=new sqlRequest($sqlParameters.$sortColumn->returnSqlOrderBy(),$cnx->num);
       $resultsArray=$request->getArrayFields();
              
       for ($i=0;$i<count($resultsArray);$i++)
       {?>
         <tr>
           <td><?php echo $resultsArray[$i]['parameter_name'];?></td>
           <td><?php 
             // if parameter type is REQUEST, label must be get from the request table
             if ($resultsArray[$i]['parameter_type']=='REQUEST')
             {
                // GET for REQUEST
                // get items to build the request  
                $request->sqlGet("SELECT *
                                  FROM ".PARAM_DB_PREFIX."framework_parameters_requests 
                                  WHERE parameter_tag_id_fk='".$resultsArray[$i]['parameter_tag_id']."'");
                $itemsForRequest=$request->getObject();
                // Get data with the built request
                $request->sqlGet("SELECT ".$itemsForRequest->request_label." AS parameter_value_label 
                                 FROM ".$itemsForRequest->request_table."   
                                 WHERE ".$itemsForRequest->request_value."='".$resultsArray[$i]['parameter_value']."' AND ".$itemsForRequest->request_clause);   
                $request->getObject();
                echo $request->objet->parameter_value_label;
             }
             else
             {
               // else display the message var build with value if exists
               if (isset($$resultsArray[$i]['parameter_value']))
               {
                 // used for sorting mode for instance
                 echo $$resultsArray[$i]['parameter_value'];
               }
               else
               {
                 // display the value itself  
                 echo $resultsArray[$i]['parameter_value'];  
               }
             }?>
           </td>
           <td class="nowrap"><center><a href="<?php echo $targetFile;?>&action=modify&id_to_modify=<?php echo $resultsArray[$i]['parameter_tag_id'];?>" tooltip="<?php TextDisplay($action_delete);?>"><img src="<?php echo $pathImages;?>edit.png" border=0 /></a></center></td>
         </tr><?php
       }?>
     </table><?php     
  }

$cnx->close();  

require_once PATHBASE.'footer.php';?>