<?php
/**
 * Script by an AJAX script to update position of an item in a dashboard from its position captured by the AJAX
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement:Ajax
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  
 

define("PATHBASE",'../');

$pathClasses=PATHBASE.'libraries/classes/';
$pathCommons=PATHBASE.'common_scripts/';  
$pathImages=PATHBASE.'images/';
$pathAppClasses=PATHBASE.'classes/';

include PATHBASE.'conf/connect.conf';
require_once $pathClasses.'class_connexion_mysql.php';
$cnx=new connexion_db();
require_once $pathCommons.'functions.php';
require_once PATHBASE.'session_settings.php';

if (isset($_SESSION['login']))
{
require_once $pathCommons.'app_functions.php';
require_once $pathCommons.'date_hour.php';
require_once $pathAppClasses.'project.php';
require_once $pathAppClasses.'history.php';
require_once PATHBASE.'messages/'.$_SESSION['language'].'_app_messages.php';
require_once PATHBASE.'messages/'.$_SESSION['language'].'_ihm_messages.php';

$filteredItemType=filterItemType($_REQUEST['item_type']);
$simpleItemType=getSimpleItemType($filteredItemType);
require_once PATHBASE.'dashboard_settings.php';

// Validating the input data:

if(!is_numeric($_REQUEST['id']) || !is_numeric($_REQUEST['x']) || !is_numeric($_REQUEST['y']) || !is_numeric($_REQUEST['z']) || !isset($_REQUEST['status']))
{
  die("0");
}
if (isset($_SESSION['current_project_id']))
{    
  $currentProject=new project($cnx->num,$_SESSION['current_project_id']);
}
else
{    
  $currentProject=new project($cnx->num,0);
}    
$currentProject->getData();

require_once PATHBASE.'boards_settings/settings_'.$filteredItemType.'.php';

// Escaping:
$id = (int)$_REQUEST['id'];
$x = (int)$_REQUEST['x'];
$y = (int)$_REQUEST['y'];
$z = (int)$_REQUEST['z'];
$status=$_REQUEST['status'];

// Check if a note is near the moved one
$request= new sqlRequest("SELECT * FROM ".$tableData." WHERE ABS(".$yPosField."-".$y.")<15 AND ABS(".$xPosField."-".$x.")<20 AND ".$itemIdName."!=".$id." AND ".$managedField."='".$status."' AND active=1".$clauseWhereElements,$cnx->num);
$request->countRows();
if ($request->rowCount!=0)
{
  $y+=15;  
}

$request->sqlGet("SELECT ".$managedField." AS status FROM ".$tableData." WHERE ".$itemIdName."=".$id);
$oldObject=$request->getObject();

$updateDateSet='';
if (isset($updateDateField))
{
  $updateDateSet=",".$updateDateField."='".date('Y-m-d H:i:s')."'";  
}
if (isset($updaterUsernameField))
{
  $updateDateSet.=",".$updaterUsernameField."='".$_SESSION['login']."'";  
}    
// get data from the item to compare and add history if there is a change
$request->sqlGet("SELECT * FROM ".$tableData." WHERE ".$itemIdName."=".$id);
$tmp=$request->getArrayFields();
$updatedObject=$tmp[0];

// if object id task, memorize the parent US status (for further use)
if ($filteredItemType=='tasks_sprint' || $filteredItemType=='pbl_tasks' || $filteredItemType=='rbl_tasks')
{
  // get US
  $request->sqlGet("SELECT * FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE us_id=".$_REQUEST['parent_id']);
  $usData=$request->getObject();
  // store US status
  $oldUsStatus=$usData->status;
}


// Saving the position of the note and the main field to update
$request->sqlGet("UPDATE ".$tableData." SET ".$xPosField."=".$x.",".$yPosField."=".$y.",".$zPosField."=".$z.",".$managedField."='".$status."'".$updateDateSet." WHERE ".$itemIdName."=".$id);

$historyObject=new history($cnx->num);

if ($status!=$updatedObject[$managedField] && ($simpleItemType=='us' || $simpleItemType=='task'))
{
  $historyObject->addPostitHistory(strtoupper($simpleItemType),$id,$managedField,$updatedObject[$managedField], $status, $_SESSION['login']);
}

// if $filteredItemType==us_project, it's necessary to check if there is change in release allocation. If yes, sprint x position must be reset.
if ($filteredItemType=='us_project' && $oldObject->status!=$status)
{ 
  $request->sqlGet("UPDATE ".$tableData." SET us_sprint_id_fk=0,xpos_s=".$xInitDefaultPosition." WHERE ".$itemIdName."=".$id);
}

// if $filteredItemType==us_release, all tasks load value must be set to remaining2do value
if ($filteredItemType=='us_release' && $oldObject->status!=$status)
{ 
  $request->sqlGet("UPDATE ".PARAM_DB_PREFIX."kados_tasks SET task_load=task_raf WHERE us_id_fk=".$id);
}

// Affect leader to a task if the previous status is the first one (TO DO) and there is a change in status and the object is a task
if (($filteredItemType=='tasks_sprint' || $filteredItemType=='pbl_tasks' || $filteredItemType=='rbl_tasks') && $oldObject->status!=$status)
{ 
  // assign (always, even if it is the same user)  
  $request->sqlGet("UPDATE ".$tableData." SET task_leader='".$_SESSION['login']."',task_finished=0,task_date_finished=NULL WHERE ".$itemIdName."=".$id);
  // if user has changed, log it
  if ($updatedObject['task_leader']!=$_SESSION['login'])
  {
    $historyObject->addPostitHistory(strtoupper($simpleItemType),$id,'task_leader',$updatedObject['task_leader'], $_SESSION['login'], $_SESSION['login']);
  }  
}

// Affect leader to a action if the previous status is the first one (TO DO) and there is a change in status and the object is an action
if ($filteredItemType=='issues_actions' && $oldObject->status!=$status)
{ 
  $request->sqlGet("UPDATE ".$tableData." SET action_leader='".$_SESSION['login']."' WHERE ".$itemIdName."=".$id);
}

// Set 2do2finish at zero if the task is in the last status and there is a change in status and the object is a task
if (($filteredItemType=='tasks_sprint' || $filteredItemType=='pbl_tasks' || $filteredItemType=='rbl_tasks') && $status==$boardFinalStatusTag && $oldObject->status!=$status)
{ 
  $request->sqlGet("UPDATE ".$tableData." SET task_raf=0,task_finished=1,task_date_finished='".aujourdhui()."' WHERE ".$itemIdName."=".$id);
  // Update record of the situation
  if (isset($_SESSION['current_sprint_id']))
  {
    $currentSprintId=$_SESSION['current_sprint_id'];
    require PATHBASE.'progress_recording.php';
  }	
}

// Set 2do2finish at zero if the action is in the last status and there is a change in status and the object is an action
if ($filteredItemType=='issues_actions' && $status==$boardFinalStatusTag && $oldObject->status!=$status)
{ 
  $request->sqlGet("UPDATE ".$tableData." SET action_raf=0 WHERE ".$itemIdName."=".$id);
}

// Manage status of US or Issue when tasks are finished or re-started
$retour=':STDBY:0';

/*  ------------- TASKS----------------------------*/
// if item is a task and the JS need the count of tasks finished, send it
if (($filteredItemType=='tasks_sprint' || $filteredItemType=='pbl_tasks' || $filteredItemType=='rbl_tasks') && $status==$boardFinalStatusTag && $oldObject->status!=$status)
{ 
  $request->sqlGet("SELECT COUNT(task_id) AS nb,status FROM ".PARAM_DB_PREFIX."kados_tasks WHERE active=1 AND us_id_fk=".$_REQUEST['parent_id']." GROUP BY status");
  $tasksByStatus=$request->getArrayFields();
  $request->sqlGet("SELECT * FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE us_id=".$_REQUEST['parent_id']);
  $usData=$request->getObject();

  if(count($tasksByStatus)==1 && $tasksByStatus[0]['status']==$boardFinalStatusTag)
  {
    // If US is already DONE (that is to say, a manual action has set to DONE, do nothing
    if ($usData->status=='RUN')
    {
      // send situation back to screen  
      $retour=':ALMOST_DONE:'.$_REQUEST['parent_id'];
      // add history for parent US
      if ($oldUsStatus!='DEV')
      {
        // add history  
        $historyObject->addPostitHistory('US',$_REQUEST['parent_id'],'status',$oldUsStatus,'DEV', $_SESSION['login']);
        // set status in DB
        $request->sqlGet("UPDATE ".PARAM_DB_PREFIX."kados_user_stories SET status='DEV' WHERE us_id=".$_REQUEST['parent_id']);     
      }  
      require PATHBASE.'progress_log.php';
    }
  }
}

// if item is a task and the JS need the count of tasks finished, send it
if (($filteredItemType=='tasks_sprint' || $filteredItemType=='pbl_tasks' || $filteredItemType=='rbl_tasks') && $oldObject->status==$boardFinalStatusTag && $oldObject->status!=$status)
{ 
  $request->sqlGet("SELECT COUNT(task_id) AS nb,status FROM ".PARAM_DB_PREFIX."kados_tasks WHERE active=1 AND us_id_fk=".$_REQUEST['parent_id']." GROUP BY status");
  $tasksByStatus=$request->getArrayFields();
  $request->sqlGet("SELECT * FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE us_id=".$_REQUEST['parent_id']);
  $usData=$request->getObject();
  
  if(count($tasksByStatus)>1 || count($tasksByStatus)==1 && $tasksByStatus[0]['status']!=$boardFinalStatusTag)
  {
    $retour=':BACK_TODO:'.$_REQUEST['parent_id'];  
    require PATHBASE.'progress_log.php';
    // compute new status
    $newStatus=usComputeStatus($_REQUEST['parent_id'],$oldUsStatus);
    // set US status
    $request->sqlGet("UPDATE ".PARAM_DB_PREFIX."kados_user_stories SET status='".$newStatus."' WHERE us_id=".$_REQUEST['parent_id']); 
    // add history for parent US
    if ($newStatus!=$oldUsStatus)
    {
      $historyObject->addPostitHistory('US',$_REQUEST['parent_id'],'status',$oldUsStatus,$newStatus, $_SESSION['login']);
    }  
  }	
}

/*  ------------- ACTIONS----------------------------*/
// if item is an action and the JS need the count of actions finished, send it
if ($filteredItemType=='issues_actions' && $status==$boardFinalStatusTag && $oldObject->status!=$status)
{ 
  $request->sqlGet("SELECT COUNT(action_id) AS nb,status FROM ".PARAM_DB_PREFIX."kados_actions WHERE active=1 AND issue_id_fk=".$_REQUEST['parent_id']." GROUP BY status");
  $actionsByStatus=$request->getArrayFields();
  $request->sqlGet("SELECT * FROM ".PARAM_DB_PREFIX."kados_issues WHERE issue_id=".$_REQUEST['parent_id']);
  $issueData=$request->getObject();

  if(count($actionsByStatus)==1 && $actionsByStatus[0]['status']==$boardFinalStatusTag)
  {
    // If US is already DONE (that is to say, a manual action has set to DONE, do nothing
    if ($issueData->status=='PROG')
    {
      // send back the message to display new issue status
      $retour=':ALMOST_DONE:'.$_REQUEST['parent_id'];
      // log status in DB
      $request->sqlGet("UPDATE ".PARAM_DB_PREFIX."kados_issues SET status='2CHK' WHERE issue_id=".$_REQUEST['parent_id']);
    }
  }
}

if ($filteredItemType=='issues_actions' && $oldObject->status==$boardFinalStatusTag && $oldObject->status!=$status)
{ 
  $request->sqlGet("SELECT COUNT(action_id) AS nb,status FROM ".PARAM_DB_PREFIX."kados_actions WHERE active=1 AND issue_id_fk=".$_REQUEST['parent_id']." GROUP BY status");
  $actionsByStatus=$request->getArrayFields();
  $request->sqlGet("SELECT * FROM ".PARAM_DB_PREFIX."kados_issues WHERE issue_id=".$_REQUEST['parent_id']);
  $issueData=$request->getObject();
  
  if(count($actionsByStatus)>1 || count($actionsByStatus)==1 && $actionsByStatus[0]['status']!=$boardFinalStatusTag)
  {
    $retour=':BACK_TODO:'.$_REQUEST['parent_id'];  
    if ($issueData->status=='2CHK')
    {
      // log status in DB
      $request->sqlGet("UPDATE ".PARAM_DB_PREFIX."kados_issues SET status='PROG' WHERE issue_id=".$_REQUEST['parent_id']);
    }  
  }	
}

echo $y.$retour;
}
else
{
  echo 'END_SESSION';
}
?>