<?php
/**
 * Actions for us management  in a dashboard
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  
 
if (!isset($otherFieldsInsert))
{
  $otherFieldsInsert='';
  $otherFieldsInsertValues='';
}
 
if (isset($_REQUEST['action']))
{
  switch ($_REQUEST['action'])
  {
    case 'add_task':
      if(ini_get('magic_quotes_gpc'))
      {
        // If magic_quotes setting is on, strip the leading slashes that are automatically added to the string:
	$_POST['note-task_load']=stripslashes(str_replace(',','.',$_POST['note-task_load']));
	$_POST['note-body']=stripslashes($_POST['note-body']);
      }

      // Escaping the input data:

      $task_load = (float)$_POST['note-task_load'];
      $body = formatStringForDB($_POST['note-body']);
      $color = $cnx->escape_string($_POST['color']);
      $zindex = (int)$_POST['zindex'];

      // Get max task_number for the project
      $request= new sqlRequest("SELECT MAX(task_number) AS max FROM ".PARAM_DB_PREFIX."kados_tasks WHERE us_id_fk=".$_REQUEST['object_id'],$cnx->num);
      $request->getObject();
      $taskNumber=(int)$request->objet->max+1;	  
	  
      // Get us_number 
      $request->sqlGet("SELECT us_number,status FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE us_id=".$_REQUEST['object_id']); 
      $usData=$request->getObject();
      $taskUsNumber=$usData->us_number;
      
      // store US detailed status
      $oldUsStatus=$usData->status;
 	  
      /* Compute position for tasks */
      // set local init positions
      $xLocalInitDefaultPosition=$xInitDefaultPosition;
      $yLocalInitDefaultPosition=$yInitDefaultPosition;         
      // get US y max and y min and number of in the backlog
      $request->sqlGet("SELECT MIN(".$yPosField.") AS ymin,MAX(".$yPosField.") AS ymax,COUNT(".$yPosField.") AS nb_items 
                       FROM ".PARAM_DB_PREFIX."kados_tasks
                       WHERE active=1 
                         AND status=(SELECT column_tag_fk 
                                     FROM ".PARAM_DB_PREFIX."kados_projects_columns 
                                     WHERE column_order=1 
                                       AND project_id_fk=".$_SESSION['current_project_id'].")
                         AND us_id_fk=".$_REQUEST['object_id']);
      $infosItemsInScope=$request->getObject();  
      if ($infosItemsInScope->nb_items!=0)
      {
        // compute y position for the new US
        $score=floor(($infosItemsInScope->ymax+$itemHeight-$infosItemsInScope->ymin+25*$infosItemsInScope->nb_items)/$infosItemsInScope->nb_items);  
        // the objective is to know if postit are more in an extended or a compact display 
        if ($score>=$itemHeight)
        {
          // if it is an extended    
          // new postit y-position is set under the last postit
          $yLocalInitDefaultPosition=$infosItemsInScope->ymax+$itemHeight+25;  
          // x position is the init x position
        }    
        else
        {
          //  if it is a more compact display
          $yLocalInitDefaultPosition=$infosItemsInScope->ymax+$itemYShift;  
          // then x-position should be a small shift
          // Check before that the postit will not "bite" on the next column
          if ((7*($infosItemsInScope->nb_items+1)+$itemWidth)<$columnWidth)
          {
            $xLocalInitDefaultPosition=7*($infosItemsInScope->nb_items+1);
          }
        }                
      }  

      // if link is not empty
      if ($_POST['note_link']!='')
      {    
        // Check if link has an allowed protocol
        if (preg_match('/^('.getParameter('APROTO',$cnx->num).'):\/\/[^ "]+$/',$_POST['note_link']))
        {
          // then set var for the SQL request  
          $recordFieldLink=',task_link';
          $recordFieldLinkValue=",'".$_POST['note_link']."'";
        }
        else 
        {
          // display warning message 
          $displayProtocolWarningMsg=true; 
          // empty var
          $recordFieldLink='';
          $recordFieldLinkValue='';
        }      
      }
      else
      {
        // no link to record   
        $recordFieldLink='';
        $recordFieldLinkValue='';
      }
        
      /* Inserting a new record in the $tableData DB: */
      $request= new sqlRequest("INSERT INTO ".$tableData." (task_number,task_us_number,text,task_load,task_init_load,color,".$xPosField.",".$yPosField.",".$zPosField.",".$managedField.$otherFieldsInsert.",
	                          task_done,task_raf,task_creation_date,task_creator,task_last_update_date,task_last_updater".$recordFieldLink.")
				VALUES (".$taskNumber.",".$taskUsNumber.",'".$body."',".$task_load.",".$task_load.",'".$color."',".$xLocalInitDefaultPosition.",".$yLocalInitDefaultPosition.",".$zindex.",'".$initialValue."'".$otherFieldsInsertValues.",
				  0,".$task_load.",'".date('Y-m-d H:i:s')."','".$_SESSION['login']."','".date('Y-m-d H:i:s')."','".$_SESSION['login']."'".$recordFieldLinkValue.")",$cnx->num);	 
      // get Task ID
      $idNewTask=$request->getLastId();
      // add history
      $historyObject=new history($cnx->num);
      // status
      $historyObject->addPostitHistory('TASK',$idNewTask,'status','', $initialValue, $_SESSION['login']);
      // text
      $historyObject->addPostitHistory('TASK',$idNewTask,'text','', $body, $_SESSION['login']);
      // if not empty, init workload
      if ($task_load!=0)
      {
        $historyObject->addPostitHistory('TASK',$idNewTask,'init_load','', $task_load, $_SESSION['login']);
      }  
      // type of task
      $historyObject->addPostitHistory('TASK',$idNewTask,'type','', $color, $_SESSION['login']);
      // link
      if ($recordFieldLinkValue!='')
      {
        $historyObject->addPostitHistory('TASK',$idNewTask,'link','', $_POST['note_link'], $_SESSION['login']);
      }        
      
      // recompute US status with task situation
      $newUsStatus=usComputeStatus($_REQUEST['object_id'],$oldUsStatus);
      // If US parent is at DONE status, reset US status to TODO
      $request->sqlGet("UPDATE ".PARAM_DB_PREFIX."kados_user_stories SET status='".$newUsStatus."' WHERE us_id=".$_REQUEST['object_id']);       
      // if US new status different from old one
      if ($newUsStatus!=$oldUsStatus)
      {
        // add history for US status 
        $history=new history($cnx->num);
        $history->addPostitHistory('US',$_REQUEST['object_id'],'status', $oldUsStatus, $newUsStatus,$_SESSION['login']);
      }
      // Update record of the situation
      if (isset($_SESSION['current_sprint_id']))
      {	  
        $currentSprintId=$_SESSION['current_sprint_id'];
        require_once PATHBASE.'progress_recording.php';
      }	
      
      // attachments management      
      $simpleItemTypeUpper='TASK';
      $postitId=$idNewTask;
      require PATHBASE.'uploaded_files_create.php';      
     
      // add tags if any
      if (isset($_POST['linkedTags']))
      {
        // if array exists
        // create tag object
        $tagAdd=new tag($cnx->num);
        // add tag(s)
        for ($i=0;$i<count($_POST['linkedTags']);$i++)
        {
          // add tag to a postit  
          $tagAdd->addToPostit($idNewTask,$_POST['linkedTags'][$i],'TASK');
          // log an history item
          $historyObject->addPostitHistory('TASK',$idNewTask,'add_tag','',$_POST['linkedTags'][$i], $_SESSION['login']);           
        }
      }
    break;
	
    case 'update_task':
      $taskToUpdateId=intval($_REQUEST['item_id']);  
      if(ini_get('magic_quotes_gpc'))
      {
	// If magic_quotes setting is on, strip the leading slashes that are automatically added to the string:
	$_POST['note-task_load']=stripslashes(str_replace(',','.',$_POST['note-task_load']));
	$_POST['note-body']=stripslashes($_POST['note-body']);
      }

      // get current values for task fields
      $request= new sqlRequest("SELECT * 
                                FROM ".PARAM_DB_PREFIX."kados_tasks 
                                WHERE task_id=".$taskToUpdateId,$cnx->num);
      $taskCurrent=$request->getObject();
      
      // Escaping the input data:
      $task_load = (float)$_POST['note-task_load'];
      $body = formatStringForDB($_POST['note-body']);
      $color = $cnx->escape_string($_POST['color']);
      $load_spent = (float)str_replace(',','.',$_POST['note-load_spent']);
      $load2finish = (float)str_replace(',','.',$_POST['note-load2finish']);
	  
      // Check if link has an allowed protocol
      if (preg_match('/^('.getParameter('APROTO',$cnx->num).'):\/\/[^ "]+$/',$_POST['note_link']) || $_POST['note_link']=='')
      {
        // then set var for the SQL request  
        $updateFieldLink="task_link='".$_POST['note_link']."',";
      }
      else
      {
        // display warning message  
        $displayProtocolWarningMsg=true;  
        // empty var to keep the current value link
        $updateFieldLink='';
      }          
      $request->sqlGet("UPDATE ".$tableData." 
                        SET text='".$body."',task_load=".$task_load.",
                            task_init_load=".$task_load.",color='".$color."',
                            ".$updateFieldLink."
                            task_done=".$load_spent.",task_raf=".$load2finish.",
                            task_last_update_date='".date('Y-m-d H:i:s')."',
                            task_last_updater='".$_SESSION['login']."' 
			WHERE ".$itemIdName."=".$taskToUpdateId);

      // add history
      $historyObject=new history($cnx->num);
      // if changed, text
      if ($_POST['note-body']!=$taskCurrent->text)
      {      
        $historyObject->addPostitHistory('TASK',$taskToUpdateId,'text',formatStringForDB($taskCurrent->text), $body, $_SESSION['login']);
      }  
      // if changed, init workload
      if ($task_load!=$taskCurrent->task_init_load)
      {
        $historyObject->addPostitHistory('TASK',$taskToUpdateId,'init_load',$taskCurrent->task_init_load, $task_load, $_SESSION['login']);
      }  
      // if changed, spent workload
      if ($load_spent!=$taskCurrent->task_done)
      {
        $historyObject->addPostitHistory('TASK',$taskToUpdateId,'load_done',$taskCurrent->task_done, $load_spent, $_SESSION['login']);
      }  
      // if changed, 2do2finish workload
      if ($load2finish!=$taskCurrent->task_raf)
      {
        $historyObject->addPostitHistory('TASK',$taskToUpdateId,'raf_load',$taskCurrent->task_raf, $load2finish, $_SESSION['login']);
      }        
      // type of task
      if ($color!=$taskCurrent->color)
      {
        $historyObject->addPostitHistory('TASK',$taskToUpdateId,'type',$taskCurrent->color, $color, $_SESSION['login']);
      }
      // link
      if ($_POST['note_link']!=$taskCurrent->task_link && $updateFieldLink!='')
      {
        $historyObject->addPostitHistory('TASK',$taskToUpdateId,'link',$taskCurrent->task_link, $_POST['note_link'], $_SESSION['login']);
      }      
      
      // Update record of the situation
      if (isset($_SESSION['current_sprint_id']))
      {
        $currentSprintId=$_SESSION['current_sprint_id'];
        require_once PATHBASE.'progress_recording.php';
      }	

      // attachments management
      $simpleItemTypeUpper='TASK';
      $postitId=$taskToUpdateId;
      require PATHBASE.'uploaded_files_update.php';

      // tags
      // gets existing tags id
      $request->sqlGet("SELECT tag_id_fk FROM ".PARAM_DB_PREFIX."kados_tags_postit WHERE postit_type='TASK' AND postit_id_fk=".$taskToUpdateId);
      $existingTags=$request->getArrayFirstFieldOnly();      
      // if tags in form
      if (isset($_POST['linkedTags']))
      { 
        // create tag object  
        $tagObject=new tag($cnx->num);  

        // remove tags in existing and not in $_POST['linkedTags']
        $removedTags= array_values(array_diff($existingTags,$_POST['linkedTags']));
        // remove tags
        for ($i=0;$i<count($removedTags);$i++)
        {
          // add tag to a postit  
          $tagObject->removeFromPostit($taskToUpdateId,$removedTags[$i],'TASK');
          // log an history item
          $historyObject->addPostitHistory('TASK',$taskToUpdateId,'remove_tag',$removedTags[$i],'', $_SESSION['login']);           
        }         
        // add tags in $_POST['linkedTags'] and not existing
        $addedTags=array_values(array_diff($_POST['linkedTags'],$existingTags));
        // add tag(s)
        for ($i=0;$i<count($addedTags);$i++)
        {
          // add tag to a postit  
          $tagObject->addToPostit($taskToUpdateId,$addedTags[$i],'TASK');
          // log an history item
          $historyObject->addPostitHistory('TASK',$taskToUpdateId,'add_tag','',$addedTags[$i], $_SESSION['login']);           
        }
      }
      else
      {
        // no tag in form
        // remove all tags
        $request->sqlGet("DELETE FROM ".PARAM_DB_PREFIX."kados_tags_postit WHERE postit_type='TASK' AND postit_id_fk=".$taskToUpdateId);
        // log history
        for ($i=0;$i<count($existingTags);$i++)
        {
          // log an history item
          $historyObject->addPostitHistory('TASK',$taskToUpdateId,'remove_tag',$existingTags[$i],'', $_SESSION['login']);           
        }          
      }
    break; 	
        
    case 'copy_tasks':
      // if all var are OK, then copy tasks  
      if (isset($_POST['source_us_id']) && isset($_POST['target_us_id']) && isset($_POST['tasks_list_count']))  
      {
        // if there are any tasks in the source US, check if any has to be copied
        if ($_POST['tasks_list_count']!=0)
        {
          for ($i=0;$i<$_POST['tasks_list_count'];$i++)  
          {
             // if task was selected , copy it
             if (isset($_POST['task_num'.$i])) 
             {
	       // Get max task_number for the project
	       $request= new sqlRequest("SELECT MAX(task_number) AS max FROM ".PARAM_DB_PREFIX."kados_tasks WHERE us_id_fk=".intval($_POST['target_us_id']),$cnx->num);
	       $request->getObject();
	       $taskNumber=(int)$request->objet->max+1;	  

	       // Get max task_number for the project
	       $request= new sqlRequest("SELECT MAX(zpos) AS max FROM ".PARAM_DB_PREFIX."kados_tasks WHERE us_id_fk=".intval($_POST['target_us_id']),$cnx->num);
	       $request->getObject();
	       $zindex=(int)$request->objet->max+1+$i;	  
               
	       // Get us_number 
	       $request->sqlGet("SELECT us_number FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE us_id=".intval($_POST['target_us_id'])); 
	       $request->getObject();
               $taskUsNumber=$request->objet->us_number;
 	       
               // store US status for source and target US

               // get target US
               $request->sqlGet("SELECT * FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE us_id=".$_POST['target_us_id']);
               $usData=$request->getObject();
               // store US status
               $oldTargetUsStatus=$usData->status;               
               
               // set different query for copy or move
               if ($_POST['action_type']=='copy')
               {
                 /* Compute position for tasks */
                 // set local init positions
                 $xLocalInitDefaultPosition=$xInitDefaultPosition;
                 $yLocalInitDefaultPosition=$yInitDefaultPosition;                        
                 // get US y max and y min and number of in the backlog
                 $request->sqlGet("SELECT MIN(".$yPosField.") AS ymin,MAX(".$yPosField.") AS ymax,COUNT(".$yPosField.") AS nb_items 
                                  FROM ".PARAM_DB_PREFIX."kados_tasks
                                  WHERE active=1 
                                    AND status=(SELECT column_tag_fk 
                                                FROM ".PARAM_DB_PREFIX."kados_projects_columns 
                                                WHERE column_order=1 
                                                  AND project_id_fk=".$_SESSION['current_project_id'].")
                                    AND us_id_fk=".intval($_POST['target_us_id']));
                 $infosItemsInScope=$request->getObject();  
                 if ($infosItemsInScope->nb_items!=0)
                 {
                   // compute y position for the new US
                   $score=floor(($infosItemsInScope->ymax+$itemHeight-$infosItemsInScope->ymin+25*$infosItemsInScope->nb_items)/$infosItemsInScope->nb_items);  
                   // the objective is to know if postit are more in an extended or a compact display 
                   if ($score>=$itemHeight)
                   {
                     // if it is an extended    
                     // new postit y-position is set under the last postit
                     $yLocalInitDefaultPosition=$infosItemsInScope->ymax+$itemHeight+25;  
                     // x position is the init x position
                   }    
                   else
                   {
                     //  if it is a more compact display
                     $yLocalInitDefaultPosition=$infosItemsInScope->ymax+$itemYShift;  
                     // then x-position should be a small shift
                     // Check before that the postit will not "bite" on the next column
                     if ((7*($infosItemsInScope->nb_items+1)+$itemWidth)<$columnWidth)
                     {
                       $xLocalInitDefaultPosition=7*($infosItemsInScope->nb_items+1);
                     }
                   }                
                 }
                 // insert tasks in DB
                 $request=new sqlRequest("INSERT INTO ".PARAM_DB_PREFIX."kados_tasks 
                                         (text, 
	                                  color, 
                                   	  status, 
	                                  active, 
                                  	  xpos, 
                                  	  ypos, 
	                                  zpos, 
                                  	  us_id_fk, 
                                  	  task_creator, 
                                   	  task_creation_date, 
                                  	  task_last_updater, 
                                  	  task_last_update_date, 
                                  	  task_number, 
	                                  task_us_number) 
                                         (SELECT text,
                                                 color,
                                                 '".$initialValue."',
                                                 1,
                                                 ".$xLocalInitDefaultPosition.",
                                                 ".$yLocalInitDefaultPosition.",
                                                 ".$zindex.",    
                                                 ".$_POST['target_us_id'].",
                                                 '".$_SESSION['login']."',
                                                 '".date('Y-m-d H:i:s')."',
                                                 '".$_SESSION['login']."',
                                                 '".date('Y-m-d H:i:s')."',                                                 
                                                 ".$taskNumber.",
                                                 ".$taskUsNumber." 
                                          FROM ".PARAM_DB_PREFIX."kados_tasks 
                                          WHERE task_id=".intval($_POST['task_num'.$i]).")",$cnx->num); 
               }
               else 
               {
                 // get source US
                 $request->sqlGet("SELECT * FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE us_id=".$_POST['source_us_id']);
                 $usData=$request->getObject();
                 // store US status
                 $oldSourceUsStatus=$usData->status;                   
                 // update mother US, task number, us number, zindex
                 $request->sqlGet("UPDATE ".PARAM_DB_PREFIX."kados_tasks
                                  SET us_id_fk=".$_POST['target_us_id'].",task_number=".$taskNumber.",
                                      task_us_number=".$taskUsNumber.",zpos=".$zindex."  
                                  WHERE task_id=".intval($_POST['task_num'.$i])); 
                 // get source US
                 $request->sqlGet("SELECT * FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE us_id=".$_POST['source_us_id']);
                 $usData=$request->getObject();
                 // store US status
                 $newSourceUsStatus=$usData->status;                                    
                 // if status are different
                 if ($newSourceUsStatus!=$oldSourceUsStatus)
                 {
                   // add history item    
                   $history=new history($cnx->num);
                   $history->addPostitHistory('US',$usData->us_id,'status',$oldSourceUsStatus, $newSourceUsStatus,$_SESSION['login']);
                 }  
                 // move folder for attachments if exists
                 
               }
               
               // recompute US status with task situation
               $newTargetUsStatus=usComputeStatus($_POST['target_us_id'],$oldTargetUsStatus);
               // If US parent is at DONE status, reset US status to TODO
               // store US status
               $request->sqlGet("UPDATE ".PARAM_DB_PREFIX."kados_user_stories SET status='".$newTargetUsStatus."' WHERE us_id=".$_POST['target_us_id']);                  
               // if status are different
               if ($newTargetUsStatus!=$oldTargetUsStatus)
               {
                 // add history item  
                 $history=new history($cnx->num);
                 $history->addPostitHistory('US',$_POST['target_us_id'],'status',$oldTargetUsStatus, $newTargetUsStatus,$_SESSION['login']);
               }                 
            }
          }
        }
      }  
    break;
  }
}