<?php
/**
 * Actions for us management  in a dashboard
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  
 
if (!isset($otherFieldsInsert))
{
  $otherFieldsInsert='';
  $otherFieldsInsertValues='';
}
 
if (isset($_REQUEST['action']))
{
  switch ($_REQUEST['action'])
  {
    case 'add_us':
      if(ini_get('magic_quotes_gpc'))
      {
	// If magic_quotes setting is on, strip the leading slashes that are automatically added to the string:
	$_POST['note-body']=stripslashes($_POST['note-body']);
      }

      // Escaping the input data:
      $business_value = $businessValueDefault;
      $body = formatStringForDB($_POST['note-body']);
      $color = $cnx->escape_string($_POST['color']);
      $zindex = (int)$_POST['zindex'];
      $complexity = 0;
	  
      // Get max us_number for the project
      $request= new sqlRequest("SELECT MAX(us_number) AS max FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE us_project_id_fk=".$_SESSION['current_project_id'],$cnx->num);
      $request->getObject();
      $usNumber=(int)$request->objet->max+1;

      /* Compute position for US */
      // set local init positions
      $xLocalInitDefaultPosition=$xInitDefaultPosition;
      $yLocalInitDefaultPosition=$yInitDefaultPosition;      
      // get US of the scope : product backlog or release backlog or feature backlog
      if ($itemType=='us_features')
      {
        $clauseScope= ' AND us_feature_id_fk=0 ';    
      }   
      else
      {
        $clauseScope= isset($_SESSION['current_release_id']) ? ' AND us_sprint_id_fk=0 AND us_release_id_fk='.$_SESSION['current_release_id'] : ' AND us_release_id_fk=0';
      }
      // get US y max and y min and number of in the backlog
      $request->sqlGet("SELECT MIN(".$yPosField.") AS ymin,MAX(".$yPosField.") AS ymax,COUNT(".$yPosField.") AS nb_items 
                       FROM ".PARAM_DB_PREFIX."kados_user_stories 
                       WHERE active=1 
                         AND us_project_id_fk=".$_SESSION['current_project_id'].$clauseScope);
      $infosItemsInScope=$request->getObject();  
      if ($infosItemsInScope->nb_items!=0)
      {
        // compute y position for the new US
        $score=floor(($infosItemsInScope->ymax+$itemHeight-$infosItemsInScope->ymin+25*$infosItemsInScope->nb_items)/$infosItemsInScope->nb_items);  
        // the objective is to know if postit are more in an extended or a compact display 
        if ($score>=$itemHeight)
        {
          // if it is an extended    
          // new postit y-position is set under the last postit
          $yLocalInitDefaultPosition=$infosItemsInScope->ymax+$itemHeight+25;  
          // x position is the init x position
        }    
        else
        {
          //  if it is a more compact display
          $yLocalInitDefaultPosition=$infosItemsInScope->ymax+$itemYShift;  
          // then x-position should be a small shift
          // Check before that the postit will not "bite" on the next column
          if ((7*($infosItemsInScope->nb_items+1)+$itemWidth)<$columnWidth)
          {
            $xLocalInitDefaultPosition=7*($infosItemsInScope->nb_items+1);
          }
        }                
      }  
      // if link is not empty
      if ($_POST['note_link']!='')
      {    
        // Check if link has an allowed protocol
        if (preg_match('/^('.getParameter('APROTO',$cnx->num).'):\/\/[^ "]+$/',$_POST['note_link']))
        {
          // then set var for the SQL request  
          $recordFieldLink=',us_link';
          $recordFieldLinkValue=",'".$_POST['note_link']."'";
        }
        else 
        {
          // display warning message 
          $displayProtocolWarningMsg=true; 
          // empty var
          $recordFieldLink='';
          $recordFieldLinkValue='';
        }      
      }
      else
      {
        // no link to record   
        $recordFieldLink='';
        $recordFieldLinkValue='';
      }
    
      /* Inserting a new record in the $tableData DB: */
      $request->sqlGet("INSERT INTO ".PARAM_DB_PREFIX."kados_user_stories (us_number,text,business_value,color,".$xPosField.",".$yPosField.",".$zPosField.",status".$otherFieldsInsertUS.",
	                         complexity,us_creation_date,us_creator,us_last_update_date,us_last_updater".$recordFieldLink.")
				   VALUES (".$usNumber.",'".$body."','".$business_value."','".$color."',".$xLocalInitDefaultPosition.",".$yLocalInitDefaultPosition.",".$zindex.",'TODO'".$otherFieldsInsertValuesUS.",
				           ".$complexity.",'".date('Y-m-d H:i:s')."','".$_SESSION['login']."','".date('Y-m-d H:i:s')."','".$_SESSION['login']."'".$recordFieldLinkValue.")");	
      // get new ID
      $idNewUS=$request->getLastId();
      // add history items
      $historyObject=new history($cnx->num);
      // status
      $historyObject->addPostitHistory('US',$idNewUS,'status','', 'TODO', $_SESSION['login']);
      // text
      $historyObject->addPostitHistory('US',$idNewUS,'text','', $body, $_SESSION['login']);
      // type of US
      $historyObject->addPostitHistory('US',$idNewUS,'type','', $color, $_SESSION['login']);
      // link
      if ($recordFieldLinkValue!='' && $_POST['note_link']!='')
      {
        $historyObject->addPostitHistory('US',$idNewUS,'link','', $_POST['note_link'], $_SESSION['login']);
      }           
      
      // attachments management      
      $simpleItemTypeUpper='US';
      $postitId=$idNewUS;
      require PATHBASE.'uploaded_files_create.php';
      
      // add tags if any
      if (isset($_POST['linkedTags']))
      {
        // if array exists
        // create tag object
        $tagAdd=new tag($cnx->num);
        // add tag(s)
        for ($i=0;$i<count($_POST['linkedTags']);$i++)
        {
          // add tag to a postit  
          $tagAdd->addToPostit($idNewUS,$_POST['linkedTags'][$i],'US');
          // log an history item
          $historyObject->addPostitHistory('US',$idNewUS,'add_tag','',$_POST['linkedTags'][$i], $_SESSION['login']);           
        }
      }
    break;
 
    case 'update_us':
      $usToUpdateId=intval($_REQUEST['item_id']);
      // get current values for US fields
      $request= new sqlRequest("SELECT * 
                                FROM ".PARAM_DB_PREFIX."kados_user_stories  
                                WHERE us_id=".$usToUpdateId,$cnx->num);
      $usCurrent=$request->getObject();
      
      if(ini_get('magic_quotes_gpc'))
      {
	 // If magic_quotes setting is on, strip the leading slashes that are automatically added to the string:
	 $_POST['note-body']=stripslashes($_POST['note-body']);
      }

      // Escaping the input data:
      $body = formatStringForDB($_POST['note-body']);
      $color = $cnx->escape_string($_POST['color']);
	  
      // Check if link has an allowed protocol
      if (preg_match('/^('.getParameter('APROTO',$cnx->num).'):\/\/[^ "]+$/',$_POST['note_link']) || $_POST['note_link']=='')
      {
        // then set var for the SQL request  
        $updateFieldLink=",us_link='".$_POST['note_link']."'";
      }
      else
      {
        // display warning message  
        $displayProtocolWarningMsg=true;       
        // empty var to keep the current value link
        $updateFieldLink='';
      }      
      
      $request= new sqlRequest("UPDATE ".PARAM_DB_PREFIX."kados_user_stories SET text='".$body."',color='".$color."',
                            us_last_update_date='".date('Y-m-d H:i:s')."',us_last_updater='".$_SESSION['login']."'".$updateFieldLink." 
							 WHERE us_id=".$usToUpdateId,$cnx->num);
      // add history
      $historyObject=new history($cnx->num);      
      
      // if changed, text
      if ($_POST['note-body']!=$usCurrent->text)
      {      
        $historyObject->addPostitHistory('US',$usToUpdateId,'text',formatStringForDB($usCurrent->text), $body, $_SESSION['login']);
      }        
      // type of us
      if ($color!=$usCurrent->color)
      {
        $historyObject->addPostitHistory('US',$usToUpdateId,'type',$usCurrent->color, $color, $_SESSION['login']);
      }
      // link
      if ($_POST['note_link']!=$usCurrent->us_link && $updateFieldLink!='')
      {
        $historyObject->addPostitHistory('US',$usToUpdateId,'link',$usCurrent->us_link, $_POST['note_link'], $_SESSION['login']);
      }          
      
      // attachments management
      $simpleItemTypeUpper='US';
      $postitId=$usToUpdateId;
      require PATHBASE.'uploaded_files_update.php';
      
      // tags
      // gets existing tags id
      $request->sqlGet("SELECT tag_id_fk FROM ".PARAM_DB_PREFIX."kados_tags_postit WHERE postit_type='US' AND postit_id_fk=".$usToUpdateId);
      $existingTags=$request->getArrayFirstFieldOnly();      
      // if tags in form
      if (isset($_POST['linkedTags']))
      { 
        // create tag object  
        $tagObject=new tag($cnx->num);  

        // remove tags in existing and not in $_POST['linkedTags']
        $removedTags= array_values(array_diff($existingTags,$_POST['linkedTags']));
        // remove tags
        for ($i=0;$i<count($removedTags);$i++)
        {
          // add tag to a postit  
          $tagObject->removeFromPostit($usToUpdateId,$removedTags[$i],'US');
          // log an history item
          $historyObject->addPostitHistory('US',$usToUpdateId,'remove_tag',$removedTags[$i],'', $_SESSION['login']);           
        }         
        // add tags in $_POST['linkedTags'] and not existing
        $addedTags=array_values(array_diff($_POST['linkedTags'],$existingTags));
        // add tag(s)
        for ($i=0;$i<count($addedTags);$i++)
        {
          // add tag to a postit  
          $tagObject->addToPostit($usToUpdateId,$addedTags[$i],'US');
          // log an history item
          $historyObject->addPostitHistory('US',$usToUpdateId,'add_tag','',$addedTags[$i], $_SESSION['login']);           
        }
      }
      else
      {
        // no tag in form
        // remove all tags
        $request->sqlGet("DELETE FROM ".PARAM_DB_PREFIX."kados_tags_postit WHERE postit_type='US' AND postit_id_fk=".$usToUpdateId);
        // log history
        for ($i=0;$i<count($existingTags);$i++)
        {
          // log an history item
          $historyObject->addPostitHistory('US',$usToUpdateId,'remove_tag',$existingTags[$i],'', $_SESSION['login']);           
        }          
      }
    break; 
  }	
}