<?php
/**
 * Form (popin) to move or copy tasks in a US from another one
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  
define("PATHBASE",'../');
$pathClasses=PATHBASE.'libraries/classes/';
$pathCommons=PATHBASE.'common_scripts/';  
$pathAppClasses=PATHBASE.'classes/';
$pathImages=PATHBASE.'images/';

require_once PATHBASE.'popin_includes_presession.php';

if (isset($_SESSION['login']))
{

$targetFile='manage_kanban.php?';
  // include block of classes, functions, and files useful for popin forms
  require_once PATHBASE.'popin_includes.php';
  require_once $pathCommons.'date_hour.php';
  require_once $pathAppClasses.'project.php';
  // get current project Data
  $currentProject=new project($cnx->num,$_SESSION['current_project_id']);
  $currentProject->getData();  
  // get bootstrap to securise use of $_REQUEST var
  require_once PATHBASE.'boards_settings/settings_bootstrap.php';

  // Get item Data
  $request=new sqlRequest("SELECT * FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE us_id=".$_REQUEST['object_id'],$cnx->num);
  $item=$request->getObject();

  // Set initial scope as minimum scope and get linked US
  // The initial scope is the lower level of project
  $scope[1]=' us_project_id_fk='.$_SESSION['current_project_id'];
  $scope[2]='';
  if (isset($_SESSION['current_release_id'])) 
  {
    $scope[2]=' us_release_id_fk='.$_SESSION['current_release_id'];
  }
  $scope[3]='';
  if (isset($_SESSION['current_sprint_id']))
  {
    $scope[3]=' us_sprint_id_fk='.$_SESSION['current_sprint_id'];
  }
  // get list of US from the same release
  $request=new sqlRequest("SELECT us_id,".PARAM_DB_PREFIX."kados_user_stories.text,us_number FROM ".PARAM_DB_PREFIX."kados_user_stories,".PARAM_DB_PREFIX."kados_tasks  
                           WHERE ".PARAM_DB_PREFIX."kados_user_stories.active=1 
                             AND us_id!=".$item->us_id." 
                             AND us_id_fk=us_id
                             AND ".PARAM_DB_PREFIX."kados_tasks.active=1 
	                     AND ".$scope[$currentProject->level]."
                           GROUP BY us_id_fk",$cnx->num);
  $listUs=$request->getArrayFields();?>

<h3 class="popupTitle"><?php echo $legend_move_or_copy_tasks.$item->us_number;?></h3>

<div id="noteData" > <!-- Holds the form -->
<form class="pure-form pure-form-aligned" action="<?php echo $targetFile;?><?php echo (isset($_REQUEST['blockId']) ? '&a='.md5(time()).'#Block'.$_REQUEST['blockId'] : '');?>" method="post" name="form_copy_tasks" enctype="multipart/form-data">
<input type="hidden" name="action" value="copy_tasks">
<input type="hidden" name="target_us_id" id="target_us_id" value="<?php echo $item->us_id;?>">

<input type="radio" name="action_type" id="copy" value="copy" checked="checked"><label for="copy"><?php echo $text_copy;?></label>
<input type="radio" name="action_type" id="move" value="move"><label for="move"><?php echo $text_move;?></label>
<br />

<label class="length250"><?php echo $text_search_scope;?></label> <?php 

if ($currentProject->level==3) 
{?>
  <input type="radio" class="action_scope" name="action_scope" id="sprint" value="sprint" checked="checked"><label for="sprint"><?php echo $text_sprint;?></label><?php
}
if ($currentProject->level>1) 
{?>
  <input type="radio" class="action_scope" name="action_scope" id="release" value="release"  <?php if ($currentProject->level==2) {echo 'checked="checked"';}?>><label for="release"><?php echo $text_release;?></label><?php
}?>
<input type="radio" class="action_scope" name="action_scope" id="project" value="project" <?php if ($currentProject->level==1) {echo 'checked="checked"';}?>><label for="project"><?php echo $text_project;?></label>
<br />

<label for="source_us" class="length100"><?php echo $text_source_user_story;?></label>
<select name="source_us_id" id="source_us">
  <option value="0"></option><?php
  for ($i=0;$i<count($listUs);$i++)
  {?>
    <option value="<?php echo $listUs[$i]['us_id'];?>" >US<?php echo $listUs[$i]['us_number'].':'.substr($listUs[$i]['text'],0,60);?></option><?php
  }?>
</select><div class="clearleft"></div>


<div style="font-weight:bold;margin-top:10px"><?php echo $text_tasks_list;?></div>
<input type="hidden" id="tasks_list_count" name="tasks_list_count" value="">
<div id="tasks_list" class="tasks_list_block">
  
</div>
<br />
<?php 
 displayButton($button_submit,'','','copy-task-submit tsc_awb_medium tsc_awb_green tsc_flat');	?>

</form>
    
    <script>
    $('input').customInput();
        
    $('input[name=action_scope]:radio').live('change', function() { 
        $('#source_us').html('');
        
        $.post('xmlhttprequest/get_us_in_scope.php',{scope:$(this).attr('value'),us_id:$('#noteData').find('#target_us_id').attr('value')},function(msg)
        {
	  if(msg!='')
	  {
            var AnswerObject=jQuery.parseJSON(msg);  
            $('#source_us').html('');
            $('#tasks_list').html('');
            var us_list_content='<option value="0"></option>';
            for (i=0;i<AnswerObject.length;i++)
            {
              us_list_content+='<option value="'+AnswerObject[i].us_id+'">'+AnswerObject[i].us_text+'</option>';
            }
            $('#source_us').html(us_list_content);
          } 
	});         
        
    });
    /* Source US for moving or copying tasks */
    $('#source_us').on('change',function () {
        $.post('xmlhttprequest/get_linked_tasks.php',{us_id:$(this).attr('value')},function(msg)
        {
	  if(msg!='')
	  {
            var AnswerObject=jQuery.parseJSON(msg);  
            $('#tasks_list').html('');
            $('#tasks_list_count').attr('value',AnswerObject.length);
            var tasks_list_content='';
            for (i=0;i<AnswerObject.length;i++)
            {
              tasks_list_content+='<div class="tasks_list_item"><input type="checkbox" name="task_num'+i+'" value="'+AnswerObject[i].task_id+'" id="task_num'+i+'"> <label for="task_num'+i+'"><div style="margin-right:15px;" class="color '+AnswerObject[i].color+'"></div>T'+AnswerObject[i].task_us_number+'.'+AnswerObject[i].task_number+' '+AnswerObject[i].text+'</label></div>';
            }
            $('#tasks_list').html(tasks_list_content);
            $('input').customInput();
          } 
	});         
    });
    </script>    
    
 </div><?php
}
else
{
  require_once $pathCommons.'functions.php';  ?>
  <script>
    window.location.replace('<?php echo getServerURL();?>/../index.php?warning_message=SESSION_END');
  </script>   <?php
}?>