<?php
/**
 * Form (popin) to update an item in a dashboard
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  
define("PATHBASE",'../');
$pathClasses=PATHBASE.'libraries/classes/';
$pathImages=PATHBASE.'images/';
$pathAppClasses=PATHBASE.'classes/';

require_once PATHBASE.'popin_includes_presession.php';

if (isset($_SESSION['login']))
{
  // include block of classes, functions, and files useful for popin forms
  require_once PATHBASE.'popin_includes.php';
  require_once $pathAppClasses.'project.php';
  // settings need the level of current project
  $currentProject=new project($cnx->num,$_SESSION['current_project_id']);
  $currentProject->getData();  
  // get bootstrap to securise use of $_REQUEST var
  require_once PATHBASE.'boards_settings/settings_bootstrap.php';

  $request=new sqlRequest("SELECT * FROM ".$tableData." WHERE ".$itemIdName."=".intval($_REQUEST['item_id']),$cnx->num);
  $item=$request->getObject();?>

<h3 class="popupTitle"><?php echo $legend_changing_f.' '.lcfirst($text_task);?></h3>

<!-- The preview: -->
<div id="previewNote" class="note <?php echo $item->color;?>" style="width:<?php echo $itemWidth;?>px;height:<?php echo $itemHeight;?>px;left:0;top:45px;z-index:1">
	    <div class="item-header">
		  <span class="postit_id bloc-header"><?php echo $objectTag.($item->task_us_number.'.'.$item->task_number);?></span>
		  <span class="task_load"><?php echo $item->task_load;?></span>
		</div>
	<div class="text_body" style="width:<?php echo ($itemWidth-$itemWidthBodyMargin);?>px;height:<?php echo ($itemHeight-$itemHeightBodyMargin);?>px;"><?php echo $item->text;?></div>
	<div class="item-footer">
	  <span class="load_spent"><?php echo $item->task_done;?></span>
	  <span class="load2finish" id="preview_load2finish"><?php echo $item->task_raf;?></span>
  </div>		
	<span class="data"><?php echo $item->$itemIdName;?></span>
</div>
<style>
.chosen-container .chosen-results {
    position: fixed;
    z-index: 23423423423;
    height: 200px;
    width: 300px;
    background-color: white;
    border:solid 1px lightgrey; 
}
</style>
<?php include PATHBASE.'note_color_choice.php';?>

<div id="noteData" style="margin-left:<?php echo ($itemWidth+30);?>px;"> <!-- Holds the form -->
<form class="pure-form pure-form-aligned" action="<?php echo $targetFileAction;?><?php echo (isset($_REQUEST['blockId']) ? '&a='.md5(time()).'#Block'.$_REQUEST['blockId'] : '');?>" method="post" name="form_task" enctype="multipart/form-data">
<input type="hidden" name="action" value="update_task" />
<input type="hidden" name="item_id" id="note_id" value="<?php echo $item->$itemIdName;?>">
<label for="note-body"  class="required_field"><?php echo $text_task;?></label>
<textarea name="note-body" id="note-body" class="pr-text_body"  cols="40" rows="4"><?php echo $item->text;?></textarea>
<div class="clearleft"></div>

<?php
if ($currentProject->paramUseTags)
{?>
<div id="selectDiv">
  <select name="linkedTags[]" data-placeholder="<?php TextDisplay($text_choose_tag);?>" multiple class="chosen-select" tabindex="5" id="tag_for_us">  
  </select></div><div class="clearleft"></div>	 <?php
}?>   
  <table><tr>
<td class="label "><?php echo $text_task_load;?></td>
<td><input type="text" <?php if ($item->status!=$boardInitialStatusTag) { echo 'readonly="readonly"';} else { echo 'onKeyUp="javascript:updateRAF();"';} ?> name="note-task_load" id="note-task_load" class="pr-task_load <?php if ($item->status!=$boardInitialStatusTag) { echo 'readonly_form_field';}?>" size="5" maxlength="5" value="<?php echo $item->task_load;?>" /> <?php echo lcfirst($text_hours);?></td>
      </tr>
      <tr>
<td class="label " style="clear:left;"><?php echo $text_load_spent;?></td>
<td><input type="text" <?php if ($item->status==$boardInitialStatusTag) { echo 'readonly="readonly"';}?> name="note-load_spent" id="note-load_spent" class="pr-load_spent <?php if ($item->status==$boardInitialStatusTag) { echo 'readonly_form_field';}?>" size="5" maxlength="5" value="<?php echo $item->task_done;?>" /> <?php echo lcfirst($text_hours);?></td>
  </tr>
  <tr>
<td class="label  "><?php echo $text_load2finish;?></td>
<td><input type="text" <?php if ($item->status==$boardInitialStatusTag || ($item->status==$boardFinalStatusTag && $currentProject->paramBlockRaf==1)) { echo 'readonly="readonly"';}?> name="note-load2finish" id="note-load2finish" class="pr-load2finish <?php if ($item->status==$boardInitialStatusTag || ($item->status==$boardFinalStatusTag && $currentProject->paramBlockRaf==1)) { echo 'readonly_form_field';}?>" size="5" maxlength="5" value="<?php echo $item->task_raf;?>" /> <?php echo lcfirst($text_hours);?></td>
  </tr>
  </table>
<label class="label"><?php echo $text_link;?></label>
<input id="note-link" type="text" size="43" name="note_link" value="<?php echo $item->task_link;?>">
<div class="clearleft"></div><br />
<?php

require PATHBASE.'postit_attachments_update.php';?>
<br /><br />
<?php 
 displayButton($button_submit,'','','task-submit tsc_awb_medium tsc_awb_green tsc_flat');	?>

<input class="colorname" type="hidden" name="color" value="<?php echo $item->color;?>" />
</form>

  
<?php
if ($currentProject->paramUseTags)
{?>
    <script>
        // update tags when there is a change in color = change posit type
        $('.color').live('click',function(){
          // get tag and group ids
          $.post('../xmlhttprequest/get_tags_for_postit.php',{item_type :'TASK',color:($(this).attr('class').replace('color','')).trim(),item_id:<?php echo intval($_REQUEST['item_id']);?>},function(msg){
	    if(msg!='')
	    {
              var arrayList = jQuery.parseJSON(msg);
              var groupToDisable=[];
              var cpt=0;
              var selectList = '<select name="linkedTags[]" data-placeholder="<?php TextDisplay($text_choose_tag);?>" multiple class="chosen-select" tabindex="5" id="tag_for_us">';
              var optgroup=0;
              for (var x = 0; x < arrayList.length; x++) 
              {
                if (optgroup!=parseInt(arrayList[x]['tag_group_id_fk']))
                {
                  selectList += '<optgroup label="'+arrayList[x]['tag_group_name']+'">'; 
                  optgroup=parseInt(arrayList[x]['tag_group_id_fk']);                        
                }
                selectList += '<option groupid="'+arrayList[x]['tag_group_id_fk']+'" value="'+arrayList[x]['tag_id']+'"';
                if (parseInt(arrayList[x]['postit_id_fk'])==<?php echo intval($_REQUEST['item_id']);?>)
                {
                  selectList +=' selected="selected"';
                  if (arrayList[x]['tag_group_id_fk']!=0)
                  {
                    groupToDisable[cpt]=[arrayList[x]['tag_id'],arrayList[x]['tag_group_id_fk']];  
                    cpt++;
                  }
                }
                selectList+='>' + arrayList[x]['tag_label'] + '</option>';
              }
              selectList += "</select>";
              $('#selectDiv').html(selectList);         
              // create chosen select
              $(".chosen-select").chosen({width:parseInt($('#note-body').width())+'px'}); 
              // disabled groups that have a chosen option
              for(y=0;y<groupToDisable.length;y++)
              {
                $(".chosen-select").find('option').each(function(k, i) { 
                   if ( $(i).val()!= groupToDisable[y][0] && $(i).attr("groupid")==groupToDisable[y][1])
                   {
                     $(i).prop('disabled', true);
                   }   
                  });
              }
              // update chosen select
               $('.chosen-select').trigger("chosen:updated");
              // set change actions on chosen select    
              $(".chosen-select").on('change', function (evt,params) 
              {
                if (params.selected) {
                  var group = $(this).find("option[value='" + params.selected + "']").attr("groupid");
                  if (group!=0)
                  {
                    $(this).find('option').each(function(k, i) { 
                      if ( $(i).val()!= params.selected && $(i).attr("groupid")==group)
                      {
                        $(i).prop('disabled', true);
                      }   
                    });
                  }
                }
                else if (params.deselected) 
                {
                  var group = $(this).find("option[value='" + params.deselected + "']").attr("groupid");
                  if (group!=0)
                  {
                    $(this).find('option').each(function(k, i) { 
                      if ( $(i).attr("groupid")==group)
                      {
                        $(i).prop('disabled', false);
                      }
                    });  
                  }
                }
         
                // update chosen select
                $('.chosen-select').trigger("chosen:updated");
              });                     
            }
          });
        });     
     
        // trigger for default color
        $( "#id_<?php echo $item->color;?>" ).trigger( "click" );
    </script><?php
    }?>    
        
    
</div><?php
}
else
{
  require_once $pathCommons.'functions.php';  ?>
  <script>
    window.location.replace('<?php echo getServerURL();?>/../index.php?warning_message=SESSION_END');
  </script>   <?php
}