<?php
/**
 *
 * History Management
 *
 * @category Scripts
 * @package  Project_Mngt:administration
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */    
class history {
  var $cnxHistory;   
  var $orderBy='history_item_date DESC';
  var $where;
  var $limit='';
  var $viewSecurityFields=false;
  var $statusUsLabels;
  
    function __construct($cnx_num)
    {
      // init classe
      // connect to DB  
      $this->cnxHistory=$cnx_num;
    }
    
    function loadStatusLabels($statusTable)
    {
      // load status labels
      // they can not be called directly since they are in an array
      $this->statusUsLabels=$statusTable;
    }
    
    function addPostitHistory($postitType,$postitId,$field,$oldValue,$newValue,$user)
    {   
      // add an item in history
      // get type, postit ID, the field, old and new value and the user doing the change
      $request=new sqlRequest("INSERT INTO ".PARAM_DB_PREFIX."kados_postit_history 
	                      (history_item_date, history_item_field, history_item_postit_type, 
                               history_item_postit_id_fk,history_item_old_value,history_item_new_value,
                               history_item_user_login_fk)
	                      VALUES
	                       ('".date('Y-m-d H:i:s')."','".$field."','".$postitType."',
                                ".$postitId.",'".$oldValue."','".$newValue."',
                                '".$user."')",$this->cnxHistory);
    }  
    
    function setOrderBy($orderBy)
    {
      // allow class user to add an order by part to the clause  
      $this->orderBy=$orderBy;  
    }

    function setWhere($where)
    {
      // allow class user to add a where part to the clause    
      $this->where=$where;  
    }    

    function setLimit($start,$nb)
    {
      // allow class user to add a limit part to the clause    
      $this->limit=' LIMIT '.$start.','.$nb;  
    }    
    
    function getPostitHistory($postitId,$postitType)
    {
      // get history items for a specific postit
      // from type and ID  
      $request=new sqlRequest("SELECT * 
                               FROM ".PARAM_DB_PREFIX."kados_postit_history 
                               WHERE history_item_postit_id_fk=".$postitId." 
                                 AND history_item_postit_type='".$postitType."' 
                               ".$this->where." 
	                       ORDER BY ".$this->orderBy." 
                               ".$this->limit,$this->cnxHistory);
      return $request->getArrayFields(); 
    }
    
    function getPostitHistoryCount($postitId,$postitType)
    {
      // get number of history items for a postit  
      // from type and postit ID  
      $request=new sqlRequest("SELECT COUNT(*) as nbItem
                            FROM ".PARAM_DB_PREFIX."kados_postit_history 
                            WHERE history_item_postit_id_fk=".$postitId." 
                              AND history_item_postit_type='".$postitType."' 
                            ".$this->where,
                            $this->cnxHistory);
      $request->getObject(); 
      return $request->objet->nbItem;
    }    
    
    function formatHistoryField($fieldData,$textDeletedObject)
    {
      // init result  
      $result=array();  
      // format date 
      $result['date']=returnFormattedDateHour($fieldData['history_item_date']);
      // get author
      $request=new sqlRequest("SELECT CONCAT(user_firstname,' ',user_name) AS user_fullname FROM ".PARAM_DB_PREFIX."framework_users 
                               WHERE user_login='".$fieldData['history_item_user_login_fk']."'",$this->cnxHistory);
      $request->getObject();
      $result['author']=$request->objet->user_fullname;
      // get field and old and new value depending on the field
      switch ($fieldData['history_item_field'])
      {
        case 'business_value':
          $result['field']='text_business_value';
          // for BV, value is what is logged
          $result['oldValue']=$fieldData['history_item_old_value'];
          $result['newValue']=$fieldData['history_item_new_value'];
        break;    
    
        case 'us_feature_id_fk':
          $result['field']='text_feature';
          // get previous and new feature
          $request->sqlGet("SELECT feature_id,feature_name FROM ".PARAM_DB_PREFIX."kados_features
                            WHERE feature_id IN(".$fieldData['history_item_old_value'].",".$fieldData['history_item_new_value'].")");  
          // get fields, first one is the key, second one is the value
          $request->getArrayFieldsOneField();
          // set old value, with check on sprint id
          $result['oldValue']=$fieldData['history_item_old_value']!=0 ? (isset($request->array[$fieldData['history_item_old_value']]) ? $request->array[$fieldData['history_item_old_value']] : $textDeletedObject) : '';
          // set new value, with check on sprint id
          $result['newValue']=$fieldData['history_item_new_value']!=0 ? (isset($request->array[$fieldData['history_item_new_value']]) ? $request->array[$fieldData['history_item_new_value']] : $textDeletedObject) : '';
       break;        

        case 'us_sprint_id_fk':
          $result['field']='text_sprint';
          // get previous and new sprint
          $request->sqlGet("SELECT sprint_id,sprint_name FROM ".PARAM_DB_PREFIX."kados_sprints
                            WHERE sprint_id IN(".$fieldData['history_item_old_value'].",".$fieldData['history_item_new_value'].")");  
          // get fields, first one is the key, second one is the value
          $request->getArrayFieldsOneField();
          // set old value, with check on sprint id
          $result['oldValue']=$fieldData['history_item_old_value']!=0 ? (isset($request->array[$fieldData['history_item_old_value']]) ? $request->array[$fieldData['history_item_old_value']] : $textDeletedObject) : 'Release Backlog';
          // set new value, with check on sprint id
          $result['newValue']=$fieldData['history_item_new_value']!=0 ? (isset($request->array[$fieldData['history_item_new_value']]) ? $request->array[$fieldData['history_item_new_value']] : $textDeletedObject) : 'Release Backlog';
        break;    
    
        case 'us_release_id_fk':
          $result['field']='text_release';
          // get previous and new release
          $request->sqlGet("SELECT release_id,release_name FROM ".PARAM_DB_PREFIX."kados_releases
                            WHERE release_id IN(".$fieldData['history_item_old_value'].",".$fieldData['history_item_new_value'].")");  
          // get fields, first one is the key, second one is the value
          $request->getArrayFieldsOneField();
          // set old value, with check on release id
          $result['oldValue']=$fieldData['history_item_old_value']!=0 ? (isset($request->array[$fieldData['history_item_old_value']]) ? $request->array[$fieldData['history_item_old_value']] : $textDeletedObject) : 'Product Backlog';
          // set new value, with check on release id
          $result['newValue']=$fieldData['history_item_new_value']!=0 ? (isset($request->array[$fieldData['history_item_new_value']]) ? $request->array[$fieldData['history_item_new_value']] : $textDeletedObject) : 'Product Backlog';
        break;    
    
        case 'complexity':
          $result['field']='text_complexity';
          $result['oldValue']=$fieldData['history_item_old_value'];
          $result['newValue']=$fieldData['history_item_new_value'];
        break;    
    
        case 'task_leader':
          $result['field']='text_assigned_to_f';
          // get previous and new leader from user list
          $request->sqlGet("SELECT user_login,CONCAT(user_firstname,' ',user_name) AS user_fullname FROM ".PARAM_DB_PREFIX."framework_users 
                            WHERE user_login='".$fieldData['history_item_old_value']."' 
                               OR user_login='".$fieldData['history_item_new_value']."'");  
          $request->getArrayFieldsOneField();
          $result['oldValue']= isset($request->array[$fieldData['history_item_old_value']]) ? $request->array[$fieldData['history_item_old_value']] :'';
          $result['newValue']= isset($request->array[$fieldData['history_item_new_value']]) ? $request->array[$fieldData['history_item_new_value']] :'';  
        break;    
    
        case 'status':
          $result['field']='text_status';
          if ($fieldData['history_item_postit_type']=='US')
          {
            $result['oldValue']=isset($this->statusUsLabels[$fieldData['history_item_old_value']]) ? $this->statusUsLabels[$fieldData['history_item_old_value']] : '';
            $result['newValue']=isset($this->statusUsLabels[$fieldData['history_item_new_value']]) ? $this->statusUsLabels[$fieldData['history_item_new_value']] : '';
          }
          else
          {
            // get previous and new status
            $request->sqlGet("SELECT column_tag,column_name FROM ".PARAM_DB_PREFIX."kados_template_columns
                            WHERE column_tag='".$fieldData['history_item_old_value']."' 
                               OR column_tag='".$fieldData['history_item_new_value']."'");  
            // get fields, first one is the key, second one is the value
            $request->getArrayFieldsOneField();
            $result['oldValue']= isset($request->array[$fieldData['history_item_old_value']]) ? $request->array[$fieldData['history_item_old_value']] :'';
            $result['newValue']= isset($request->array[$fieldData['history_item_new_value']]) ? $request->array[$fieldData['history_item_new_value']] :'';  
          }
        break;    
        
        case 'text':
          // field name  
          $result['field']='text_text';  
          $result['oldValue']= mb_convert_encoding($fieldData['history_item_old_value'], 'HTML-ENTITIES', 'UTF-8');
          $opcodes = FineDiff::getDiffOpcodes($result['oldValue'], mb_convert_encoding($fieldData['history_item_new_value'], 'HTML-ENTITIES', 'UTF-8'),FineDiff::$wordGranularity);
          $result['newValue']= html_entity_decode (FineDiff::renderDiffToHTMLFromOpcodes($result['oldValue'], $opcodes));               
        break;

        case 'init_load':
          // field name  
          $result['field']='text_task_load';  
          $result['oldValue']=$fieldData['history_item_old_value'];
          $result['newValue']=$fieldData['history_item_new_value'];                           
        break;

        case 'load_done':
          // field name  
          $result['field']='text_load_spent';  
          $result['oldValue']=$fieldData['history_item_old_value'];
          $result['newValue']=$fieldData['history_item_new_value'];                           
        break;    
    
        case 'raf_load':
          // field name  
          $result['field']='text_load2finish';  
          $result['oldValue']=$fieldData['history_item_old_value'];
          $result['newValue']=$fieldData['history_item_new_value'];                           
        break;
    
        case 'link':
          // field name  
          $result['field']='text_link';  
          $result['oldValue']='<a href="'.$fieldData['history_item_old_value'].'" target="_ext1">'.substr($fieldData['history_item_old_value'],0,20).(strlen($fieldData['history_item_old_value'])>20 ? '...' :'').'</a>';
          $result['newValue']='<a href="'.$fieldData['history_item_new_value'].'" target="_ext2">'.substr($fieldData['history_item_new_value'],0,20).(strlen($fieldData['history_item_new_value'])>20 ? '...' :'').'</a>';
        break;    

        case 'attachment_added':
          // field name  
          $result['field']='text_attachment_added';  
          $result['oldValue']= $fieldData['history_item_old_value'];
          $result['newValue']= $fieldData['history_item_new_value'];  
        break;

        case 'attachment_removed':
          // field name  
          $result['field']='text_attachment_removed';  
          $result['oldValue']= $fieldData['history_item_old_value'];
          $result['newValue']= $fieldData['history_item_new_value'];  
        break;       
    
        case 'add_tag':
          // field name  
          $result['field']='text_tag_added';  
          // get tag name
          $request->sqlGet("SELECT tag_label FROM ".PARAM_DB_PREFIX."kados_tags
                            WHERE tag_id=".trim($fieldData['history_item_new_value']));  
          // init new value
          $result['newValue']=$textDeletedObject;  
          // if new value exists in database
          if ($request->countRows()!=0)
          {
            $request->getObject();
            // ut it in newvalue item
            $result['newValue']= $request->objet->tag_label;  
          }  
          // set old value
          $result['oldValue']= $fieldData['history_item_old_value'];
        break;

        case 'remove_tag':
          // field name  
          $result['field']='text_tag_removed';  
          // get tag name
          $request->sqlGet("SELECT tag_label FROM ".PARAM_DB_PREFIX."kados_tags
                            WHERE tag_id=".trim($fieldData['history_item_old_value']));  
          // init old value
          $result['oldValue']=$textDeletedObject;              
          // if value exist in database
          if ($request->countRows()!=0)
          {
            $request->getObject();
            // put it in the oldvalue item
            $result['oldValue']= $request->objet->tag_label;  
          }  
          // get newValue
          $result['newValue']= $fieldData['history_item_new_value'];
        break;    
    
        case 'trash_in':
        case 'trash_out':
          $result['field']='text_'.$fieldData['history_item_field'];  
          $result['oldValue']= '';
          $result['newValue']= '';          
        break;

        case 'type':
          // field name  
          $result['field']='text_postit_type';  
          // get color signification
          $request->sqlGet("SELECT color_name,object_color_meaning  
                            FROM ((SELECT color AS color_name,use_color_meaning AS object_color_meaning 
                                   FROM ".PARAM_DB_PREFIX."kados_colors_uses
			           WHERE use_color_postit_type='".$fieldData['history_item_postit_type']."' 
                                     AND use_color_lock=1)
			          UNION
			          (SELECT color_name,object_color_meaning
			           FROM ".PARAM_DB_PREFIX."kados_projects_colors,".PARAM_DB_PREFIX."kados_colors 
			           WHERE project_id_fk=".$_SESSION['current_project_id']."
		 	             AND color_id_fk=color_id 
			             AND object_type='".$fieldData['history_item_postit_type']."')) color_table 
                            WHERE color_name='".$fieldData['history_item_old_value']."' 
                                OR color_name='".$fieldData['history_item_new_value']."'");     
          // get fields, first one is the key, second one is the value
          $request->getArrayFieldsOneField();
          $result['oldValue']= isset($request->array[$fieldData['history_item_old_value']]) ? $request->array[$fieldData['history_item_old_value']] :'';
          $result['newValue']= isset($request->array[$fieldData['history_item_new_value']]) ? $request->array[$fieldData['history_item_new_value']] :'';          
        break;
    
        case 'relationship':
          $result['field']='text_add_relationship';  
          $result['oldValue']= '';
          $request->sqlGet("SELECT us_number,text 
                            FROM ".PARAM_DB_PREFIX."kados_user_stories 
                            WHERE us_id=".$fieldData['history_item_new_value']);
          $request->getArrayFields();
          if ($request->rowCount!=0)
          {
            $result['newValue']= 'US'.$request->array[0]['us_number'].' : '.substr($request->array[0]['text'],0,120).( strlen($request->array[0]['text'])>120 ? '...' : '' );                      
          }  
          else
          {
            $result['newValue']=$textDeletedObject;  
          }
        break;
    
        case 'relationship_del':
          $result['field']='text_remove_relationship';  
          $request->sqlGet("SELECT us_number,text 
                            FROM ".PARAM_DB_PREFIX."kados_user_stories 
                            WHERE us_id=".$fieldData['history_item_old_value']);
          $request->getArrayFields();
          if ($request->rowCount!=0)
          {
            $result['oldValue']= 'US'.$request->array[0]['us_number'].' : '.substr($request->array[0]['text'],0,120).( strlen($request->array[0]['text'])>120 ? '...' : '' );                      
          }  
          else
          {
            $result['oldValue']=$textDeletedObject;  
          }
          $result['newValue']= '';
        break;    
    
      }
      return $result;
    }
}
?>