<?php

/*******************  FUNCTION  ***********************************************
NAME: make_clickable            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function make_clickable($text)
{
  return preg_replace_callback(
    '#\bhttps?://[^\s()<>]+(?:\([\w\d]+\)|([^[:punct:]\s]|/))#', 
    create_function(
      '$matches',
      'return "<a href=\'{$matches[0]}\' target=\'_ext\'>{$matches[0]}</a>";'
    ),
    $text);
}


/**
 * get access right for a local profile on a project for an action tag
 *  
 * @param varchar $user       login of a user
 * @param varchar $profileTag tag of the action
 * @param int     $projectID  project id
 * @return varchar id
 */
function isActionAllowedOnProjectForUser($user,$actionTag,$projectId)  
{
  // init answer  
  $result=false;
  // get connection
  $cnx=new connexion_db();
  // send request : check if an action (tag) is allowed for that user on that project
  $request=new sqlRequest("SELECT user_login_fk
                        FROM ".PARAM_DB_PREFIX."framework_profiles_constitution_actions t1,".PARAM_DB_PREFIX."kados_projects_users t2
                        WHERE action_tag_fk='".$actionTag."' AND t1.profile_id_fk=t2.profile_id_fk 
						     AND user_login_fk='".$user."' AND project_id_fk=".$projectId,$cnx->num);
  // count rows
  $request->countRows();
  
  // if there is some rows
  if($request->rowCount!=0)
  {
    // it is allowed  
    $result=true;
  }
  // send back answer
  return $result;
}

/**
 * get local profile on a project for an user
 *  
 * @param varchar $user       login of a user
 * @param int     $projectID  project id
 * @return varchar id
 */
function getLocalProfileOnProjectForUser($user,$projectId)  
{
  // init answer  
  $result=0;
  // get connection
  $cnx=new connexion_db();
  // send request : get profile id for for that user on that project
  $request=new sqlRequest("SELECT profile_id_fk
                        FROM ".PARAM_DB_PREFIX."kados_projects_users
                        WHERE user_login_fk='".$user."' AND project_id_fk=".$projectId,$cnx->num);
  // count rows
  $request->countRows();
  
  // if there is one row
  if($request->rowCount!=0)
  {
    // profile exists  
    $request->getObject();
    // get prifile id
    $result=$request->objet->profile_id_fk;
  }
  // send back result
  return $result;
}


/*******************  FUNCTION  ***********************************************
NAME: displayStatusImageButton            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function displayStatusImageButton($args)
{
  global $pathImages,$targetFile;
  
  $id=(int)$args[0];
  $status=$args[1];
  $allow=$args[2];
  $k=$args[3];  
  
  switch ($status)
  {
    case 'TODO':?>
      <img src="<?php echo $pathImages;?>/app/bulb.png" style="cursor:default;" /><?php
    break; 

    case 'RUN':?>
      <img src="<?php echo $pathImages;?>/app/under_progress.png" style="cursor:default;" /><?php        
    break;

    case 'DEV':
      if ($allow)
      {?>
	<a href="<?php echo $targetFile;?>&action=us_status_change&new_status=done&us_id=<?php echo $id;?>#Block<?php echo $k;?>"><img src="<?php echo $pathImages;?>/app/square_green.png" border="0" /></a><?php
      }
      else
      {?>
        <img src="<?php echo $pathImages;?>/app/square_green.png" style="cursor:default;" /><?php
      }
    break;
	
    case 'DONE':
      if ($allow)
      {?>
        <a href="<?php echo $targetFile;?>&action=us_status_change&new_status=dev&us_id=<?php echo $id;?>#Block<?php echo $k;?>"><img src="<?php echo $pathImages;?>/app/ok.png"  border="0"  /></a><?php
      }
      else
      {	?>
        <img src="<?php echo $pathImages;?>/app/ok.png" style="cursor:default;" /><?php
      }
    break;	
    
  }
}

/*******************  FUNCTION  ***********************************************
NAME: displayIssueStatusImageButton            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function displayIssueStatusImageButton($args)
{
  global $pathImages,$targetFile;
  
  $id=(int)$args[0];
  $status=$args[1];
  $allow=$args[2];
  $k=$args[3];

  switch ($status)
  {
    case 'NEW':
      if ($allow)
      {?>
        <a href="<?php echo $targetFile;?>&action=issue_status_change&new_status=away&issue_id=<?php echo $id;?>#Block<?php echo $k;?>"><img src="<?php echo $pathImages;?>/app/bulb.png" border="0" /></a><?php
      }
      else
      {?>
	<img src="<?php echo $pathImages;?>/app/bulb.png" style="cursor:default;" /><?php
      }  
    break;
    
    case 'PROG':?>
	    <img src="<?php echo $pathImages;?>/app/under_progress.png" style="cursor:default;" /><?php
    break;
      
    case '2CHK':
      if ($allow)
      {?>
        <a href="<?php echo $targetFile;?>&action=issue_status_change&new_status=away&issue_id=<?php echo $id;?>#Block<?php echo $k;?>"><img src="<?php echo $pathImages;?>/app/square_green.png" border="0" /></a><?php
      }
      else
      {?>
        <img src="<?php echo $pathImages;?>/app/square_green.png" style="cursor:default;" /><?php
      }
    break;
	
    case 'AWAY':
      if ($allow)
      {?>
        <a href="<?php echo $targetFile;?>&action=issue_status_change&new_status=2chk&issue_id=<?php echo $id;?>#Block<?php echo $k;?>"><img src="<?php echo $pathImages;?>/app/ok.png"  border="0"  /></a><?php
      }
      else
      {	?>
	<img src="<?php echo $pathImages;?>/app/ok.png" style="cursor:default;" /><?php
      }
    break;	
  }
}


/*******************  FUNCTION  ***********************************************
NAME: displayActivitySourceImage            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function displayActivitySourceImage($args)
{
  global $pathImages,$text_lock_by_template;
  
  $id=(int)$args[0];
  $activityTemplate=$args[1];
  
  if ($activityTemplate!=0)
  {?>
    <img src="<?php echo $pathImages;?>/app/template_lock.png" title="<?php echo $text_lock_by_template;?>" style="cursor:default;" /><?php
  }	
}



/*******************  FUNCTION  ***********************************************
NAME: displayLockedImage            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function displayLockedImage($args)
{
  global $pathImages,$text_lock_by_template;
  
  $id=(int)$args[0];
  $activityTemplate=$args[1];
  
  if ($activityTemplate==1)
  {?>
	 <img src="<?php echo $pathImages;?>/app/template_lock.png" title="<?php echo $text_lock_by_template;?>" style="cursor:default;" /><?php
  }	
}



/*******************  FUNCTION  ***********************************************
NAME: isTemplateActivity            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function isTemplateActivity($args)
{
  $id=(int)$args[0];
  $cnx_num=$args[1];
  
  $request=new sqlRequest("SELECT template_activity_id_fk FROM ".PARAM_DB_PREFIX."kados_activities WHERE activity_id=".$id,$cnx_num);
  $request->getObject();  
  return !($request->objet->template_activity_id_fk);
}

/*******************  FUNCTION  ***********************************************
NAME: isColorDefault            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function isColorDefault($default)
{
  global $pathImages;
  
  if ((int)$default==1)
  {?>
     <img src="<?php echo $pathImages;?>/app/star.png" style="cursor:default;" /><?php
  }	
}



/*******************  FUNCTION  ***********************************************
NAME: isColorUsed            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function isColorUsed($args)
{
  $id=(int)$args[0];
  $cnx_num=$args[1];

  $request=new sqlRequest("SELECT use_color_postit_type,color,color_id 
                        FROM ".PARAM_DB_PREFIX."kados_colors_uses,".PARAM_DB_PREFIX."kados_colors 
                        WHERE color=color_name
                          AND use_color_id=".$id,$cnx_num);
  $colorUse=$request->getObject();  
  $table='';  
  if ($colorUse->use_color_postit_type=='NONE')
  {
    return 1;
  }
  switch ($colorUse->use_color_postit_type)
  {
    case 'US':
      $table=PARAM_DB_PREFIX.'kados_user_stories';
    break;    

    case 'TASK':
      $table=PARAM_DB_PREFIX.'kados_tasks';
    break;    

    case 'ACTIV':
      $table=PARAM_DB_PREFIX.'kados_activities';
    break;    

    case 'ACTIO':
      $table=PARAM_DB_PREFIX.'kados_actions';
    break;    
  }
  
  if ($table!='')
  {      
    $request->sqlGet("SELECT COUNT(*) AS nbItem 
                     FROM ".$table." 
                     WHERE active=1 AND color='".$colorUse->color."'");
    $request->getObject();  
    $colorIsUsedInPostit=$request->objet->nbItem;
    // check if no project uses the color
    $request->sqlGet("SELECT COUNT(*) AS nbItem 
                     FROM ".PARAM_DB_PREFIX."kados_projects_colors
                     WHERE project_id_fk=".$colorUse->color_id."
                       AND object_type='".$colorUse->use_color_postit_type."'");
    $request->getObject();  
    $colorIsUsedInProject=$request->objet->nbItem;    
    return (!$colorIsUsedInProject && !$colorIsUsedInPostit);
  }
  else 
  {
    return 0;
  }
 
}

/*******************  FUNCTION  ***********************************************
NAME: getProjectSetting            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function getProjectSetting($tag,$project_id,$cnx_num)
{
  $request=new sqlRequest("SELECT setting_value FROM ".PARAM_DB_PREFIX."kados_projects_settings WHERE setting_tag='".$tag."' AND project_id_fk=".$project_id,$cnx_num);
  $request->getObject();
  return $request->objet->setting_value;
}


/*******************  FUNCTION  ***********************************************
NAME: getRunningReleaseId            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function getRunningReleaseId($project_id,$cnx_num)
{
  $request=new sqlRequest("SELECT release_id FROM ".PARAM_DB_PREFIX."kados_releases 
                   WHERE release_due_date>='".aujourdhui()."' AND release_project_id_fk=".$project_id."
				   ORDER BY release_due_date ASC LIMIT 0,1",$cnx_num);
  $request->getArrayFirstFieldOnly();
  $runningReleaseId=0;
  if ($request->rowCount)
  {
	$runningReleaseId=$request->array[0];
  }
  
  return $runningReleaseId;
}	

/*******************  FUNCTION  ***********************************************
NAME: getLastReleaseId            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function getLastReleaseId($project_id,$cnx_num)
{
  $request=new sqlRequest("SELECT release_id FROM ".PARAM_DB_PREFIX."kados_releases 
                   WHERE release_project_id_fk=".$project_id."
				   ORDER BY release_due_date DESC LIMIT 0,1",$cnx_num);
  $request->getArrayFirstFieldOnly();
  $runningLastId=0;
  if ($request->rowCount)
  {
	$runningLastId=$request->array[0];
  }
  
  return $runningLastId;
}	

/*******************  FUNCTION  ***********************************************
NAME: getInitialStatus            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function getInitialStatus($project_id)
{ 
  $cnx=new connexion_db();
  
  $request=new sqlRequest("SELECT column_tag_fk 
                        FROM ".PARAM_DB_PREFIX."kados_projects_columns 
                        WHERE project_id_fk=".$project_id." AND column_order=1",$cnx->num);
  $request->getArrayFirstFieldOnly();
  $initialValue=0;
  if ($request->rowCount)
  {
	$initialValue=$request->array[0];
  }
  
  return $initialValue;
}

/*******************  FUNCTION  ***********************************************
NAME: getFinalStatus            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function getFinalStatus($project_id)
{ 
  $cnx=new connexion_db();
  
  $request=new sqlRequest("SELECT column_tag_fk 
                        FROM ".PARAM_DB_PREFIX."kados_projects_columns 
                        WHERE project_id_fk=".$project_id." ORDER BY column_order DESC LIMIT 0,1",$cnx->num);
  $request->getArrayFirstFieldOnly();
  $finalStatus=0;
  if ($request->rowCount)
  {
	$finalStatus=$request->array[0];
  }
  
  return $finalStatus;
}

/*******************  FUNCTION  ***********************************************
NAME: filterItemType            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function filterItemType($itemType)
{
  $filterTypes['tasks_sprint']='tasks_sprint';
  $filterTypes['pbl_tasks']='pbl_tasks';
  $filterTypes['rbl_tasks']='rbl_tasks';
  $filterTypes['us_release']='us_release';
  $filterTypes['us_project']='us_project';
  $filterTypes['us_poker']='us_poker';
  $filterTypes['us_review']='us_review';
  $filterTypes['us_project_workshop']='us_project_workshop';
  $filterTypes['us_release_workshop']='us_release_workshop';    
  $filterTypes['issues_impact']='issues_impact';
  $filterTypes['issues_actions']='issues_actions';
  $filterTypes['checklist']='checklist';  
  $filterTypes['activities']='activities';  
  $filterTypes['stakeholders']='stakeholders'; 
  $filterTypes['tasks_stakeholders']='tasks_stakeholders';   
  $filterTypes['us_features']='us_features';    
  $filterTypes['colors_global']='colors_global';    
  $filterTypes['us_miniboard']='us_miniboard';
  
  $simpleItemType='none';
  if (isset($filterTypes[$itemType]))
  {
    $simpleItemType=$filterTypes[$itemType];
  }

  return $simpleItemType;
}

/*******************  FUNCTION  ***********************************************
NAME: getSimpleItemType            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function getSimpleItemType($itemType)
{
  $simplifyTypes['tasks_sprint']='task';
  $simplifyTypes['pbl_tasks']='task';
  $simplifyTypes['rbl_tasks']='task';
  $simplifyTypes['us_release']='us';
  $simplifyTypes['us_project']='us';
  $simplifyTypes['us_poker']='us';
  $simplifyTypes['us_review']='us';
  $simplifyTypes['us_project_workshop']='us';
  $simplifyTypes['us_release_workshop']='us';    
  $simplifyTypes['issues_impact']='issue';
  $simplifyTypes['issues_actions']='action';
  $simplifyTypes['checklist']='activity';  
  $simplifyTypes['activities']='activity';  
  $simplifyTypes['stakeholders']='stakeholder'; 
  $simplifyTypes['tasks_stakeholders']='task';   
  $simplifyTypes['us_features']='us';    
  $simplifyTypes['colors_global']='color';    
  $simplifyTypes['us_miniboard']='us';
  
  $simpleItemType='';
  if (isset($simplifyTypes[$itemType]))
  {
    $simpleItemType=$simplifyTypes[$itemType];
  }

  return $simpleItemType;
}

/*******************  FUNCTION  ***********************************************
NAME: getMasterItemType            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function getMasterItemType($itemType)
{
  $simplifyTypes['tasks_sprint']='us';
  $simplifyTypes['pbl_tasks']='us';
  $simplifyTypes['rbl_tasks']='us';  
  $simplifyTypes['us_release']='us';
  $simplifyTypes['us_project']='us';
  $simplifyTypes['us_poker']='us';
  $simplifyTypes['us_review']='us';
  $simplifyTypes['us_project_workshop']='us';
  $simplifyTypes['us_release_workshop']='us';  
  $simplifyTypes['issues_impact']='issue';
  $simplifyTypes['issues_actions']='issue';
  $simplifyTypes['checklist']='activity';  
  $simplifyTypes['activities']='activity';  
  $simplifyTypes['stakeholders']='stakeholder';   
  $simplifyTypes['tasks_stakeholders']='task';   
  $simplifyTypes['us_features']='us';    
  $simplifyTypes['colors_global']='color';   
  $simplifyTypes['us_miniboard']='us';
  
  $masterItemType='';
  if (isset($simplifyTypes[$itemType]))
  {
    $masterItemType=$simplifyTypes[$itemType];
  }

  return $masterItemType;
}

/*******************  FUNCTION  ***********************************************
NAME: displayImpactImage            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function displayImpactImage($impact)
{
  global $pathImages;?>
  
  <img src="<?php echo $pathImages;?>/app/impact_<?php echo $impact;?>.png" style="cursor:default;" /><?php
}

/*******************  FUNCTION  ***********************************************
NAME: displayProbability            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function displayProbability($probability)
{
  global $pathImages;
  if ($probability==100)
  {?>
    <img src="<?php echo $pathImages;?>/app/problem14.png" style="cursor:default;" /><?php
  }	
  else
  {
    echo $probability.'%';
  }
}


/*******************  FUNCTION  ***********************************************
NAME: countWorkingDaysBetweenTwoDates            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function countWorkingDaysBetweenTwoDates($date1,$date2,$workingDays=array(0,1,2,3,4),$excludeDays=array())
{
  $dateStart=new DateTime($date1);
  $dateEnd=new DateTime($date2);
  $count=0;
  
  while ($dateStart<$dateEnd)
  {
    // check current day is a working day
    if (in_array(fmod(dayOfWeek($dateStart->format('Y-m-d'))+6,7),$workingDays))
	{
	  // check if current day is not excluded
	  if (!in_array($dateStart->format('Y-m-d'),$excludeDays))
	  {
	    $count++;
	  }
	}
    $dateStart->add(new DateInterval('P1D'));
  }
  return $count;
}


/*******************  FUNCTION  ***********************************************
NAME: displayTaskInitLoad            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function displayTaskInitLoad($args)
{
  $id=(int)$args[0];
  $taskLoad=$args[1];
  $taskInitLoad=$args[3];

  if ($taskInitLoad!=$taskLoad)
  {
    echo $taskLoad.'(<i>'.$taskInitLoad.'</i>)';
  }
  else
  {
    echo $taskLoad;
  }
}

/*******************  FUNCTION  ***********************************************
NAME: usComputeStatus            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function usComputeStatus($us_id,$status)
{
  // set connection  
  $cnx=new connexion_db();
  
  // get count of tasks and their status on that US
  $request=new sqlRequest("SELECT COUNT(task_id) AS nb,status FROM ".PARAM_DB_PREFIX."kados_tasks WHERE us_id_fk=".$us_id." AND active>0 GROUP BY status",$cnx->num);
  $tasksByStatus=$request->getArrayFields();
  // Get project ID for that US
  $request->sqlGet("SELECT us_project_id_fk FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE us_id=".$us_id);
  $request->getObject();
  // Get tag for final column (status) for the project
  $finalStatusTag= getFinalStatus($request->objet->us_project_id_fk);
          
  switch ($status)
  {
    case 'DEV':
    case 'RUN':
    case 'TODO':
      // for running status  
      if (count($tasksByStatus)==0)
      {
        // if no task, status is TODO  
	return 'TODO';
      }	
      else if(count($tasksByStatus)==1 && $tasksByStatus[0]['status']==$finalStatusTag)
      {
        // if only one status for all tasks and it's the final one => status for US is ready to check (green square)  
	return 'DEV';
      }
      else
      {
        // else it's an US under progress  
        return 'RUN';
      }
    break;
	
    case 'DONE':
      // for Done  
      if (count($tasksByStatus)==0)
      {
        // if thre is no task, it's back to TODO  
	return 'TODO';
      }	
      else if(count($tasksByStatus)==1 && $tasksByStatus[0]['status']==$finalStatusTag)
      {
        // if situation has not move : all tasks in the same final column, stay to DONE  
	return 'DONE';
      }
      else
      {
        // else , go back to RUN  
        return 'RUN';
      }        
    break;	
  }
}

/*******************  FUNCTION  ***********************************************
NAME: userIsAllowedOnProject            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function userIsAllowedOnProject($projectId,$userLogin)
{
  $allow=true;
  $cnx=new connexion_db();
  $request=new sqlRequest("SELECT project_visibility FROM ".PARAM_DB_PREFIX."kados_projects WHERE project_id=".$projectId,$cnx->num);
  $projectData=$request->getObject();
  if ($projectData->project_visibility=='PRI')
  {
    $request->sqlGet("SELECT user_login_fk FROM ".PARAM_DB_PREFIX."kados_projects_users WHERE project_id_fk=".$projectId);
    $request->getArrayFirstFieldOnly();
    if (!in_array($userLogin,$request->array))
    {
      $allow=false;
    }
  }
  
  return $allow;    
}


/*******************  FUNCTION  ***********************************************
NAME: getImageFromUsDetailedStatus            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function getImageFromUsDetailedStatus($status)
{
  switch ($status)
  {
    case 'TODO':
      return 'app/bulb.png';
    break;

    case 'RUN':
      return 'app/under_progress.png';
    break;

    case 'DEV':
      return 'app/square_green.png';
    break; 

    case 'DONE':
      return 'app/ok.png';
    break;	
  }
}

/*******************  FUNCTION  ***********************************************
NAME: formatStringForDB            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function formatStringForDB($text)
{
  global $cnx;  
  // 
  if(ini_get('magic_quotes_gpc'))
  {  
    return $cnx->escape_string(strip_tags(stripslashes($text)));
  }
  else 
  {
    return $cnx->escape_string(strip_tags($text));
  }
}

/*******************  FUNCTION  ***********************************************
NAME: changeDoubleQuote            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function changeDoubleQuote($text)
{
  return str_replace('"','&quot;' ,$text);
}
?>