<?php
/**
 * Compute filter for US
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  US
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  

// Filter on the US with my tasks = put all US without a task for me in the DECK/
// Set scope
$scope=' us_project_id_fk='.$_SESSION['current_project_id'];
if (isset($_SESSION['current_sprint_id']))
{
  $scope=' us_sprint_id_fk='.$_SESSION['current_sprint_id'];
}
else if (isset($_SESSION['current_release_id']))
{
  $scope=' us_release_id_fk='.$_SESSION['current_release_id'];
}


// create filter for US (if any)
$clauseWhereUsFilter='';

// Filter A is type (color) of US
$clauseWhereUsFilterA='';
if (isset($_SESSION['filter_us']))
{
  $clauseWhereUsFilterA=" AND ".PARAM_DB_PREFIX."kados_user_stories.color='".$_SESSION['filter_us']."'";
}

// Filter B is on the feature
$clauseWhereUsFilterB=''; 
if (isset($_SESSION['feature_filter']))
{
  $clauseWhereUsFilterB=" AND us_feature_id_fk=".$_SESSION['feature_filter'];
} 
 
// Filter C is on the tasks color
$clauseWhereUsFilterC=''; 
$flagJoinTasks=false;
if (isset($_SESSION['filter_task']))
{
  $clauseWhereUsFilterB=" AND ".PARAM_DB_PREFIX."kados_tasks.color='".$_SESSION['filter_task']."'";
  $flagJoinTasks=true;  
} 

// Filter D is on the stakeholders
$clauseWhereUsFilterD=''; 
if (isset($_SESSION['stakeholder_filter']))
{
  $clauseWhereUsFilterD=" AND ".PARAM_DB_PREFIX."kados_tasks.task_leader='".$_SESSION['stakeholder_filter']."'";
  $flagJoinTasks=true;  
} 

// Filter E is on tasks text
$clauseWhereUsFilterE=''; 
if (isset($_SESSION['search_text_filter']))
{
  $clauseWhereUsFilterE=" AND LOCATE('".$_SESSION['search_text_filter']."',".PARAM_DB_PREFIX."kados_tasks.text)";
  $flagJoinTasks=true;  
} 

// Filter F is on US done
$clauseWhereUsFilterF=''; 
if (isset($_SESSION['us_status_filter']))
{
  $clauseWhereUsFilterF=" AND ".PARAM_DB_PREFIX."kados_user_stories.status!='DONE'";
} 

// Filter G is on US text
$clauseWhereUsFilterG=''; 
if (isset($_SESSION['search_text_filter_us']))
{
  $clauseWhereUsFilterG=" AND LOCATE('".$_SESSION['search_text_filter_us']."',".PARAM_DB_PREFIX."kados_user_stories.text)";
} 

// Filter H is on US tags
$clauseWhereUsFilterH=''; 
if (isset($_SESSION['tag_filter_plus_us']))
{
  if (count($_SESSION['tag_filter_plus_us'])>1)  
  {
    $request= new sqlRequest("SELECT tag_id 
                              FROM ".PARAM_DB_PREFIX."kados_tags 
                              WHERE LOWER(tag_postit_type)='us' 
                                AND tag_id IN(".implode(',',$_SESSION['tag_filter_plus_us']).")",$cnx->num);
    // if there is some US related tag in filter, set clause
    if ($request->countRows()!=0)
    {    
      $clauseWhereUsFilterH.=" AND us_id IN(SELECT postit_id_fk 
                                            FROM ".PARAM_DB_PREFIX."kados_tags_postit,".PARAM_DB_PREFIX."kados_user_stories 
                                            WHERE postit_type='US' 
                                              AND tag_id_fk IN(".implode(',',$request->getArrayFirstFieldOnly()).") 
                                              AND postit_id_fk=us_id 
                                              AND us_project_id_fk=".$_SESSION['current_project_id'].") ";  
    }
  } 
}
if (isset($_SESSION['tag_filter_minus_us']))
{
  if (count($_SESSION['tag_filter_minus_us'])>1)  
  {
    $request=new sqlRequest("SELECT tag_id 
                             FROM ".PARAM_DB_PREFIX."kados_tags 
                             WHERE LOWER(tag_postit_type)='us' 
                               AND tag_id IN(".implode(',',$_SESSION['tag_filter_minus_us']).")",$cnx->num);
    // if there is some US related tag in filter, set clause
    if ($request->countRows()!=0)
    {    
      $clauseWhereUsFilterH.=" AND us_id NOT IN(SELECT postit_id_fk 
                                                FROM ".PARAM_DB_PREFIX."kados_tags_postit,".PARAM_DB_PREFIX."kados_user_stories 
                                                WHERE postit_type='US' 
                                                  AND tag_id_fk IN(".implode(',',$request->getArrayFirstFieldOnly()).") 
                                                  AND postit_id_fk=us_id 
                                                  AND us_project_id_fk=".$_SESSION['current_project_id'].") ";  
    }
  } 
}

// final filter is A+B+C+D+E+F 
$clauseWhereUsFilter=$clauseWhereUsFilterA.$clauseWhereUsFilterB.$clauseWhereUsFilterC.$clauseWhereUsFilterD.$clauseWhereUsFilterE.$clauseWhereUsFilterF.$clauseWhereUsFilterG.$clauseWhereUsFilterH; 
 
?>
