<?php
/**
 * functions.php
 * Useful functions for all scripts
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  Project_Mngt:functions
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */ 
 
if (phpversion()<5.3)
{  
  function lcfirst($string)
  {
    $chain=strtolower(substr($string,0,1)).substr($string,1);
    return $chain;
  }
}    


  
/*******************  FUNCTION  ***********************************************
NAME: add_zero_two_digits            
OBJECT: add zero if necessary in front of an hour to have a two-digit display 
IN:
- $number   -> number to be tested
OUT: the result
*******************************************************************************/  
function add_zero_two_digits($number)
{
  if ($number>=10)
  {
    return $number;
  }
  else
  {
    return '0'.$number;
  }
}

/*******************  FUNCTION  ***********************************************
NAME:  addParamUrl           
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function addParamUrl($cible,$param)
{
  if (strpos($cible,"?")) 
    $cible.="&".$param;
  else 
    $cible.="?".$param;
	
  return $cible;
}	

/*******************  FUNCTION  ***********************************************
NAME: convert_for_uri            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function convert_for_uri($text) { 
  // Dfinition du sparateur 
  define("SEPARATOR", "_"); 

  $tofind = ""; // Lettre accentues 
  $replac = "aaaaaaooooooeeeeciiiiuuuuyn"; // Equivalant non accentu 

  // Mise en minuscule + suppression des lettres accentues par leur quivalant non accentu 
  $text = strtr(strtolower($text),$tofind,$replac); 

  // Remplacement de caractre non alphanumrique par un sparateur 
  $text = ereg_replace("[^a-z0-9]", SEPARATOR, $text); 

  // Suppression des doubles sparateurs 
  while (strstr($text, SEPARATOR . SEPARATOR)) 
    $text = str_replace(SEPARATOR . SEPARATOR, SEPARATOR, $text); 

  // Retour avec suppression dun possible sparateur en fin de chane 
  return(ereg_replace(SEPARATOR . "$", "", $text)); 
}

/*******************  FUNCTION  ***********************************************
NAME: getParameter            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function getParameter($param,$cnx_num)
{
  $request=new sqlRequest("SELECT parameter_value FROM ".PARAM_DB_PREFIX."framework_parameters WHERE parameter_tag_id='".$param."'",$cnx_num);
  $request->getArrayFirstFieldOnly();
  return $request->array[0];
}

/*******************  FUNCTION  ***********************************************
NAME: getParameter_name            
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function getParameter_name($param,$cnx_num)
{
  $request=new sqlRequest("SELECT parameter_name FROM ".PARAM_DB_PREFIX."framework_parameters WHERE parameter_tag_id='".$param."'",$cnx_num);
  $request->getArrayFirstFieldOnly();
  return $request->array[0];
}


/*******************  FUNCTION  ***********************************************
NAME: set_parameter            
OBJECT:  
IN:
- $   -> 
*******************************************************************************/
function set_parameter($param,$value,$cnx_num)
{
  $request=new sqlRequest("UPDATE ".PARAM_DB_PREFIX."framework_parameters SET parameter_value='".$value."' WHERE parameter_tag_id='".$param."'",$cnx_num);
}



/*******************  FUNCTION  ***********************************************
NAME: address_fields_not_null            
OBJECT:  
IN:
 $list -> array of variables (POST)
 $tag  -> tag to specify a set of address variables  
OUT: the result
*******************************************************************************/
function address_exists($list,$tag='')
{
  $exit=true;
  if ($list['form_item_address'.$tag.'_street1']=='' && $list['form_item_address'.$tag.'_street2']=='' &&  $list['form_item_address'.$tag.'_zip_code']=='' &&  $list['form_item_address'.$tag.'_city']=='')
  {
    $exit=false;
  }  
  return $exit;
}

/*******************  FUNCTION  ***********************************************
NAME: add_zero            
OBJECT:  
IN:
- $value   -> value for which zero must be added (before) 
OUT: the result
*******************************************************************************/
function add_zero($value,$number=6)
{
  $return_string='';
  for ($i=0;$i<$number-strlen((string)$value);$i++)
  {
    $return_string.='0';
  }
  $return_string.=(string)$value;
  return $return_string;
}


/**
 * Display a value with a money style
 *  
 * @param float $value value to display
 * @return varchar formatted value
 */
  function DisplayMoney($value)
  {
    echo number_format($value,2, ',', ' ');
  }


/**
 * Display a text formatted with utf8
 *  
 * @param varchar $text text to display
 * @return varchar formatted value
 */  
  function TextDisplay($text)
  {
    echo TextFormat($text);
  }

/**
 * Format a text with utf8
 *  
 * @param varchar $text text to display
 * @return varchar formatted value
 */  
  function TextFormat($text)
  {
    //return utf8_encode($text);
    return $text;  
  }
  

/**
 * get name of a user
 *  
 * @param varchar $userLogin user login
 * @return varchar name of the user or nothing if user does not exist
 */    
function getUserName($userLogin)  
{
  $cnx=new connexion_db();
  $request=new sqlRequest("SELECT CONCAT(user_firstname,' ',user_name) AS name FROM ".PARAM_DB_PREFIX."framework_users WHERE user_login='".$userLogin."'",$cnx->num);
  $request->countRows();
  if($request->rowCount!=0)
  {
    $request->getObject();
    return $request->objet->name;
  }
  else
  {
    return '';
  }
}

/**
 * get label of an action of the profile
 *  
 * @param varchar $actionTag tag of the action
 * @param varchar $language  language
 * @return varchar action label
 */
function getActionLabel($actionTag,$language)  
{
  $label='';
  
  $cnx=new connexion_db();
  $request=new sqlRequest("SELECT action_translation_value 
                        FROM ".PARAM_DB_PREFIX."framework_profiles_actions_translations 
                        WHERE action_translation_language='".$language."' AND action_tag_fk='".$actionTag."'",$cnx->num);
  $request->countRows();
  
  if($request->rowCount!=0)
  {
    $request->getObject();
    $label=$request->objet->action_translation_value;
	if ($pos=strrpos($label,']'))
	{
	  $label=substr($label,$pos+1);
	}
  }
  return $label;
}

/**
 * get profile id from a profile tag
 *  
 * @param varchar $profileTag tag of the profile
 * @return varchar id
 */
function getProfileIdFromTag($profileTag)  
{
  $id=0;
  
  $cnx=new connexion_db();
  $request=new sqlRequest("SELECT profile_id
                        FROM ".PARAM_DB_PREFIX."framework_profiles
                        WHERE profile_tag='".$profileTag."'",$cnx->num);
  $request->countRows();
  
  if($request->rowCount!=0)
  {
    $request->getObject();
    $id=$request->objet->profile_id;
  }
  return $id;
}

function displayButton($text,$image,$target,$class='',$specific='',$actionOn='')
{?>
  	<table class="button_shell" cellpadding="0" cellspacing="0">
	<tr><?php
          if ($image!='')
          {?>
	  <td class="button_img"><a href="<?php echo $target;?>" <?php echo $actionOn;?>  class="<?php echo $class.' '.$specific.'_img';?>" ><img src="<?php echo $image;?>" border="0" /></a> </td><?php
          }?>
	  <td> <a href="<?php echo $target;?>" <?php echo $actionOn;?>  class="<?php echo $class.' '.$specific.'_link';?>"><?php echo $text;?></a></td>	
	</tr>
	</table><?php
}

function displayButtonImg($text,$image,$target,$class='',$specific='')
{?>
  	<table class="button_shell" cellpadding="0" cellspacing="0">
	<tr>
	  <td class="button_img"><a href="<?php echo $target;?>" class="<?php echo $class.' '.$specific.'_img';?>" ><img src="<?php echo $image;?>" border="0" title="<?php echo $text;?>"  /></a> </td>
	</tr>
	</table><?php
}


/*******************  FUNCTION  ***********************************************
NAME:  setUrlForParam           
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function setUrlForParam($cible)
{
  if (strpos($cible,"?")) 
    $cible.="&";
  else 
    $cible.="?";
	
  return $cible;
}	

/*******************  FUNCTION  ***********************************************
NAME:             
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function strftimeSpecial($format,$time=-1)
{
  // Vrifie sous Windows, pour trouver et remplacer le modificateur %e 
  // correctement
  if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN') {
    $format = preg_replace('#(?<!%)((?:%%)*)%e#', '\1%#d', $format);
  }
  if ($time==-1)
  {
    $time=time();
  }	
  
  if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN') {  
    return TextFormat(strftime($format,$time));
  }
  else
  {
    return strftime($format,$time);
  }
}


// PHP < 5.5.0
/*******************  FUNCTION  ***********************************************
NAME:             
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
if (!function_exists('array_column')) {
    function array_column($input, $column_key, $index_key = null)
    {
        if ($index_key !== null) {
            // Collect the keys
            $keys = array();
            $i = 0; // Counter for numerical keys when key does not exist
           
            foreach ($input as $row) {
                if (array_key_exists($index_key, $row)) {
                    // Update counter for numerical keys
                    if (is_numeric($row[$index_key]) || is_bool($row[$index_key])) {
                        $i = max($i, (int) $row[$index_key] + 1);
                    }
                   
                    // Get the key from a single column of the array
                    $keys[] = $row[$index_key];
                } else {
                    // The key does not exist, use numerical indexing
                    $keys[] = $i++;
                }
            }
        }
       
        if ($column_key !== null) {
            // Collect the values
            $values = array();
            $i = 0; // Counter for removing keys
           
            foreach ($input as $row) {
                if (array_key_exists($column_key, $row)) {
                    // Get the values from a single column of the input array
                    $values[] = $row[$column_key];
                    $i++;
                } elseif (isset($keys)) {
                    // Values does not exist, also drop the key for it
                    array_splice($keys, $i, 1);
                }
            }
        } else {
            // Get the full arrays
            $values = array_values($input);
        }
       
        if ($index_key !== null) {
            return array_combine($keys, $values);
        }
       
        return $values;
    }
}

/*******************  FUNCTION  ***********************************************
NAME:             
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function getServerURL()
{
 $pageURL= getServerROOT();
 $app=substr($_SERVER['PHP_SELF'],0,strrpos($_SERVER['PHP_SELF'],'/'));
 return $pageURL.$app;    
}

/*******************  FUNCTION  ***********************************************
NAME:             
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function getAppPath()
{
  $result=$_SERVER['DOCUMENT_ROOT'].substr($_SERVER['SCRIPT_NAME'],0,strpos($_SERVER['SCRIPT_NAME'],'/',1));
  return $result;
}

/*******************  FUNCTION  ***********************************************
NAME:             
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function getServerROOT()
{
  $pageURL = 'http';  
  if (isset($_SERVER["HTTPS"]))
  {
    if ($_SERVER["HTTPS"]=='on')
    {
      $pageURL = 'https';
    }
  }
  $pageURL .= "://";
  if ($_SERVER["SERVER_PORT"] != "80") 
  {
    $pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"];
  } 
  else 
  {
    $pageURL .= $_SERVER["SERVER_NAME"];
  }
  return $pageURL;    
}


/*******************  FUNCTION  ***********************************************
NAME:             
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function stripAccents($string)
{
  return strtr($string,'',
                       'aaaaaceeeeiiiinooooouuuuyyAAAAACEEEEIIIINOOOOOUUUUY');
}

/*******************  FUNCTION  ***********************************************
NAME:             
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function stripSpaces($string)
{
  return strtr($string," ()'/\\",
                       "-__-__");
}

/*******************  FUNCTION  ***********************************************
NAME:             
OBJECT:  
IN:
- $   -> 
OUT: the result
*******************************************************************************/
function upload_multiple_file($file,$file_dir="user_files",$postitId,$postitType) 
{
  $cnx=new connexion_db();  
  // init var  
  $overwrite=0;
  $max_file_size_check=0;
  $max_file_size = 1024*1024*getParameter('SIZMAX', $cnx->num);

  // get allowed file types
  $allowed_file_type=explode(',',getParameter('FLEXT', $cnx->num));

  // check format for each file
  foreach($_FILES['files']['name'] as $fkey=> $fname)
  {
    $ext = strtolower(pathinfo($fname, PATHINFO_EXTENSION));
    if (!in_array($ext, $allowed_file_type)) 
    {
      // if one file type is KO, break the loading and send back a message  
      return "FORMAT_KO!".implode(', ',$allowed_file_type);
      break;
    }
  }
  reset($_FILES['files']['name']);
  // add history items
  $history=new history($cnx->num);  
 
  // analyse each file
  foreach($_FILES['files']['tmp_name'] as $key => $tmp_name )
  {
    // get vars from global $_FILES var
    $file_name = $_FILES['files']['name'][$key];
    $file_size =$_FILES['files']['size'][$key];
    $file_tmp_name =$_FILES['files']['tmp_name'][$key];
    $file_type=$_FILES['files']['type'][$key];
 
    // if file size must be checked
    if($max_file_size_check < 1) 
    {
      // if file size is bigger than the limit  
      if($file_size > $max_file_size)
      {
        // compute readable max file size in Mo  
        $fsize=$max_file_size/1048576;
        // send message KO back
        return 'SIZE_KO!'.$fsize;
        break;
      }
    }
 
    // check if dir is OK
    if(is_dir($file_dir)==false)
    {
      // if not create it  
      $status =  mkdir("$file_dir", 0700);
      // create an index file
      copy($file_dir.'../../tpl/index_tpl.php',$file_dir.'index.php');
      copy($file_dir.'../../tpl/.htaccess',$file_dir.'.htaccess');
      if($status < 1)
      {
        // if creation is KO, send back a message  
        return "DIRECTORY_KO!".$file_dir;
      }
    }
 
    // if dir is OK
    if(is_dir($file_dir))
    {
      // allow overwrite  
      if($overwrite < 1)
      {
        // save file  
        move_uploaded_file($file_tmp_name,"$file_dir/".$file_name);
        // add item in history
        $history->addPostitHistory($postitType,$postitId,'attachment_added','',$file_name,$_SESSION['login']);
      }
    }
  }
  return "Success";
}


function createThumb($pathToImage,$type, $thumbHeight)
{
      //Load image and size
      switch($type)
      {
        case 'jpeg':  
        case 'jpg':
          $img = imagecreatefromjpeg($pathToImage);
        break;
    
        case 'png':
          $img = imagecreatefrompng($pathToImage);
        break;

        case 'gif':
          $img = imagecreatefromgif($pathToImage);
        break;    

        default: 
        break;    
      }
      $width = imagesx($img);
      $height = imagesy($img);

      //Calculate the size of thumb
      $new_width = floor($width * ($thumbHeight / $height)); 
      $new_height = $thumbHeight;//$thumbHeight

      //Make the new thumb
      $tmp_img = imagecreatetruecolor($new_width, $new_height);

      //Copy the old image and calculate the size
      imagecopyresized($tmp_img, $img, 0, 0, 0, 0, $new_width, $new_height, $width, $height);
      // sets the header and creates the temporary thumbnail
      // ideal for ajax requests / <img> elements
      header("Content-type: image/jpeg");
      imagejpeg($tmp_img);

      return true;

}


function isPassValid($pwd,$size=true,$number=true,$letter=true,$caps=true,$symbol=true)
{
  $errors=array();
  // minimum size
  if( strlen($pwd) < 8 && $size) 
  {
    $errors[]= 'SHORT';
  }
  // at least one number
  if( !preg_match("#[0-9]+#", $pwd) && $number) 
  {
    $errors[]= 'NUMBER';
  } 
  // ate least one letter
  if( !preg_match("#[a-z]+#", $pwd) && $letter) 
  {
    $errors[]= 'LETTER';
  }
  // at least one CAP
  if( !preg_match("#[A-Z]+#", $pwd) && $caps) 
  {
    $errors[]= 'CAPS';
  }
  // at least one symbol
  if( !preg_match("#\W+#", $pwd) && $symbol) 
  {
    $errors[]= 'SYMBOL';
  }
  return $errors;
}

?>