<?php 
/**
 * Deck Management
 *
 * PHP version 5
 *
 * @category Scripts
 * @package  DeckManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  
define("PATHBASE",'./');
$pathClasses=PATHBASE.'libraries/classes/';
$pathCommons=PATHBASE.'common_scripts/';  
$pathAppClasses=PATHBASE.'classes/';
$pathImages=PATHBASE.'images/';

$targetFile='';

if (!isset($_REQUEST['action']))
{
  $_REQUEST['action']='';  
}

require_once PATHBASE.'popin_includes_presession.php';?>
  <html>
    <head>
       
    </head>
    <body><?php    
    
if (isset($_SESSION['login']))
{
  require_once PATHBASE.'popin_includes.php';
  require_once $pathClasses.'class_sortColumn.php';
  require_once $pathCommons.'date_hour.php';
  require_once $pathAppClasses.'project.php';

  $itemType='tasks_sprint';
  $masterItemType=getMasterItemType($itemType);
  $simpleItemType=getSimpleItemType($itemType);
  $usFieldForOrderMatrix=PARAM_DB_PREFIX.'kados_user_stories.ypos_s';  
  $firstColumnDisplayParentZone=true;
  $firstColumnDisplayWarningZone=true;
  $firstColumnTitle=$text_sprint_backlog;
  $firstColumnObjectTag='US';
  $firstColumnFunctionForHeaderStamp='displayStatusImageButton';  
  $firstColumnObjectTag='US';
  include PATHBASE.'boards_settings/settings_'.$itemType.'.php';  
  
  /* Dashboard settings */
  include PATHBASE.'dashboard_settings.php';  
  
  // get current project Data
  $currentProject=new project($cnx->num,$_SESSION['current_project_id']);
  $currentProject->getData();
  //require PATHBASE.'postit_attachments_create.php';
  


/****************************** DECK basic actions ***********************************/
// Add to DECK
if (isset($_REQUEST['add_to_deck']))
{
  if (!array_search((int)$_REQUEST['add_to_deck'],$_SESSION['us_deck_content']))
  {
    array_push($_SESSION['us_deck_content'],(int)$_REQUEST['add_to_deck']);
    // Add US to the deck storage of the user
    $request->sqlGet("INSERT INTO ".PARAM_DB_PREFIX."kados_users_decks 
                     (user_login_fk,item_id_fk,item_type)
                     VALUES ('".$_SESSION['login']."',".($_REQUEST['add_to_deck']).",'us')");
  }	
}
// Remove from DECK
if (isset($_REQUEST['remove_from_deck']))
{
  $pos=array_search((int)$_REQUEST['remove_from_deck'],$_SESSION['us_deck_content']);
  if ($pos>0)
  {
    unset($_SESSION['us_deck_content'][$pos]);
   // Delete US in the deck storage of the user 
   $request->sqlGet("DELETE FROM ".PARAM_DB_PREFIX."kados_users_decks 
                    WHERE user_login_fk='".$_SESSION['login']."' 
                      AND item_type='us' 
                      AND item_id_fk=".$_REQUEST['remove_from_deck']);
  }	
}


/****************** Action for keeping US with my tasks **********************************/
// Filter on the US with my tasks = put all US without a task for me in the DECK/
// Set scope
$scope=' us_project_id_fk='.$_SESSION['current_project_id'];
if (isset($_SESSION['current_sprint_id']))
{
  $scope=' us_sprint_id_fk='.$_SESSION['current_sprint_id'];
}
else if (isset($_SESSION['current_release_id']))
{
  $scope=' us_release_id_fk='.$_SESSION['current_release_id'];
}


// Empty DECK
if (isset($_REQUEST['empty_deck']))
{
    // get US in the deck for the sprint and user
    $request->sqlGet("SELECT item_id_fk FROM ".PARAM_DB_PREFIX."kados_users_decks 
                     WHERE user_login_fk='".$_SESSION['login']."' 
                       AND item_type='us' 
                       AND item_id_fk IN(SELECT us_id FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE ".$scope.")");
    $usToDeleteFromDeck=$request->getArrayFirstFieldOnly();    
    // Remove US from the deck (session)
    for ($k=0;$k<count($usToDeleteFromDeck);$k++)
    {
      $pos=array_search($usToDeleteFromDeck[$k],$_SESSION['us_deck_content']);
      if ($pos>0)
      {
        unset($_SESSION['us_deck_content'][$pos]);
      }
    }
    // remove from deck in Database
    $request->sqlGet("DELETE FROM ".PARAM_DB_PREFIX."kados_users_decks 
                     WHERE user_login_fk='".$_SESSION['login']."' 
                       AND item_type='us' 
                       AND item_id_fk IN(SELECT us_id FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE ".$scope.")");
}

// Fill DECK with all US
if (isset($_REQUEST['fill_deck']))
{
  // 1/Empty the DECK for that scope
  // get US in the deck for the scope
  $request->sqlGet("SELECT item_id_fk FROM ".PARAM_DB_PREFIX."kados_users_decks 
                   WHERE user_login_fk='".$_SESSION['login']."' 
                     AND item_type='us' 
                     AND item_id_fk IN(SELECT us_id FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE ".$scope.")");
  $usToDeleteFromDeck=$request->getArrayFirstFieldOnly();    
  for ($k=0;$k<count($usToDeleteFromDeck);$k++)
  {
    $pos=array_search($usToDeleteFromDeck[$k],$_SESSION['us_deck_content']);
    if ($pos>0)
    {
      unset($_SESSION['us_deck_content'][$pos]);
    }
  }
  // remove from deck in Database
  $request->sqlGet("DELETE FROM ".PARAM_DB_PREFIX."kados_users_decks 
                   WHERE user_login_fk='".$_SESSION['login']."' 
                     AND item_type='us' 
                     AND item_id_fk IN(SELECT us_id FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE ".$scope.")");

  // 2/put all US in DECK
  // Find US 
  // put on deck
  $request->sqlGet("SELECT us_id FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE ".$scope);
  $request->getArrayFirstFieldOnly();
  // then put US in the deck (session and DB)
  for($i=0;$i<$request->rowCount;$i++)
  {
    array_push($_SESSION['us_deck_content'],(int)$request->array[$i]);
    // Add US to the deck storage of the user
    $request->sqlGet("INSERT INTO ".PARAM_DB_PREFIX."kados_users_decks 
	               (user_login_fk,item_id_fk,item_type)
			       VALUES ('".$_SESSION['login']."',".($request->array[$i]).",'us')");
  }
}

// Put in deck US where user has no task
if ($_REQUEST['action']=='filter_my_tasks')
{
  // 1/Empty the DECK for that scope
  // get US in the deck for the scope
  $request->sqlGet("SELECT item_id_fk FROM ".PARAM_DB_PREFIX."kados_users_decks 
                   WHERE user_login_fk='".$_SESSION['login']."' 
                     AND item_type='us' 
                     AND item_id_fk IN(SELECT us_id FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE ".$scope.")");
  $usToDeleteFromDeck=$request->getArrayFirstFieldOnly();    
  for ($k=0;$k<count($usToDeleteFromDeck);$k++)
  {
    $pos=array_search($usToDeleteFromDeck[$k],$_SESSION['us_deck_content']);
    if ($pos>0)
    {
      unset($_SESSION['us_deck_content'][$pos]);
    }
  }
  // remove from deck in Database
  $request->sqlGet("DELETE FROM ".PARAM_DB_PREFIX."kados_users_decks 
                   WHERE user_login_fk='".$_SESSION['login']."' 
                     AND item_type='us' 
                     AND item_id_fk IN(SELECT us_id FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE ".$scope.")");

  // 2/put US without me in DECK
  // Find US without me allocated to tasks
  // put on deck
  $request->sqlGet("SELECT us_id FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE ".$scope." AND us_id NOT IN (
                   SELECT us_id_fk FROM ".PARAM_DB_PREFIX."kados_user_stories,".PARAM_DB_PREFIX."kados_tasks 
                   WHERE ".$scope." AND us_id_fk=us_id AND ".PARAM_DB_PREFIX."kados_user_stories.active=1 
				       AND task_leader='".$_SESSION['login']."' AND ".PARAM_DB_PREFIX."kados_tasks.active=1)");
  $request->getArrayFirstFieldOnly();
  // then put US in the deck (session and DB)
  for($i=0;$i<$request->rowCount;$i++)
  {
    array_push($_SESSION['us_deck_content'],(int)$request->array[$i]);
    // Add US to the deck storage of the user
    $request->sqlGet("INSERT INTO ".PARAM_DB_PREFIX."kados_users_decks 
	               (user_login_fk,item_id_fk,item_type)
			       VALUES ('".$_SESSION['login']."',".($request->array[$i]).",'us')");
  }
}  

include_once $pathCommons.'filter_us_compute.php';

 // Get US of the sprint in deck
if ($flagJoinTasks)
{
  $request=new sqlRequest("SELECT us_id AS parent_id,us_number AS display_number,".PARAM_DB_PREFIX."kados_user_stories.text,".PARAM_DB_PREFIX."kados_user_stories.status AS header_stamp,".PARAM_DB_PREFIX."kados_user_stories.color,business_value AS infoBottomLeft,
                               complexity AS infoBottomRight 
                        FROM ".PARAM_DB_PREFIX."kados_user_stories,".PARAM_DB_PREFIX."kados_tasks  
	                WHERE ".PARAM_DB_PREFIX."kados_user_stories.active=1 AND ".$scope." 
                          AND ".PARAM_DB_PREFIX."kados_tasks.active=1                               
                          AND us_id_fk=us_id   
			  AND us_id IN (".implode(',',$_SESSION['us_deck_content']).") ".$clauseWhereUsFilter." 
                        GROUP BY us_id_fk       
			ORDER BY ".$usFieldForOrderMatrix." ASC",$cnx->num);    
} 
else
{
  $request=new sqlRequest("SELECT us_id AS parent_id,us_number AS display_number,text,status AS header_stamp,color,business_value AS infoBottomLeft,
                               complexity AS infoBottomRight 
                        FROM ".PARAM_DB_PREFIX."kados_user_stories 
	                WHERE active=1 AND ".$scope." 
			  AND us_id IN (".implode(',',$_SESSION['us_deck_content']).") ".$clauseWhereUsFilter." 
			ORDER BY ".$usFieldForOrderMatrix." ASC",$cnx->num);
}  
$deckItemsArray=$request->getArrayFields();

if (count($deckItemsArray)==0)
{
  echo $text_deck_is_empty;
}
else
{
for ($k=0;$k<count($deckItemsArray);$k++)
{?>
      <div id="note_deck<?php echo $deckItemsArray[$k]['parent_id'];?>" class="note_deck <?php echo $deckItemsArray[$k]['color'];?>" style="width:<?php echo $itemWidth;?>px;" >
          <span class="data"><?php echo $deckItemsArray[$k]['parent_id'];?></span>
	     <div class="item-header" >
		  <span class="deck_header-left"><a href="<?php echo $targetFileAction.'&remove_from_deck='.$deckItemsArray[$k]['parent_id'];?>" ><img src="<?php echo $pathImages.'app/plus_grey.png';?>" border="0"></a></span>
		  <span class="deck_postit_id"><?php echo $firstColumnObjectTag.$deckItemsArray[$k]['display_number'];?></span>
		  <span class="deck_postit_header-right"><?php 
		    if (isset($firstColumnFunctionForHeaderStamp))
			{
		      call_user_func($firstColumnFunctionForHeaderStamp,array($deckItemsArray[$k]['parent_id'],$deckItemsArray[$k]['header_stamp'],false,'')); 
			}
            else
            {
              echo htmlspecialchars($deckItemsArray[$k]['header_stamp']);
            }?></span>	
            <span class="clearright"></span>
		 </div>
		 <div class="deck_postit_text" style="width:<?php echo ($itemWidth-$itemWidthBodyMargin);?>px;height:<?php echo ($itemHeight-$itemHeightBodyMargin);?>px;"><?php echo make_clickable(nl2br(htmlspecialchars($deckItemsArray[$k]['text'])));?></div>
	     <div class="deck_item-footer">
		    <span class="deck_postit_footer-left"><?php 
			if (isset($deckItemsArray[$k]['infoBottomLeft']))
			{
		      if (isset($firstColumnFunctionForBottomLeft)) 
			  { 
			    call_user_func($firstColumnFunctionForBottomLeft,$deckItemsArray[$k]['infoBottomLeft']);
			  }
			  else
			  {
			    echo $deckItemsArray[$k]['infoBottomLeft'];
			  }
			} ?>
			</span>
		    <span class="deck_postit_footer-right"><?php 
		  	if (isset($deckItemsArray[$k]['infoBottomRight']))
			{
		      if (isset($firstColumnFunctionForBottomRight)) 
			  { 
			    call_user_func($firstColumnFunctionForBottomRight,$deckItemsArray[$k]['infoBottomRight']);
			  }
			  else
			  {
			    echo $deckItemsArray[$k]['infoBottomRight'];
			  }
			} ?>				
			</span>
		 </div>	
                 
	  </div><?php
	}

}?>
        <script>
        	$('.deck_postit_text').each(function(){
	   var text='#note_deck'+$(this).parent().find('span.data').text();
	   $(this).resizable({
		 alsoResize: text
	  });
	});  
        </script><?php
}?>
  </body>
   </html>