<?php
/**
 * Script to get data to export
 *
 * @category Exports
 * @package  getData
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  http://www.php.net/license/3_01.txt  PHP License 3.01
 * */

// get project, release and sprint data
if ($_REQUEST['sprint_id']!=0)
{    
  $request=new sqlRequest("SELECT project_name,release_name,sprint_name 
                        FROM ".PARAM_DB_PREFIX."kados_projects,".PARAM_DB_PREFIX."kados_releases,".PARAM_DB_PREFIX."kados_sprints
                        WHERE sprint_id=".$_REQUEST['sprint_id']." AND sprint_release_id_fk=release_id 
                          AND release_project_id_fk=project_id",$cnx->num);
  $minimumScope='sprint';
}
else if ($_REQUEST['release_id']!=0)
{    
  $request=new sqlRequest("SELECT project_name,release_name, '' AS sprint_name  
                        FROM ".PARAM_DB_PREFIX."kados_projects,".PARAM_DB_PREFIX."kados_releases
                        WHERE release_id=".$_REQUEST['release_id']." AND release_project_id_fk=project_id",$cnx->num);
  $minimumScope='release';
}    
else
{    
  $request=new sqlRequest("SELECT project_name, '' AS release_name, '' AS sprint_name 
                        FROM ".PARAM_DB_PREFIX."kados_projects
                        WHERE project_id=".$_REQUEST['project_id'],$cnx->num);
  $minimumScope='project';
}    
$projectData=$request->getObject();

// Get colors of Tasks and US that must be in the export
$request->sqlGet("SELECT color_id FROM ".PARAM_DB_PREFIX."kados_colors");	  	     
$colorList=$request->getArrayFirstFieldOnly();
	
// get list of tasks and US types (colors) selected
// init array for tasks
$tasksIn=array();
// init array for US
$usIn=array();
for ($i=0;$i<count($colorList);$i++)	  
{
  // put color in the array if checkbox was selected  
  if (isset($_POST['choose_color_task_'.$colorList[$i]]))
  {
    $tasksIn[]=$colorList[$i];
  }	    
  // put color in the array if checkbox was selected  
  if (isset($_POST['choose_color_us_'.$colorList[$i]]))
  {
    $usIn[]=$colorList[$i];
  }	    
}  

// Get filter status for US
// init array with US status
$usStandardStatus=array('todo','run','dev','done');
$usStatusFilter=array();
for ($i=0;$i<count($usStandardStatus);$i++)
{
  // if status was selected by user, add in the array  
  if (isset($_POST['choose_status_us_'.$usStandardStatus[$i]]))
  {
    $usStatusFilter[]=strtoupper($usStandardStatus[$i]);
  }
} 

// filters tasks on status
// get status tag (column tag)
$request->sqlGet("SELECT column_tag 
                 FROM ".PARAM_DB_PREFIX."kados_template_columns,".PARAM_DB_PREFIX."kados_projects_columns 
                 WHERE column_tag=column_tag_fk AND project_id_fk=".$_REQUEST['project_id']);
$request->getArrayFirstFieldOnly();
// init array for values
$taskStatusList=array();
for ($i=0;$i<count($request->array);$i++)
{
  // if status was selected by user, add in the array  
  if (isset($_POST['choose_status_task_'.$request->array[$i]]))
  {
    $taskStatusList[]=$request->array[$i];
  }
} 

// init lists for tasks and US
$listUs=array();
$listTasks=array();

if (count($usIn)!=0)
{    
  // Get US and tasks for the selected scope
  $request->sqlGet("SELECT * 
                   FROM ".PARAM_DB_PREFIX."kados_user_stories LEFT JOIN 
                         ((SELECT color_id,color_name,use_color_default  AS color_default,
	                       use_color_meaning AS object_color_meaning ,color_value  
                           FROM ".PARAM_DB_PREFIX."kados_colors_uses,".PARAM_DB_PREFIX."kados_colors 
			   WHERE use_color_postit_type='US' AND color=color_name 
                                 AND use_color_lock=1)
			    UNION
			    (SELECT color_id,color_name,object_color_default AS color_default,
                                    object_color_meaning ,color_value  
			     FROM ".PARAM_DB_PREFIX."kados_projects_colors,".PARAM_DB_PREFIX."kados_colors 
			     WHERE project_id_fk=".$_REQUEST['project_id']." 
		 	       AND color_id_fk=color_id 
			      AND object_type='US')) ".PARAM_DB_PREFIX."kados_colors_all ON color=color_name  
                   WHERE active=1 AND color_id IN(".implode(',',$usIn).")
                     AND us_".$minimumScope."_id_fk=".$_REQUEST[$minimumScope.'_id']);
  $request->getArrayFields();
  
  // Select if US should be displayed in export regarding its status.
  // init vars, one for US
  $listUs=array();
  // one for US id
  $listUSid=array();
  // one for releases ID
  $listReleases=array();
  // one for sprints ID
  $listSprints=array();
  // one for release constitution
  $usTree=array();
  
  // populate listUS
  for ($i=0;$i<count($request->array);$i++)
  {
    // get detailed status for the US
    $detailedStatus=$request->array[$i]['status'];
    if (in_array($detailedStatus,$usStatusFilter))
    {
      // If status is in the selected one (by user), put it in the US list  
      $request->array[$i]['detailed_status']=$detailedStatus;   
      $listUs[$request->array[$i]['us_id']]=$request->array[$i];
      // If release of US is not recorded, record it in the releases list
      if ($useHierarchy)
      {    
        if (!in_array($request->array[$i]['us_release_id_fk'],$listReleases))
        {
          $listReleases[]=$request->array[$i]['us_release_id_fk'];  
        }
        // populate a tree of US by Release and sprint
        $usTree[$request->array[$i]['us_release_id_fk']][$request->array[$i]['us_sprint_id_fk']][]=$request->array[$i]['us_id'];
        // same process for sprints
        if (!in_array($request->array[$i]['us_sprint_id_fk'],$listSprints))
        {
          $listSprints[]=$request->array[$i]['us_sprint_id_fk'];  
        }
      }  
    }
  }

  // Get tasks
  if (count($tasksIn)!=0 && count($taskStatusList)!=0)
  {
    // If at least one task type and one task status are selected, get tasks
    $request->sqlGet("SELECT us_id_fk,task_number,text,color_value,object_color_meaning,
                            column_name,status,task_init_load,task_done,task_raf 
                     FROM ".PARAM_DB_PREFIX."kados_template_columns,".PARAM_DB_PREFIX."kados_tasks LEFT JOIN
                         ((SELECT color_id,color_name,use_color_default  AS color_default,
	                       use_color_meaning AS object_color_meaning,color_value  
                           FROM ".PARAM_DB_PREFIX."kados_colors_uses,".PARAM_DB_PREFIX."kados_colors 
			   WHERE use_color_postit_type='TASK' AND color=color_name 
                                 AND use_color_lock=1)
			    UNION
			    (SELECT color_id,color_name,object_color_default AS color_default,
                                    object_color_meaning,color_value  
			     FROM ".PARAM_DB_PREFIX."kados_projects_colors,".PARAM_DB_PREFIX."kados_colors 
			     WHERE project_id_fk=".$_REQUEST['project_id']." 
		 	       AND color_id_fk=color_id 
			      AND object_type='TASK')) ".PARAM_DB_PREFIX."kados_colors_all ON color=color_name
                     WHERE active=1 AND status=column_tag 
                       AND color_id IN(".implode(',',$tasksIn).")
                       AND status IN('".implode("','",$taskStatusList)."')
                       AND us_id_fk IN (SELECT us_id 
                                        FROM ".PARAM_DB_PREFIX."kados_user_stories 
                                        WHERE us_".$minimumScope."_id_fk=".$_REQUEST[$minimumScope.'_id'].")");
    $listTasks=$request->getArrayFieldsGroup('us_id_fk');
  }  
}  

// Special treatment is hierarchy (releases and sprints) must be displayed
if ($useHierarchy)
{   
  // Get Releases
  $releases=array();
  if (count($listReleases)!=0)
  {
    $request->sqlGet("SELECT release_id,release_name,release_due_date 
                     FROM ".PARAM_DB_PREFIX."kados_releases 
                     WHERE release_id IN(".implode(',',$listReleases).") 
                     ORDER BY release_due_date");
    $releases=$request->getArrayFields();
    // delete releases ID list, no more useful
    unset($listReleases);
  }
  // get Sprints
  $sprints=array();
  if (count($listSprints)!=0)
  {
    $request->sqlGet("SELECT sprint_release_id_fk,sprint_id,sprint_name  
                     FROM ".PARAM_DB_PREFIX."kados_sprints 
                     WHERE sprint_id IN(".implode(',',$listSprints).") 
                     ORDER BY sprint_end_date");
    $sprints=$request->getArrayFieldsGroup('sprint_release_id_fk');
    // delete sprints ID list, no more useful
    unset($listSprints);
  }
}
?>
