<?php
/**
 * Display at the top of some board the tags filter
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  

if (($tagFilterItem=='us' || $tagFilterItem=='task') && ($simpleItemType=='us' || $simpleItemType=='task') && $showFilterTags && $currentProject->paramUseTags)
{
  $textItem='text_'.$tagFilterItem;   
    
/****************************** TAG FILTER basic actions ***********************************/
  $wkf=new workflow('TAG',PARAM_DB_PREFIX.'framework_workflows',PARAM_DB_PREFIX.'framework_status',PARAM_DB_PREFIX.'framework_workflows_transitions',$_SESSION['language'],PATHBASE);
    
  $request=new sqlRequest("(SELECT tag_id,tag_label,tag_color 
                         FROM ".PARAM_DB_PREFIX."kados_tags 
                         WHERE tag_type='ALL_MAND' 
                           AND tag_status_id_fk=".$wkf->id_etat_from_label('TAGACT')."
                           AND LOWER(tag_postit_type)='".$tagFilterItem."') 
                        UNION 
                        (SELECT tag_id,tag_label,tag_color 
                         FROM ".PARAM_DB_PREFIX."kados_tags,".PARAM_DB_PREFIX."kados_tags_projects 
                         WHERE tag_type IN('ALL_FREE','USR_FREE') 
                           AND tag_status_id_fk=".$wkf->id_etat_from_label('TAGACT')." 
                           AND LOWER(tag_postit_type)='".$tagFilterItem."'     
                           AND tag_id_fk=tag_id 
                           AND project_id_fk=".$_SESSION['current_project_id'].")",$cnx->num);	  
  $tagsList=$request->getArrayFields();

  // create two filters clause and add them to the global clause var
  if (isset($_SESSION['tag_filter_plus_'.$tagFilterItem]) && $tagFilterItem==$simpleItemType)
  {
    if (count($_SESSION['tag_filter_plus_'.$tagFilterItem])>1)  
    {   
      $addClauseTag='';
      // check if any filtered tag  is for US or Tasks
      $request->sqlGet("SELECT tag_id 
                        FROM ".PARAM_DB_PREFIX."kados_tags 
                        WHERE LOWER(tag_postit_type)='".$tagFilterItem."' 
                          AND tag_id IN(".implode(',',$_SESSION['tag_filter_plus_'.$tagFilterItem]).")");
      // if there is some US related tag in filter, set clause
      if ($request->countRows()!=0)
      {   
        // switch between task and US  
        if ($tagFilterItem=='us')  
        {
          // get related tags and build the clause            
          $addClauseTag=" AND us_id IN(SELECT postit_id_fk 
                                       FROM ".PARAM_DB_PREFIX."kados_tags_postit,".PARAM_DB_PREFIX."kados_user_stories 
                                       WHERE postit_type='US' 
                                         AND tag_id_fk IN(".implode(',',$request->getArrayFirstFieldOnly()).") 
                                         AND postit_id_fk=us_id 
                                         AND us_project_id_fk=".$_SESSION['current_project_id'].") ";  
        }  
        else if ($tagFilterItem=='task')
        {
          $addClauseTag=" AND task_id IN(SELECT postit_id_fk 
                                         FROM ".PARAM_DB_PREFIX."kados_tags_postit,".PARAM_DB_PREFIX."kados_user_stories,".PARAM_DB_PREFIX."kados_tasks 
                                         WHERE postit_type='TASK' 
                                           AND tag_id_fk IN(".implode(',',$request->getArrayFirstFieldOnly()).") 
                                           AND postit_id_fk=task_id AND us_id=us_id_fk 
                                           AND us_project_id_fk=".$_SESSION['current_project_id'].") ";  
        }    
      }  
      $clauseWhereElements.=$addClauseTag;
      $clauseWhereElementsGetAll.=$addClauseTag;
    }  
  } 
  
  if (isset($_SESSION['tag_filter_minus_'.$tagFilterItem]) && $tagFilterItem==$simpleItemType)
  {
    if (count($_SESSION['tag_filter_minus_'.$tagFilterItem])>1)  
    {   
      $addClauseTag='';
      // check if any filtered tag  is for US or Tasks
      $request->sqlGet("SELECT tag_id 
                        FROM ".PARAM_DB_PREFIX."kados_tags 
                        WHERE LOWER(tag_postit_type)='".$tagFilterItem."' 
                          AND tag_id IN(".implode(',',$_SESSION['tag_filter_minus_'.$tagFilterItem]).")");
      // if there is some US related tag in filter, set clause
      if ($request->countRows()!=0)
      {         
        if ($tagFilterItem=='us')  
        {
          $addClauseTag=" AND us_id NOT IN(SELECT postit_id_fk 
                                       FROM ".PARAM_DB_PREFIX."kados_tags_postit,".PARAM_DB_PREFIX."kados_user_stories  
                                       WHERE postit_type='US' 
                                         AND tag_id_fk IN(".implode(',',$request->getArrayFirstFieldOnly()).") 
                                         AND postit_id_fk=us_id 
                                         AND us_project_id_fk=".$_SESSION['current_project_id'].") ";  
        }
        else if ($tagFilterItem=='task')
        {
          $addClauseTag=" AND task_id NOT IN(SELECT postit_id_fk 
                                       FROM ".PARAM_DB_PREFIX."kados_tags_postit,".PARAM_DB_PREFIX."kados_user_stories,".PARAM_DB_PREFIX."kados_tasks   
                                       WHERE postit_type='TASK' 
                                         AND tag_id_fk IN(".implode(',',$request->getArrayFirstFieldOnly()).") 
                                         AND postit_id_fk=task_id AND us_id=us_id_fk 
                                         AND us_project_id_fk=".$_SESSION['current_project_id'].") ";  
        }    
      } 
      $clauseWhereElements.=$addClauseTag;
      $clauseWhereElementsGetAll.=$addClauseTag;
    }  
  }  
  // init list of tags for filtering list
  $listTagsAvailableInFilterPlus=array();
  $listTagsAvailableInFilterMinus=array();
  // init counters
  $cpt1=0;
  $cpt2=0;
  // build list for list box
  for ($i=0;$i<count($tagsList);$i++)
  {
    // for filter plus  
    if(!(array_search($tagsList[$i]['tag_id'],$_SESSION['tag_filter_plus_'.$tagFilterItem])>0))
    {
      // set id and label  
      $listTagsAvailableInFilterPlus[$cpt1]['tag_id']=$tagsList[$i]['tag_id'];
      $listTagsAvailableInFilterPlus[$cpt1++]['tag_label']=$tagsList[$i]['tag_label'];
    }
    // for filter minus
    if(!(array_search($tagsList[$i]['tag_id'],$_SESSION['tag_filter_minus_'.$tagFilterItem])>0))
    {
      // set id and label  
      $listTagsAvailableInFilterMinus[$cpt2]['tag_id']=$tagsList[$i]['tag_id'];
      $listTagsAvailableInFilterMinus[$cpt2++]['tag_label']=$tagsList[$i]['tag_label'];
    }
  }?>  
<div class="tagBlockFilter <?php if (count($_SESSION['tag_filter_plus_'.$tagFilterItem])>1) { echo 'activeFilter';}?>" style="margin-right:5px;">
<form name="tags_filter_plus_<?php echo $tagFilterItem;?>_form" id="tags_filter_form" style="float:left" method="post" action="<?php echo $targetFileAction;?>" enctype="multipart/form-data">   
 <input type="hidden" name="action" value="filter_add_to_tag_plus" />
 <input type="hidden" name="tag_filter_item" value="<?php echo $tagFilterItem;?>" />
<select name="add_to_tag_filter" class="filter_select" style="font-size:8pt; color:grey;font-style:italic" onChange="javascript:document.tags_filter_plus_<?php echo $tagFilterItem;?>_form.submit();">
    <option value="" style="display:none"><?php echo $$textItem.' : '.$text_tag_filter_plus;?></option>   <?php
    // display available tags for filter in listbox
    for($i=0;$i<count($listTagsAvailableInFilterPlus);$i++)
    {?>
      <option value="<?php echo $listTagsAvailableInFilterPlus[$i]['tag_id'];?>"> <?php echo $listTagsAvailableInFilterPlus[$i]['tag_label'];?></option><?php  
    } ?>
   </select> 
</form> 
</div>    <?php
  for ($i=0;$i<count($tagsList);$i++)
  {
    if (array_search($tagsList[$i]['tag_id'],$_SESSION['tag_filter_plus_'.$tagFilterItem])>0)
    {?>
      <div class="tag-filter <?php echo $tagsList[$i]['tag_color'];?>"><?php echo $tagsList[$i]['tag_label'];?>
          <a href="<?php echo $targetFileAction;?>&remove_from_tag_filter=<?php echo $tagsList[$i]['tag_id'];?>&filter_type=plus&tag_filter_item=<?php echo $tagFilterItem;?>"><img border="0" src="<?php echo $pathImages;?>app/delete.png"></a> 
      </div> <?php
    } 
  }?>
<div class="tagBlockFilter <?php if (count($_SESSION['tag_filter_minus_'.$tagFilterItem])>1) { echo 'activeFilter';}?>" style="margin-right:5px;">
<form name="tags_filter_minus_<?php echo $tagFilterItem;?>_form" id="tags_filter_form" style="float:left" method="post" action="<?php echo $targetFileAction;?>" enctype="multipart/form-data">   
<input type="hidden" name="action" value="filter_add_to_tag_minus" />
<input type="hidden" name="tag_filter_item" value="<?php echo $tagFilterItem;?>" />
<select name="add_to_tag_filter" class="filter_select" style="font-size:8pt; color:grey;font-style:italic" onChange="javascript:document.tags_filter_minus_<?php echo $tagFilterItem;?>_form.submit();">
    <option value="" style="display:none"><?php echo $$textItem.' : '.$text_tag_filter_minus;?></option>   <?php
    // display available tags for filter in listbox
    for($i=0;$i<count($listTagsAvailableInFilterMinus);$i++)
    {?>
      <option value="<?php echo $listTagsAvailableInFilterMinus[$i]['tag_id'];?>"> <?php echo $listTagsAvailableInFilterMinus[$i]['tag_label'];?></option><?php  
    } ?>
   </select> 
</form> 
</div> <?php
  
  for ($i=0;$i<count($tagsList);$i++)
  {
    if (array_search($tagsList[$i]['tag_id'],$_SESSION['tag_filter_minus_'.$tagFilterItem])>0)
    {?>
      <div class="tag-filter <?php echo $tagsList[$i]['tag_color'];?>"><?php echo $tagsList[$i]['tag_label'];?>
          <a href="<?php echo $targetFileAction;?>&remove_from_tag_filter=<?php echo $tagsList[$i]['tag_id'];?>&filter_type=minus&tag_filter_item=<?php echo $tagFilterItem;?>"><img border="0" src="<?php echo $pathImages;?>app/delete.png"></a> 
      </div> <?php
    }  
  }
}?>