<?php
/**
 * Build an image for burnup chart of business value
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */
define("PATHBASE",'../');
$pathLibraries=PATHBASE.'libraries/';
$pathClasses=PATHBASE.'libraries/classes/';

require_once PATHBASE.'popin_includes_presession.php';

require_once $pathLibraries.'jpgraph402/jpgraph.php';
require_once $pathLibraries.'jpgraph402/jpgraph_line.php';

// Get data of the sprint
require_once PATHBASE.'popin_includes.php';

$request=new sqlRequest("SELECT * FROM ".PARAM_DB_PREFIX."kados_releases WHERE release_id=".$_SESSION['current_release_id'],$cnx->num);
$releaseData=$request->getObject();
$request->sqlGet("SELECT sprint_id,sprint_name FROM ".PARAM_DB_PREFIX."kados_sprints WHERE sprint_release_id_fk=".$_SESSION['current_release_id']." ORDER BY sprint_start_date");
$sprintsList=$request->getArrayFields();

if (count($sprintsList)!=0)
{

require $pathCommons.'compute_release_data_by_sprint.php';

$businessValueLine=array();
$realBvLine=array();
$sprints=array();
$businessValueLine[0]=0;
$realBvLine[0]=0;
$sprints[0]='Start';

for ($i=0;$i<count($sprintsList);$i++)
{
  $businessValueLine[$i+1]=$businessValueLine[$i]; 
  if (isset($businessValueBySprint[$sprintsList[$i]['sprint_id']]))
  {
    $businessValueLine[$i+1]+=$businessValueBySprint[$sprintsList[$i]['sprint_id']];
  }
  $realBvLine[$i+1]=$realBvLine[$i]; 
  if (isset($businessValueDeliveredBySprint[$sprintsList[$i]['sprint_id']]))
  {
    $realBvLine[$i+1]+=$businessValueDeliveredBySprint[$sprintsList[$i]['sprint_id']];
  }  
  $sprints[$i+1]=$sprintsList[$i]['sprint_name'];
}

 

// Setup the graph
$graph = new Graph(800,480);
$graph->SetScale("textint");

$theme_class=new SoftyTheme;

$graph->SetTheme($theme_class);
$graph->img->SetAntiAliasing();

$graph->SetMargin(50,30,30,00);
$graph->yaxis->HideZeroLabel();
$graph->yaxis->HideLine(false);
$graph->yaxis->HideTicks(false,false);
$graph->xaxis->SetTickLabels($sprints);

$graph->xgrid->Show();
$graph->xgrid->SetLineStyle("solid");
$graph->xgrid->SetColor('#E3E3E3');

// Create the first line
$p1 = new LinePlot($businessValueLine);
$graph->Add($p1);
$p1->SetColor("#6495ED");
$p1->SetLegend($text_bv_planned_delivery);

// Create the second line
$p3 = new LinePlot($realBvLine);
$graph->Add($p3);
$p3->SetColor("#46BB28");
$p3->SetLegend($text_bv_delivered);


$graph->legend->SetFrameWeight(1);

// Output line
$graph->Stroke();
}
