<?php

/**
 * create graph scattering US business value and complexity
 *
 * @category Graphs
 * @package  scatter
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */

function jitter($x,$y)
{
   // set random value for x 
   $alea=mt_rand(0,3);  
   // set random value for y
   $alea2=mt_rand(0,3);  
   // set random + or - for x
   $signe=mt_rand(0,1);
   // compute value for x
   $alea=$signe==0 ? $alea : -$alea;
   // set random + or - for x
   $signe2=mt_rand(0,1);
   // compute value for y
   $alea2=$signe2==0 ? $alea2 : -$alea2;   
   // get value for jittering position for x regarding boundaries
   $newX=($x+$alea)>100 || ($x+$alea)<0 ? $x-$alea : $x+$alea;
   // get value for jittering position for y regarding boundaries
   $newY=($y+$alea2)<0 || ($y+$alea2)>100 ? $y-$alea2 : $y+$alea2;
   // put values in an array
   $position=array($newX,$newY);
   // return values
   return $position;
}
// init session var
if (!isset($_SESSION['filter_us_graph_status']))
{
  $_SESSION['filter_us_graph_status']=array('TODO'=>true,'RELEASE'=>true,'DONE'=>true);
}

$cpt=0;
$colorZones[$cpt++]='#3BD000';
$colorZones[$cpt++]='#66FF00';
$colorZones[$cpt++]='#EDE20E';
$colorZones[$cpt++]='#66FF00';
$colorZones[$cpt++]='#EDE20E';
$colorZones[$cpt++]='#ED782E';
$colorZones[$cpt++]='#EDE20E';
$colorZones[$cpt++]='#ED782E';
$colorZones[$cpt++]='#ED0018';

// actions
switch ($_REQUEST['action'])
{
  case 'cancel_zoom':
    unset($_SESSION['cpl_min']);
    unset($_SESSION['bv_min']);
    unset($_SESSION['cpl_max']);
    unset($_SESSION['bv_max']);
    unset($_SESSION['idZone']);
  break; 

  case 'filter_us_graph_status':
    if (isset($_POST['filter_us_status_todo']))  
    {
      $_SESSION['filter_us_graph_status']['TODO']=true;
    }
    else 
    {
      $_SESSION['filter_us_graph_status']['TODO']=false;  
    }
    if (isset($_POST['filter_us_status_release']))  
    {
      $_SESSION['filter_us_graph_status']['RELEASE']=true;
    }
    else 
    {
      $_SESSION['filter_us_graph_status']['RELEASE']=false;  
    }
    if (isset($_POST['filter_us_status_done']))  
    {
      $_SESSION['filter_us_graph_status']['DONE']=true;
    }
    else 
    {
      $_SESSION['filter_us_graph_status']['DONE']=false;  
    }    
  break;    
}

// get MAX and MIN values for BV and complexity
$request=new sqlRequest("SELECT MAX(business_value)+100 AS max_bv,MIN(business_value)-100 min_bv,
                                MAX(complexity)+2 AS max_cpl,MIN(complexity)-2 AS min_cpl   
                         FROM ".PARAM_DB_PREFIX."kados_user_stories 
                         WHERE active=1 
                           AND us_project_id_fk=".$_SESSION['current_project_id'],$cnx->num);        
// store values in a object      
$minMax=$request->getObject(); 

// init session var to manage zoom
if (!isset($_SESSION['cpl_min']))
{  
  $_SESSION['cpl_min']=$minMax->min_cpl;
  $_SESSION['bv_min']=$minMax->min_bv;
  $_SESSION['cpl_max']=$minMax->max_cpl;
  $_SESSION['bv_max']=$minMax->max_bv;  
  $_SESSION['zoom']=false;  
  $_SESSION['id_zone']=0;
}

// check if used on zoom
if (isset($_REQUEST['cpl_min']))
{
  $_SESSION['zoom']=true;  
  $_SESSION['cpl_min']=$_REQUEST['cpl_min'];
  $_SESSION['bv_min']=$_REQUEST['bv_min'];
  $_SESSION['cpl_max']=$_REQUEST['cpl_max'];
  $_SESSION['bv_max']=$_REQUEST['bv_max'];  
  $gapComplexity=$_REQUEST['cpl_max']-$_REQUEST['cpl_min'];
  $gapBusinessValue=$_REQUEST['bv_max']-$_REQUEST['bv_min'];  
  $_SESSION['id_zone']=$_REQUEST['id_zone'];
}

// if no zoom , set boundaries with max and min freshly computed from instant situations of US
if (!$_SESSION['zoom'])
{
  $_SESSION['cpl_min']=$minMax->min_cpl;
  $_SESSION['bv_min']=$minMax->min_bv;
  $_SESSION['cpl_max']=$minMax->max_cpl;
  $_SESSION['bv_max']=$minMax->max_bv;  
}

// compute gap for complexity from high to low value
$gapComplexity=$_SESSION['cpl_max']-$_SESSION['cpl_min'];
// compute gap for BV from high to low value
$gapBusinessValue=$_SESSION['bv_max']-$_SESSION['bv_min'];
      
// get US for the project
$request=new sqlRequest("SELECT us_number,business_value,complexity,
                                status,us_release_id_fk,release_name,text   
                         FROM ".PARAM_DB_PREFIX."kados_user_stories LEFT JOIN ".PARAM_DB_PREFIX."kados_releases ON us_release_id_fk=release_id 
                         WHERE active=1 
                           AND us_project_id_fk=".$_SESSION['current_project_id']."
                           AND business_value<=".$_SESSION['bv_max']." 
                           AND business_value>=".$_SESSION['bv_min']."    
                           AND complexity<=".$_SESSION['cpl_max']." 
                           AND complexity>=".$_SESSION['cpl_min']."    
                         ORDER BY status",$cnx->num);
// store result in a an array
$list=$request->getArrayFields();  ?>
    <div class="MessageBox InformationMessageBox"><?php echo $msg_scatter_us;?></div>
      <div>
        <form name="us_graph_status_filter_form" style="float:left" id="us_status_filter_form" method="post" action="<?php echo $targetFile;?>&action=filter_us_graph_status" enctype="multipart/form-data">   
            <span class="checkUsType" style="background-color:#FFDD00"><input name="filter_us_status_todo" id="filter_us_status_todo" type="checkbox" onClick="document.us_graph_status_filter_form.submit()" <?php if ($_SESSION['filter_us_graph_status']['TODO']) { echo 'checked="checked"';}?>/> <label style="font-size:8pt" for="filter_us_status_todo"><?php echo $text_us_in_backlog;?></label></span>
            <span class="checkUsType" style="background-color:#AFD7FF"><input name="filter_us_status_release" id="filter_us_status_release" type="checkbox" onClick="document.us_graph_status_filter_form.submit()" <?php if ($_SESSION['filter_us_graph_status']['RELEASE']) { echo 'checked="checked"';}?> /> <label style="font-size:8pt" for="filter_us_status_release"><?php echo $text_us_in_release;?></label></span>
            <span class="checkUsType" style="background-color:#87CD64"><input name="filter_us_status_done" id="filter_us_status_done" type="checkbox" onClick="document.us_graph_status_filter_form.submit()" <?php if ($_SESSION['filter_us_graph_status']['DONE']) { echo 'checked="checked"';}?> /> <label style="font-size:8pt" for="filter_us_status_done"><?php echo $text_us_done;?></label></span>
        </form>          
      </div><?php
      // display button to cancel zoom
      if ($_SESSION['zoom'])
      {
        displayButton($button_cancel_zoom,'',$targetFile.'&action=cancel_zoom','tsc_awb_small tsc_awb_blue tsc_flat');	  
      }?>
       <div id="scatterplot" style="border:dotted 1px grey;">  
           <span class="point" style="text-align:center;left:0%; bottom:0%; background-color:black; width:5px;"><span style="text-align:center;position:relative;top:5px;font-size:7pt" ><?php echo $_SESSION['cpl_min'];?></span></span>
           <span class="point" style="text-align:center;left:33.34%; bottom:0%; background-color:black; width:5px;"><span style="text-align:center;position:relative;top:5px;font-size:7pt" ><?php echo $_SESSION['cpl_min']+round((int)$gapComplexity*0.33);?></span></span>
           <span class="point" style="text-align:center;left:66.67%; bottom:0%; background-color:black; width:5px;"><span style="text-align:center;position:relative;top:5px;font-size:7pt" ><?php echo $_SESSION['cpl_min']+round((int)$gapComplexity*0.66);?></span></span>
           <span class="point" style="text-align:center;left:100%; bottom:0%; background-color:black; width:5px;"><span style="text-align:center;position:relative;top:5px;font-size:7pt" ><?php echo $_SESSION['cpl_min']+round((int)$gapComplexity*1);?></span></span>
          
           <span class="point" style="text-align:center;left:0%; bottom:0%; background-color:black; width:5px;"><span style="text-align:center;position:relative;top:-8px;right:<?php echo strlen((string)$_SESSION['bv_min'])*8;?>px;font-size:7pt" ><?php echo $_SESSION['bv_min'];?></span></span>
           <span class="point" style="text-align:center;left:0%; bottom:33.34%; background-color:black; width:5px;"><span style="text-align:center;position:relative;top:-8px;right:<?php echo strlen((string)round($_SESSION['bv_min']+(int)$gapBusinessValue*0.33))*8;?>px;font-size:7pt" ><?php echo $_SESSION['bv_min']+round((int)$gapBusinessValue*0.33);?></span></span>
           <span class="point" style="text-align:center;left:0%; bottom:66.67%; background-color:black; width:5px;"><span style="text-align:center;position:relative;top:-8px;right:<?php echo strlen((string)round($_SESSION['bv_min']+(int)$gapBusinessValue*0.66))*8;?>px;font-size:7pt" ><?php echo $_SESSION['bv_min']+round((int)$gapBusinessValue*0.66);?></span></span>
           <span class="point" style="text-align:center;left:0%; bottom:100%; background-color:black; width:5px;"><span style="text-align:center;position:relative;top:-8px;right:<?php echo strlen((string)($_SESSION['bv_min']+(int)$gapBusinessValue))*8;?>px;font-size:7pt" ><?php echo $_SESSION['bv_min']+(int)$gapBusinessValue;?></span></span><?php
             // display zone for zooming
             for ($i=0;$i<9;$i++)
             {?>
                <div id="zoomZonePosition<?php echo $i;?>" class="graphZoneZoom" style="z-index:0;background-color:<?php echo ($_SESSION['zoom'] ? $colorZones[$_SESSION['id_zone']] : $colorZones[$i]);?>"></div><?php
                // display zoom zone if not in zoom mode
                if (!$_SESSION['zoom'])
                {             
                  // compute x position of zoom zone  
                  $x=fmod($i,3);
                  // compute y position of zoom zone
                  $y=floor($i/3); 
                  // compute complexity values to send to script for zooming
                  $cpl_min=$_SESSION['cpl_min']+round((int)$gapComplexity*0.33333333*$x);
                  $cpl_max=$_SESSION['cpl_min']+round((int)$gapComplexity*0.33333333*($x+1));
                  // compute business value values to send to script for zooming
                  // warning, zoom sones are displayed from top to bottom 
                  // whereas business values is from bottom to top
                  $bv_min=$_SESSION['bv_min']+round((int)$gapBusinessValue*0.3333333*(2-$y));
                  $bv_max=$_SESSION['bv_min']+round((int)$gapBusinessValue*0.3333333*(3-$y));?>                
                  <script type="text/javascript">
                     $('#zoomZonePosition<?php echo $i;?>').click( function() {
                         location.replace('project_reports.php?cpl_max=<?php echo $cpl_max;?>&cpl_min=<?php echo $cpl_min;?>&bv_min=<?php echo $bv_min;?>&bv_max=<?php echo $bv_max;?>&id_zone=<?php echo $i;?>');
                     });
                  </script><?php 
                }
             }           
           // compute US bubble position
           for ($i=0;$i<count($list);$i++)
           {
             // X position based on percentage of complexity
             $left=round(100*($list[$i]['complexity']-$_SESSION['cpl_min'])/$gapComplexity,2);   
             // Y position based on percentage of business value
             $bottom=round(100*($list[$i]['business_value']-$_SESSION['bv_min'])/$gapBusinessValue,2);  
             // jitter the position
             $jitteredPosition=jitter($left,$bottom);
             // set default color : in backlog, out of a release
             // yellow
             $color='#FFDD00';
             $status='TODO';
             // if in a release set another color  
             if ($list[$i]['us_release_id_fk']!=0)
             {
               // blue
               $color='#AFD7FF';  
               $status='RELEASE';
             } 
             // if US done set another color  
             if ($list[$i]['status']=='DONE')
             {
               // green  
               $color='#87CD64';  
               $status='DONE';
             } 
             // display bubble
             if ($_SESSION['filter_us_graph_status'][$status])
             {?>
               <span class="point" style="text-align:center;left:<?php echo $jitteredPosition[0];?>%; bottom:<?php echo $jitteredPosition[1];?>%; background-color: <?php echo $color;?>; width:20px;">
                    <span style="text-align:center;font-size:7pt" ><?php echo $list[$i]['us_number'];?></span>
                    <div class="bubbleTip" <?php if ($jitteredPosition[0]>80) { echo 'style="left:-235px"';}?>><?php
                      echo '<b>US'.$list[$i]['us_number'].'</b><br />';
                      echo $text_business_value.' : '.$list[$i]['business_value'].'<br />';
                      echo $text_complexity.' : '.$list[$i]['complexity'].'<br />';
                      echo $text_release.' : <i>'.$list[$i]['release_name'].'</i><br />';
                      echo nl2br(substr($list[$i]['text'],0,100)).'...';?>
                    </div>  
               </span>  <?php
             }
           }?>
           <script>
               $('.point').click(function() {
                    var bubble=$(this).find(".bubbleTip");
                    if (bubble.css('visibility')=='hidden')
                    {
                       bubble.css('visibility','visible');
                    }
                    else if (bubble.css('visibility')=='visible')
                    {
                      bubble.css('visibility','hidden');
                    }

                });
           </script>
       </div> 
    <script> 
      $('#scatterplot').scatter({ height:window.innerHeight-$('#menu').innerHeight()-$('#railway').innerHeight()-170, width:window.innerWidth-100, xLabel: 'Complexity', yLabel: 'Business Value',color:'#FFFFFF',responsive: true });
      $('.point').plot();
     
        var boxHeight=parseInt(Math.round((window.innerHeight-$('#menu').innerHeight()-$('#railway').innerHeight()-170)/3));
        var boxWidth=parseInt(Math.round((window.innerWidth-100)/3));<?php
        // set position for zoom zones
        for ($i=0;$i<9;$i++)
        {
          // compute x and y based on zone number  
          $x=fmod($i,3);
          $y=floor($i/3);?>      
          $('#zoomZonePosition<?php echo $i;?>').height(boxHeight);
          $('#zoomZonePosition<?php echo $i;?>').width(boxWidth);
          $('#zoomZonePosition<?php echo $i;?>').css('top',boxHeight*<?php echo $y;?>);
          $('#zoomZonePosition<?php echo $i;?>').css('left',boxWidth*<?php echo $x;?>);<?php
        }?>       
     </script> 