<?php
/**
 * Build an image for burndown chart
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */
define("PATHBASE",'../');
$pathLibraries=PATHBASE.'libraries/';
$pathClasses=PATHBASE.'libraries/classes/';

require_once PATHBASE.'popin_includes_presession.php';

require_once $pathLibraries.'jpgraph402/jpgraph.php';
require_once $pathLibraries.'jpgraph402/jpgraph_line.php';
require_once $pathLibraries.'jpgraph402/jpgraph_bar.php';
require_once $pathLibraries.'jpgraph402/jpgraph_error.php';
require_once $pathCommons.'date_hour.php';

// Get data of the sprint

require_once PATHBASE.'popin_includes.php';

$request=new sqlRequest("SELECT * FROM ".PARAM_DB_PREFIX."kados_sprints WHERE sprint_id=".$_SESSION['current_sprint_id'],$cnx->num);
$sprintData=$request->getObject();
$startDate=new DateTime($sprintData->sprint_start_date);
$endDate=new DateTime($sprintData->sprint_end_date);

  // Get data on US from baselines					   
  $request->sqlGet("SELECT us_id_fk,baseline_date,us_status 
                   FROM ".PARAM_DB_PREFIX."kados_baselines bl 
		   WHERE bl.us_sprint_id_fk=".$_SESSION['current_sprint_id']);
  $usDataFromBaselines=$request->getArrayFields();					   
  $usValuesByDay=array();
  
  for ($i=0;$i<count($usDataFromBaselines);$i++)
  {
    if (!isset($usValuesByDay[$usDataFromBaselines[$i]['baseline_date']][$usDataFromBaselines[$i]['us_id_fk']]))
    {    
      $usValuesByDay[$usDataFromBaselines[$i]['baseline_date']][$usDataFromBaselines[$i]['us_id_fk']]=$usDataFromBaselines[$i]['us_status'];
    }
    else
    {    
      $usValuesByDay[$usDataFromBaselines[$i]['baseline_date']][$usDataFromBaselines[$i]['us_id_fk']]='NONE';
    }
  }
 
  // get US ids in the sprint
  // get data
  $request->sqlGet("SELECT us_id 
                    FROM ".PARAM_DB_PREFIX."kados_user_stories 
		    WHERE us_sprint_id_fk=".$_SESSION['current_sprint_id']);
  // fill array
  $usIdsInSprint=$request->getArrayFirstFieldOnly();

  $allUsIds=array_values(array_unique(array_merge(array_column($usDataFromBaselines,"us_id_fk"),$usIdsInSprint)));

// get project working days	 
$workingDays=explode(';',getProjectSetting('WK_DAY',$_SESSION['current_project_id'],$cnx->num));	   
$projectExludedDays=array();
$request->sqlGet("SELECT idle_day FROM ".PARAM_DB_PREFIX."kados_projects_idle_days 
                  WHERE project_id_fk=".$_SESSION['current_project_id']." ORDER BY idle_day");
$projectExludedDays=$request->getArrayFirstFieldOnly();	  
// count real sprint days 
$duration=$endDate->diff($startDate,true);
$daysShift=$duration->format('%a');

$daysDisplay=array();
$daysList=array();
$daysCount=0;
for ($i=0;$i<$daysShift+1;$i++)
{
  if (in_array(fmod(dayOfWeek($startDate->format('Y-m-d'))+6,7),$workingDays))
  {
    // check if current day is not excluded
    if (!in_array($startDate->format('Y-m-d'),$projectExludedDays))
    {
      array_push($daysDisplay,$startDate->format('j/n/y'));  
      array_push($daysList,$startDate->format('Y-m-d'));  
      $daysCount++;
    }
  }
  $startDate->add(new DateInterval('P1D'));
}
  $usValuesByDayFull=array();
  // fill in the big array for each day and each US
  for ($i=0;$i<count($daysList);$i++)
  {
    for($j=0;$j<count($allUsIds);$j++)
    {
      // if value exists for that day  
      if (isset($usValuesByDay[$daysList[$i]]))
      {
        // if us has no record   
        if (!isset($usValuesByDay[$daysList[$i]][$allUsIds[$j]]))
        {
           // if US in sprint
           if (in_array($allUsIds[$j],$usIdsInSprint))
           {
             // if sprint first day, status=> NONE  
             if ($i==0)
             {
               $usValuesByDayFull[$daysList[$i]][$allUsIds[$j]]='NONE';      
             }
             else
             {
               // else status of the previous day  
               $usValuesByDayFull[$daysList[$i]][$allUsIds[$j]]=$usValuesByDayFull[$daysList[$i-1]][$allUsIds[$j]];        
             }
           }
           else
           {
              //not in sprint anymore status=> NONE 
              $usValuesByDayFull[$daysList[$i]][$allUsIds[$j]]='NONE';                     
           }
        }
        else
        {
          $usValuesByDayFull[$daysList[$i]][$allUsIds[$j]]=$usValuesByDay[$daysList[$i]][$allUsIds[$j]];
        }
      }
      else
      {
        // if previous day or today, get value from previous day
        if ($daysList[$i]<= aujourdhui())
        {
          $usValuesByDayFull[$daysList[$i]][$allUsIds[$j]]=$usValuesByDayFull[$daysList[$i-1]][$allUsIds[$j]];     
        }
        else
        {
          // else create it with NONE 
          $usValuesByDayFull[$daysList[$i]][$allUsIds[$j]]='NONE';   
        }
      }
    }
  }

  $usTodo=array();
  $usInProgress=array();
  $usReady2Check=array();
  $usDone=array();  
  // count US status
  for ($i=0;$i<count($daysList);$i++)
  {
    $statusCount=array('NONE'=>0,'TODO'=>0,'RUN'=>0,'DEV'=>0,'DONE'=>0);
    for($j=0;$j<count($allUsIds);$j++)
    {
      $statusCount[$usValuesByDayFull[$daysList[$i]][$allUsIds[$j]]]++;
    }
    $usTodo[$i]=$statusCount['TODO'];
    $usInProgress[$i]=$statusCount['RUN'];
    $usReady2Check[$i]=$statusCount['DEV'];
    $usDone[$i]=$statusCount['DONE'];
  }

// Setup the graph
$graph = new Graph(900,550);
$graph->SetScale("textint");

$theme_class=new SoftyTheme;

$graph->SetTheme($theme_class);
$graph->img->SetAntiAliasing(true);
$graph->SetBox(false);
$graph->SetMargin(30,30,30,00);
$graph->yaxis->HideZeroLabel();
$graph->yaxis->HideLine(false);
$graph->yaxis->HideTicks(false,false);

$graph->xgrid->Show();
$graph->xgrid->SetLineStyle("solid");
$graph->xaxis->SetTickLabels($daysDisplay);
$graph->xgrid->SetColor('#E3E3E3');
$graph->xaxis->SetLabelAngle(45);

if (count($usDataFromBaselines)!=0)
{
  // Build lines
// Create the bar plots
$b1plot = new BarPlot($usTodo);
$b1plot->SetLegend($text_us_count_todo);  
$b2plot = new BarPlot($usInProgress);
$b2plot->SetLegend($text_us_count_run);
$b3plot = new BarPlot($usReady2Check);
$b3plot->SetLegend($text_us_count_ready2check);
$b4plot = new BarPlot($usDone);
$b4plot->SetLegend($text_us_count_delivered);

// Create the grouped bar plot
$gbplot = new AccBarPlot(array($b1plot,$b2plot,$b3plot,$b4plot));
 
// ...and add it to the graPH
$graph->Add($gbplot);

$b1plot->SetFillColor('#EDCD00');
$b1plot->SetColor('#EDCD00');
$b1plot->value->Show();
$b1plot->value->SetColor('black');
$b1plot->value->SetFont(FF_FONT1,FS_BOLD);    
$b1plot->value->SetFormat('%d');

$b2plot->SetFillColor('#B22222');
$b2plot->SetColor('#B22222');
$b2plot->value->Show();
$b2plot->value->SetColor('black');
$b2plot->value->SetFont(FF_FONT1,FS_BOLD);    
$b2plot->value->SetFormat('%d');

$b3plot->SetFillColor("#2D4B8E");
$b3plot->SetColor("#2D4B8E");
$b3plot->value->Show();
$b3plot->value->SetColor('black');
$b3plot->value->SetFont(FF_FONT1,FS_BOLD);    
$b3plot->value->SetFormat('%d');

$b4plot->SetFillColor("#027100");
$b4plot->SetColor("#027100");
$b4plot->value->Show();
$b4plot->value->SetColor('black');
$b4plot->value->SetFont(FF_FONT1,FS_BOLD);    
$b4plot->value->SetFormat('%d');


}
else
{
  $idealLineList=array();  
  for ($i=0;$i<count($daysList);$i++)
  {
    $idealLineList[$i]=0;
  }
  // Create the solid real line
  $p2 = new BarPlot($idealLineList);
  $graph->Add($p2);
  $p2->SetLegend($text_no_data);
}

$graph->legend->SetFrameWeight(1);
$graph->legend->SetColumns(4);

// Output line
$graph->Stroke();
?>