<?php
/**
 * index.php
 * index page  
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  Project_Mngt:index
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */
DEFINE("PATHBASE",'./');
$pathClasses=PATHBASE.'libraries/classes/';
$pathCommons=PATHBASE.'common_scripts/';  
$pathImages=PATHBASE.'images/';

// if connect.conf does not exists
// redirect to updates index page
// NEW INSTALL
if (!file_exists(PATHBASE.'conf/connect.conf'))
{
  header("location: ./updates/index.php");
}
// NEW UPGRADE
$oldVersion=file_get_contents(PATHBASE.'VERSION');
if(file_exists(PATHBASE.'VERSION_NEW'))
{
  $newVersion=file_get_contents(PATHBASE.'VERSION_NEW');  
  if($newVersion!=$oldVersion)
  {
    header("location: ./updates/index.php");  
  }
}

// connection info
include PATHBASE.'conf/connect.conf';
require_once $pathClasses.'class_connexion_mysql.php';
$cnx=new connexion_db();

require_once $pathCommons.'functions.php';
require_once PATHBASE.'session_settings.php';
require_once $pathCommons.'getDefaultLanguage.php';

$_SESSION['charset']=$cnx->charset;

// Set default language using the browser language 
$request=new sqlRequest("SELECT language_tag FROM ".PARAM_DB_PREFIX."framework_languages WHERE language_status=1",$cnx->num);
$availableLanguages=$request->getArrayFirstFieldOnly();
$browserDefaultLanguage=strtolower(getDefaultLanguage());
$browserLanguage= ($browserDefaultLanguage=='pt-br') ? 'br' : substr($browserDefaultLanguage,0,2);  
$_SESSION['language']= in_array($browserLanguage,$availableLanguages) ? $browserLanguage : 'en' ;

if (isset($_GET['change_language']))
{  
  $request=new sqlRequest("SELECT language_tag FROM ".PARAM_DB_PREFIX."framework_languages WHERE language_status=1",$cnx->num);
  $availableLanguages=$request->getArrayFirstFieldOnly();
  $changeLanguage=strtolower(substr($_GET['change_language'],0,2));
  $_SESSION['language']=in_array($changeLanguage,$availableLanguages) ? $changeLanguage : 'en' ;
} 

require_once $pathClasses.'class_ldap.php';
require_once PATHBASE.'classes/appUser.php';
require_once $pathCommons.'date_hour.php';
require_once PATHBASE.'messages/'.$_SESSION['language'].'_ihm_messages.php';
require_once PATHBASE.'messages/'.$_SESSION['language'].'_app_messages.php';
require_once PATHBASE.'messages/'.$_SESSION['language'].'_js_messages.php';

require_once $pathCommons.'app_functions.php';

$targetFile='index.php?';
 
if (!isset($_REQUEST['connexion']))
{
  $_REQUEST['connexion']='';
}  

switch($_REQUEST['connexion'])
{
  case 'off':
    $saveLanguage=$_SESSION['language'];
    session_destroy();
    session_start();
    $_SESSION['language']=$saveLanguage;
  break;
}

if (!isset($_SESSION['login']))
{        
   switch($_REQUEST['connexion'])
   {
     case 'on':
       // init var  
       $userOK=false;
       $syntaxOK=true;  
       // filter login width
       $FormLogin=substr(trim($_POST['Flogin']),0,15);  
       // check if login used only allowed chars
       if (!preg_match("/^[a-z0-9_]+$/",strtolower($FormLogin)))
       {
         $msg_error=$msg_user_format_ko;  
         $syntaxOK=false;  
       }        
       // filter pass width
       $FormPass=substr($_POST['Fpass'],0,15);
       // if syntax is OK
       if ($syntaxOK)
       {
         // LDAP users are allowed
         if (getParameter('LDAP',$cnx->num) && function_exists('ldap_connect'))
         {
           // First search user in the local users before using LDAP
           $request=new sqlRequest("SELECT user_password,status_tag 
                                    FROM ".PARAM_DB_PREFIX."framework_users,".PARAM_DB_PREFIX."framework_status  
                                    WHERE user_login='".strtolower($FormLogin)."' 
                                      AND user_connection_mode='LOCAL' 
                                      AND user_status_id_fk=status_id",$cnx->num);
           $request->countRows();
           // if user is found
           if ($request->rowCount!=0)
           {
  	     // It's a local user => use its profile
             $request->getObject();
             // check if user is active
             if ($request->objet->status_tag=='ACTIVE')
             {
               // check password
               if ($request->objet->user_password==md5($FormPass))
               {
                 // allow login  
                 $userOK=true;
               }
               else
               {
                 // send error message  
                 $msg_error=$msg_wrong_password;
               }
             }
             else 
             {
               // send error message  
               $msg_warning=$msg_user_inactive;
             }
           }
	   else
	   {
	     // It's not a local user => check if it's a LDAP user
             // get LDAP settings from DB  
             $request=new sqlRequest("SELECT parameter_tag_id,parameter_value 
                                      FROM ".PARAM_DB_PREFIX."framework_parameters 
                                      WHERE parameter_tag_id LIKE 'LDP%'",$cnx->num);
             $ldapData=$request->getArrayFieldsOneField();
             // build the constants
             define("LDAP_SERVER",$ldapData['LDPSRV']);
             define("LDAP_PORT",$ldapData['LDPPRT']);
             define("LDAP_BASE_DN",$ldapData['LDPBDN']);
             define("LDAP_UID_FIELD",$ldapData['LDPUID']);
             define("LDAP_NAME_FIELDS_NAME",$ldapData['LDPNAM']);
             define("LDAP_NAME_FIELDS_FIRSTNAME",$ldapData['LDPFNM']);
             define("LDAP_NAME_FIELDS_FULLNAME",$ldapData['LDPFUN']);
             define("LDAP_ATTRIBUTES",$ldapData['LDPATT']);
             define("LDAP_ALL_ATTRIBUTES",$ldapData['LDPAAT']);
             define("LDAP_BIND_DN",$ldapData['LDPBID']);
             define("LDAP_BIND_PASS",$ldapData['LDPBIP']);
             define("LDAP_USER_OBJECTCLASS",$ldapData['LDPOBJ']);             
             // create connection
	     $ldapConnection=new mtLdap();
	     // Check if Ldap Id id OK
	     if ($ldapConnection->authenticate($FormLogin,$_POST['Fpass']))
	     { 
	       // Check if user is in the BD
               $request=new sqlRequest("SELECT user_name,status_tag  
                                        FROM ".PARAM_DB_PREFIX."framework_users,".PARAM_DB_PREFIX."framework_status  
                                        WHERE user_login='".strtolower($FormLogin)."' 
                                          AND user_connection_mode='LDAP' 
                                          AND user_status_id_fk=status_id",$cnx->num);		
               $request->countRows();
               if ($request->rowCount==0)
               {
                 // if valid LDAP users can log directly in KADOS
                 if (getParameter('AUTLOG', $cnx->num))
                 {
                   // insert user
                   $userOK=true;
	           //reinit LDAP connection
                   unset($ldapConnection);
                   $ldapConnection=new mtLdap();
                   // get user details from LDAP
		   $userData=$ldapConnection->getData($FormLogin);
                   // Get default profile
	           $request->sqlGet("SELECT profile_id FROM ".PARAM_DB_PREFIX."framework_profiles WHERE profile_default=1");
		   $request->getObject();
		   $defaultProfileId=$request->objet->profile_id;
		   // Create user
		   $request->sqlGet("INSERT INTO ".PARAM_DB_PREFIX."framework_users (user_login, user_name, user_firstname, user_mail,
                                                                  user_profile_id_fk,  user_creation_date, user_password,
                                                                  user_status_id_fk,user_connection_mode,user_theme,user_confirmed) 
                                     VALUES ('".strtolower($FormLogin)."','".$userData->lastname."',
                                             '".$userData->firstname."','".$userData->mail."',
                                             ".$defaultProfileId.",'".aujourdhui()."','',
                                             (SELECT status_id 
                                              FROM ".PARAM_DB_PREFIX."framework_status 
                                              WHERE status_target_object='USR' AND status_order=1),
                                              'LDAP','".  getParameter('THEME', $cnx->num)."',1)");
                 }
                 else
                 {
                   // warn user he/she can not login 
                   $msg_warning=$msg_user_not_registred;
                 }  
	       }
               else
               {
                 // if user is active, allow login
                 $request->getObject();
                 // check if user is active
                 if ($request->objet->status_tag=='ACTIVE')
                 {                   
                   // Allow login  
                   $userOK=true;
                 }  
                 else 
                 {
                   // send error message  
                   $msg_warning=$msg_user_inactive;
                 }                 
               }  
	     }
	     else
	     {
               // send error message  
	       $msg_error=$msg_credentials_ko;
	     }
	   }
	 }  
	 else
	 {
	   // No LDAP is used
           // search user in the user table
           $request=new sqlRequest("SELECT user_password,user_confirmed,status_tag,user_connection_mode   
                                    FROM ".PARAM_DB_PREFIX."framework_users,".PARAM_DB_PREFIX."framework_status  
                                    WHERE status_id=user_status_id_fk 
                                      AND user_login='".strtolower($FormLogin)."'",$cnx->num);
           $request->countRows();
           if ($request->rowCount==0)
           {
             // send error message  
             $msg_error=$msg_unknown_user;
           }
           else
           {
             // check if user id confirmed  
             $userData=$request->getObject();
             if ($userData->user_connection_mode=='LOCAL')
             {
               if ($userData->user_confirmed==1)
               {
                 //  check is user is active
                 if ($userData->status_tag=='ACTIVE')
                 {
                   // check password  
                   if ($userData->user_password==md5($FormPass))
                   {
                     // allow login  
                     $userOK=true;
                   }
                   else
                   {
                     // send error message  
                     $msg_error=$msg_wrong_password;
                   }
                 }
                 else
                 {
                   // send error message
                   $msg_warning=$msg_user_inactive;    
                 }
               }
               else
               {
                 // send error message  
                 $msg_warning=$msg_user_not_confirmed;  
               }
             }
             else
             {
               // user id LDAP but LDAP is not available  
               $msg_warning=$msg_user_ldap_without_ldap;    
             }
           }
	 }  
       }  
       // If user is authenticated, let's go to the welcome page
       if ($userOK)
       {	
         $request=new sqlRequest("SELECT user_password,user_name,user_firstname,user_profile_id_fk,
	                                 user_language,profile_tag,user_theme 
	                          FROM ".PARAM_DB_PREFIX."framework_users,".PARAM_DB_PREFIX."framework_profiles 
	                          WHERE LOWER(user_login)='".strtolower($FormLogin)."' 
	                            AND user_profile_id_fk=profile_id",$cnx->num);
         $request->getObject();
         // create session vars
         $_SESSION['login']=strtolower($FormLogin);     
         $_SESSION['user_fullname']=$request->objet->user_firstname.' '.$request->objet->user_name;
         $_SESSION['language']=$request->objet->user_language;
         $_SESSION['user_rights']=array();
         $_SESSION['user_theme']=$request->objet->user_theme;
         $_SESSION['user_profile']=intval($request->objet->user_profile_id_fk);
         $_SESSION['user_profile_tag']=$request->objet->profile_tag;
         $request->sqlGet("SELECT action_tag_fk 
                           FROM ".PARAM_DB_PREFIX."framework_profiles_constitution_actions 
                           WHERE profile_id_fk=".$_SESSION['user_profile']);
         $_SESSION['user_actions']=$request->getArrayFirstFieldOnly();
         // update last login date
         $userObject=new appUser($cnx->num,$_SESSION['login']);
         $userObject->setLastLoginDate();
         // set auto filter on US done if user pref is ON
         if ($userObject->user_pref_filter_on_for_us_done)
         {
           $_SESSION['us_status_filter']=true;  
         }
         // get first menu for user
         $menu_lev1=array();
         $sqlMenus="SELECT menu_tag AS tag,menu_translation_value AS titre,menu_file AS file 
                    FROM ".PARAM_DB_PREFIX."framework_menus,".PARAM_DB_PREFIX."framework_menus_translations,".PARAM_DB_PREFIX."framework_profiles_constitution_menus 
                    WHERE menu_father='' AND menu_translation_language='".$_SESSION['language']."' 
                      AND menu_tag=".PARAM_DB_PREFIX."framework_menus_translations.menu_tag_fk 
                      AND menu_tag=".PARAM_DB_PREFIX."framework_profiles_constitution_menus.menu_tag_fk 
                      AND profile_id_fk=".$_SESSION['user_profile']." 
                    ORDER BY menu_order";
         $request=new sqlRequest($sqlMenus,$cnx->num);
         $menu_lev1=$request->getArrayFields();	
         $_SESSION['menu_lev1']='projects';	
         $targetStartFile='projects.php?';
         // Check if any shortcut
         include PATHBASE.'shortcuts_analysis.php';
         // if no shortcuts go to home 
         header('location: ./'.$targetStartFile);
       }
     break;  
  } 
}
else
{
  $menu_lev1=array();
  $sqlMenus="SELECT menu_tag AS tag,menu_translation_value AS titre,menu_file AS file 
             FROM ".PARAM_DB_PREFIX."framework_menus,".PARAM_DB_PREFIX."framework_menus_translations,".PARAM_DB_PREFIX."framework_profiles_constitution_menus,
                  ".PARAM_DB_PREFIX."framework_profiles,".PARAM_DB_PREFIX."framework_users 
             WHERE menu_father='' AND menu_translation_language='".$_SESSION['language']."' 
               AND menu_tag=".PARAM_DB_PREFIX."framework_menus_translations.menu_tag_fk 
               AND menu_tag=".PARAM_DB_PREFIX."framework_profiles_constitution_menus.menu_tag_fk 
               AND profile_id_fk=user_profile_id_fk
               AND user_login='".$_SESSION['login']."'
             ORDER BY menu_order";
  $request=new sqlRequest($sqlMenus,$cnx->num);
  $menu_lev1=$request->getArrayFields();	
  $targetStartFile=$menu_lev1[0]['file'];  
  $_SESSION['menu_lev1']=$menu_lev1[0]['tag'];	
  // Check if any shortcut
  include PATHBASE.'shortcuts_analysis.php';
  header('location: ./'.$targetStartFile);    
}

if (isset($_REQUEST['warning_message']))
{
  if ($_REQUEST['warning_message']=='SESSION_END')
  {
     $msg_warning=$msg_session_ended;
  }
} ?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<title><?php TextDisplay($appName);?></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link rel="icon" type="image/png" href="<?php echo $pathImages;?>app/favicon.png" />

<link rel="stylesheet" type="text/css" href="css/global.css" />
<link rel="stylesheet" type="text/css" href="css/form.css" />
<link rel="stylesheet" type="text/css" href="css/sweetalert/sweet-alert.css" />
<link rel="stylesheet" type="text/css" href="css/app.css" />
<link rel="stylesheet" type="text/css" href="css/buttons.css" />
<link rel="stylesheet" type="text/css" href="css/forms.css" />

<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>themes/<?php echo getParameter('THEME',$cnx->num);?>/theme.css" />


<?php require_once PATHBASE."js/messages.js.php"; ?>
<script type="text/javascript" src="<?php echo PATHBASE.'js/global.js';?>"></script>
<script type="text/javascript" src="<?php echo PATHBASE.'js/app.js';?>"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/jquery/jquery.min.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/sweet-alert.min.js"></script>
</head>

<body>

<div class="global">

<!-- START HEADER!-->
<div class="display_header">
  <div class="logo"><img src="<?php echo PATHBASE;?>themes/<?php echo getParameter('THEME',$cnx->num);?>/images/logo.png" border="0" /></div>
  <div class="title"><?php TextDisplay($appName);?></div>  
  <div class="subtitle"><?php if (isset($appSubTitle)) { echo $appSubTitle;}?></div>
  <div class="languages"><?php
   $request=new sqlRequest("SELECT language_tag FROM ".PARAM_DB_PREFIX."framework_languages WHERE language_status=1 ORDER BY language_tag",$cnx->num); 
   $resultsArray=$request->getArrayFields();
   // list languages with link to switch language
   for ($i=0;$i<count($resultsArray);$i++)
   {?>
     <a href="<?php echo setUrlForParam($_SERVER['PHP_SELF']);?>change_language=<?php echo $resultsArray[$i]['language_tag'];?>" class="std_link link_flag"><img src="<?php echo $pathImages;?>flags/<?php echo $resultsArray[$i]['language_tag'];?>-small.png" border="0"/></a> <?php
   }?>	 
  </div>    
</div>
<div class="sol"></div>
<div class="clearleft"></div>
<!-- END HEADER!-->


<div class="display_body">
    <div id="mainbox"> 
    
        <div class="card"><?php
        if (isset($msg_error))
        {?>
           <div class="MessageBox ErrorMessageBox"><?php echo $msg_error;?></div><?php
        }
        else if (isset($msg_warning))
        {?>
           <div class="MessageBox WarningMessageBox"><?php echo $msg_warning;?></div><?php
        }?>
      <div id="connexionBlock" with="100%">     
           <form class="pure-form pure-form-aligned" action="<?php echo $targetFile;?>"  method="POST" name="form_logon" onkeypress="javascript:if(event.keyCode == 13){CheckFormLogon();}">
	     <fieldset class="fieldset">
	     <input type="hidden" name="connexion" value="on"><?php
                 if (isset($_REQUEST['shortcut']))
                 {?>
                   <input type="hidden" name="shortcut" value="<?php echo $_REQUEST['shortcut'];?>"><?php
                 }     
                 if (isset($_REQUEST['shortcut_id']))
                 {?>
                   <input type="hidden" name="shortcut_id" value="<?php echo $_REQUEST['shortcut_id'];?>"><?php
                 } 
                 if (isset($_REQUEST['shortcut_target']))
                 {?>
                   <input type="hidden" name="shortcut_target" value="<?php echo $_REQUEST['shortcut_target'];?>"><?php
                 } ?>                     
		   <legend class="legend"><?php echo $legend_logon;?></legend>
	   <label class="label required_field100" for="Flogin"><?php echo $text_login;?></label>
           <input class="std_form_field" type="text" name="Flogin" size="25" /><div class="clearleft"></div>
           <label  class="label required_field100" for="Fpass"><?php echo $text_password ;?></label>
           <input class="std_form_field" type="password" name="Fpass" size="25" /><div class="clearleft"></div><br />

	   <div ><?php
             displayButton($button_submit,'','javascript:CheckFormLogon()','tsc_awb_medium tsc_awb_green tsc_flat');	?>
	   </div>  		   
		   
		  </fieldset> 
</form>
<script type="text/javascript">document.form_logon.Flogin.focus();</script>
<?php
if (getParameter('USACT',$cnx->num))
{?>
  <div class="forgotten_pass std_link"><a href="forgotten.php"><?php echo $text_forgotten_password;?></a></div><?php
}
// Display news
$request->sqlGet("SELECT * FROM ".PARAM_DB_PREFIX."framework_news 
                  WHERE news_language='".$_SESSION['language']."' 
                  ORDER BY news_date DESC
                  LIMIT 0,3");
$newsList=$request->getArrayFields();?>
</div>
        </div>
    <div class="card "> <?php
      for ($i=0;$i<count($newsList);$i++)
      {?>
        <div class="news-piece topColor<?php echo $i;?> ">
            <p><?php echo nl2br($newsList[$i]['news_content']);?></p>
            <a target="_ext" href="<?php echo $newsList[$i]['news_link'];?>"><?php echo $newsList[$i]['news_link'];?></a>
        </div><?php
      }?>  
    </div>
     </div>
<?php
require_once PATHBASE.'footer.php';?>

