<?php
Class connexion_db
{
  var $host;
  var $user;
  var $password;
  var $num;
  var $nom_db;
	
  // le constructeur cree la connexion physique.
  function __construct($path="")
  {
    $this->host=PARAM_CNX_HOST;
    $this->user=PARAM_CNX_USER;
    $this->password=PARAM_CNX_PASS;
    $this->nom_db=PARAM_CNX_DB;
    $this->charset=PARAM_CNX_CHARSET;      	  
    $this->num=mysqli_connect($this->host,$this->user,$this->password);
    if (!$this->num)
    {
      echo "<br>SQL : DB connection error<br>";
      echo mysqli_error($this->num)."<BR>\n";
    }
    else
    {
      $this->select_db();
      mysqli_query($this->num,"SET NAMES '".$this->charset."'");
    }	  
  }
	
  function select_db($chgt=false,$nlle_base="")
  {
	  if ($chgt)
	    $this->nom_db=$nlle_base;
	  $cr_select_db=mysqli_select_db($this->num,$this->nom_db);
      if (!$cr_select_db)
      {
        echo "base non selectionnee <br>";
	    echo mysqli_error($this->num)."<BR>\n";
      }
	}  	
		
	function close()
	{ mysqli_close($this->num); }
        
      function escape_string($value)
      {
        return mysqli_escape_string($this->num,$value);   
      }

};//fin def classe connexion_db

class sqlRequest{
  var $objet;
  var $resultat;
  var $rowCount;
  var $array;
  var $connex;
  var $array_obj;
  var $id_new;
  var $log;
 
  function __construct($chaine,$cnx)
  {
    $this->connex=$cnx;
	$this->resultat=mysqli_query($this->connex,$chaine);
    if ($this->resultat)
    {
	    $this->id_new=  mysqli_insert_id($this->connex);
	    mysqli_query($this->connex,'COMMIT');
		$this->log=true;
    }
	else
	{
      $this->addLog($chaine);
	}  
  }
 
  function sqlGet($chaine)
  {
    $this->resultat=mysqli_query($this->connex,$chaine);
    if ($this->resultat)
	{
	  $this->id_new=mysqli_insert_id($this->connex);	 
	  $this->log=true;	  
	  mysqli_query($this->connex,'COMMIT');	
	}  
	else
	{
      $this->addLog($chaine);
	}
    return $this->log;	
  }
  
  function getLastId()
  {
    return $this->id_new;	
  }
  
  private function recup_row()
  {
    $one_row=mysqli_fetch_row($this->resultat);
    if (!$one_row)
    {  
      echo "Recuperation ligne resultat tablo non effectuee <BR>\n";
	  echo mysqli_error($this->connex)."<BR>";
    }
	else
	{ return $one_row; }
	
  } 
  
  private function recup_row_champ()
  {
    $one_row=mysqli_fetch_assoc($this->resultat);
    if (!$one_row)
    {  
      echo "Recuperation ligne resultat tablo non effectuee <BR>\n";
	  echo mysqli_error($this->connex)."<BR>";
    }
	else
	{ return $one_row; }
	
  }      
 
  function countRows()
  {
    $this->rowCount=mysqli_num_rows($this->resultat);  
	return  $this->rowCount;
  }
  
  
  function positionne($pos)
  {
    $this->countRows();
    if ($pos<=$this->rowCount)
	{ 
	  $cr_dat_seek=mysqli_data_seek($this->resultat,$pos);
	  if (!$cr_dat_seek)
      {    
        echo "Positionnement non effectuee <BR>\n";
	    echo mysqli_error($this->connex)."<BR>";
      }
	}
	else
	{
	  echo "Position hors d'atteinte.";
	} 
  }		 
  
  function getArray()
  {  
    $this->array=array();
	$this->countRows();
    for($i=0;$i<$this->rowCount;$i++)
    { $this->array[$i]=$this->recup_row(); }
	return $this->array;
  }
  
  function getArrayFirstFieldOnly()
  {  
    $this->array=array();
    $this->countRows();
    for($i=0;$i<$this->rowCount;$i++)
    { 
      $row=$this->recup_row();
      $this->array[$i]=$row[0];
    }
    return $this->array;
  }  
  
  function getArrayFields()
  {  
    $this->array=array();
	$this->countRows();
    for($i=0;$i<$this->rowCount;$i++)
    { $this->array[$i]=$this->recup_row_champ(); }
	return $this->array;
  } 

  function getArrayFieldsGroup($groupField)
  {  
    $this->array=array();
	$this->countRows();
    for($i=0;$i<$this->rowCount;$i++)
    { 
	  $row=$this->recup_row_champ();
	  $this->array[$row[$groupField]][]=$row; 
	}
	return $this->array;
  }   
  
  function getArrayFieldsPivot($pivotField)
  {  
    $this->array=array();
	$this->countRows();
    for($i=0;$i<$this->rowCount;$i++)
    { 
	  $row=$this->recup_row_champ();
	  $this->array[$row[$pivotField]]=$row; 
	}
	return $this->array;
  } 

  function getArrayPivotDouble()
  {  
    $this->array=array();
	$this->countRows();
    for($i=0;$i<$this->rowCount;$i++)
    { 
	  $row=$this->recup_row();
	  $this->array[$row[0]][$row[1]]=$row; 
	}
	return $this->array;
  }   
  
  
  function getArrayFieldsOneField()
  {  
    $this->array=array();
	$this->countRows();
    for($i=0;$i<$this->rowCount;$i++)
    { 
	  $row=$this->recup_row();
	  $this->array[$row[0]]=$row[1]; 
	}
	return $this->array;
  }   
  
  function getArrayFieldsPivotDouble($pivotFields,$targetField='')
  {  
    $this->array=array();
	$this->countRows();
    for($i=0;$i<$this->rowCount;$i++)
    { 
	  $row=$this->recup_row_champ();
	  if ($targetField=='')
	  {
	    $this->array[$row[$pivotFields[0]]][$row[$pivotFields[1]]]=$row; 
	  }
      else	  
	  {
	    $this->array[$row[$pivotFields[0]]][$row[$pivotFields[1]]]=$row[$targetField]; 
	  }	  
	}
	return $this->array;
  }

  function getArrayFieldsPivotDoubleMultipleRows($pivotFields,$targetField='')
  {  
    $this->array=array();
	$this->countRows();
    for($i=0;$i<$this->rowCount;$i++)
    { 
	  $row=$this->recup_row_champ();
	  if ($targetField=='')
	  {
	    $this->array[$row[$pivotFields[0]]][$row[$pivotFields[1]]][]=$row; 
	  }
          else	  
	  {
	    $this->array[$row[$pivotFields[0]]][$row[$pivotFields[1]]][]=$row[$targetField]; 
	  }	  
	}
	return $this->array;
  }  
  
  function getObject()
  {
    $this->objet=mysqli_fetch_object($this->resultat);
    if (!$this->objet)
     {  
       echo "Recuperation ligne resultat objet non effectuee <BR>\n";
	   echo mysqli_error($this->connex)."<BR>";
     }
	 return $this->objet;
	
  }

  function addLog($chaine)
  {
    $this->log=false;	
    if (file_exists('sql_log.txt'))
    {
      if (filesize('sql_log.txt')>100000)
      {
        unlink('sql_log.txt');
      }
    }
    $file=fopen('sql_log.txt',"a");
	fwrite($file,date('Y-m-d H:i:s',time()).' => '.mysqli_error($this->connex)." - ".$_SERVER['PHP_SELF']." - (".$chaine.")\n\r");
	fclose($file);
  }
}
?>
