<?php
/**
 * Main page to manage user stories of a project
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement:ObjectSettings
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  

// Get mode : standard or workshop
if ($_SESSION['mode_pbl']=='std')
{ 
  $itemType='us_project';
}
else
{ 
  $itemType='us_project_workshop';
}
  
// set master item and simple item displayed on board from item type
$masterItemType=getMasterItemType($itemType);
$simpleItemType=getSimpleItemType($itemType);
// gt dashboard settings 
include PATHBASE.'dashboard_settings.php';

// init columns arrays
$arrayStatusX[0]=$columnWidth*0;
$arrayStatus[0]['colName']='Product BackLog';
// Check is at least one column for tasks exists
$request->sqlGet("SELECT column_tag_fk FROM ".PARAM_DB_PREFIX."kados_projects_columns WHERE project_id_fk=".$_SESSION['current_project_id']);
$request->countRows();
if ($request->rowCount!=0)
{
  $arrayStatus[0]['link']='manage_kanban.php?menu_lev2=prj_kanban&project_id='.$_SESSION['current_project_id'].'&board=tasks';
}  
  	
// Set visible Release Array
$visibleReleasesArray[0]=0;
// init invisible columns array
$invisibleColumnsArray=array();

if ($_SESSION['mode_pbl']=='std')
{
  // Get releases to display columns of the dashboard
  $request=new sqlRequest("SELECT release_id,release_name,release_creation_date,release_due_date,
                                  release_project_id_fk,visibility   
                           FROM ".PARAM_DB_PREFIX."kados_releases 
	  	           WHERE release_project_id_fk=".$_SESSION['current_project_id']." 
                           ORDER BY release_due_date",$cnx->num);
  $resultArray=$request->getArrayFields();
  // init counter
  $cpt=1;
  for ($i=0;$i<count($resultArray);$i++)
  {
    // Column width, except if visibility is 0
    if ($resultArray[$i]['visibility'])
    {  
      $arrayStatusX[$resultArray[$i]['release_id']]=$columnWidth*($cpt);
      // store visible release in an array
      $visibleReleasesArray[$cpt]=$resultArray[$i]['release_id'];
      // set column name
      $arrayStatus[$cpt]['colName']=$resultArray[$i]['release_name'].' <span class="small_font">('.format_date($resultArray[$i]['release_due_date']).')</span>';
      // set link to hide column
      $arrayStatus[$cpt]['link2hide']='&action=hide_in_kanban&release2hide='.$resultArray[$i]['release_id'];
      // set column link (drill down)
      $arrayStatus[$cpt++]['link']='manage_kanban.php?menu_lev2=prj_kanban&release_id='.$resultArray[$i]['release_id'];
      
    }
    else
    {    
      // store column invisibility
      $invisibleColumnsArray[]=array('column_id' => $resultArray[$i]['release_id'],'column_position' =>$cpt,'column_type' => 'release','column_name' =>$resultArray[$i]['release_name']);  
    }  
  }
}
else
{
  $columnWidth=getParameter('WSSIZE',$cnx->num);
}

// Prepare a filter for getting only the US of the visible releases
$visibleReleases=implode(',',$visibleReleasesArray);

// allow or not to display buttons for hide or show columns based on  UPD_RELEASE right in profile
$allowShowHideColumns=in_array('UPD_RELEASE',$_SESSION['user_actions']) || in_array('UPD_RELEASE',$_SESSION['user_local_actions']);

// set flag for displaying buttons
$displayTopButtons=true;

// set parameters of dashboard
$allowAdd=in_array('ADD_US',$_SESSION['user_actions']) || in_array('ADD_US',$_SESSION['user_local_actions']);
$targetAdd=PATHBASE.'boards_buttons/add_us.php?item_type='.$itemType.'&us_from='.($itemType=='us_release' ? 'release' : '');
// set Add button parameters
$buttonAdd=$button_add_user_story;
$buttonAddImage='app/new_user_story.png';

// set others buttons
$allowDelete=in_array('DEL_US',$_SESSION['user_actions']) || in_array('DEL_US',$_SESSION['user_local_actions']);
$allowOrder=in_array('ORD_US',$_SESSION['user_actions']) || in_array('ORD_US',$_SESSION['user_local_actions']);
$allowUpdate=in_array('UPD_US',$_SESSION['user_actions']) || in_array('UPD_US',$_SESSION['user_local_actions']);
$allowMove=in_array('MOVE_US',$_SESSION['user_actions']) || in_array('MOVE_US',$_SESSION['user_local_actions']);
// 
$allowActionHeaderStamp=$allowUpdate;

// set display of priority sorting button
$displayPriorityButton=true;
// get from global config if workshop button must be displayed
$displayWorkshopSwitch=getParameter('USEWS',$cnx->num);
// set texts for ordering buttons
$buttonOrder=$button_reorder;
$buttonOrderExtended=$button_reorder_flat;
$buttonSortByPriority=$button_reorder_priority;

// set link to project for postit created on that board
$otherFieldsInsertUS=',us_project_id_fk';
$otherFieldsInsertValuesUS=','.$_SESSION['current_project_id'];

// init static column parameters => for no display
$MultipleItemsArray[0]=array('parent_id'=>0,'name'=>'','header_stamp'=>'','text'=>'','color'=>'');
$firstColumnStatic=false;
// set function used for top right-hand part of the postit => use image for postit status
$functionForHeaderStamp='displayStatusImageButton';

// get specific settings for that board
include PATHBASE.'boards_settings/settings_'.$itemType.'.php';
// generic actions on postit
include PATHBASE.'boards_actions/actions_items.php';
// specific actions on US
include PATHBASE.'boards_actions/actions_us.php';
// display railway
include PATHBASE.'railway_display.php';

// allow filter on US
$showFilterUs=true;
// get dashboard
include PATHBASE.'matrix_display.php';
