<?php
/**
 * Main script to manage items in a dashboard
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */

// settings for board
$dashboardWidth=($columnWidth)*count($arrayStatus)+floor($itemWidth/3);
$simpleItemParentType= isset($simpleItemParentType) ? $simpleItemParentType : 'us';
$stakeholdersProjects = isset($stakeholdersProjects) ? $stakeholdersProjects : array();

// Global Flags
$deckIsAvailable = isset($deckIsAvailable) ? $deckIsAvailable : true;
$displayNoUser = isset($displayNoUser) ? $displayNoUser : false;
$displayMyTasks = isset($displayMyTasks) ? $displayMyTasks : false;

// Flags for buttons
$displayPriorityButton = isset($displayPriorityButton) ? $displayPriorityButton : false;
$displaySortByNumberButton = isset($displaySortByNumberButton) ? $displaySortByNumberButton : true;
$displayBackToRoadmapButton = isset($displayBackToRoadmapButton) ? $displayBackToRoadmapButton : false;
$displayButtonExtraAdd = isset($displayButtonExtraAdd) ? $displayButtonExtraAdd : false;
  
// Flags for Workshop View
$workshopView = isset($workshopView) ? $workshopView : false;
$displayWorkshopSwitch = isset($displayWorkshopSwitch) ? $displayWorkshopSwitch : false;


// Flags for Zones (above each postit)
$displayParentZone = isset($displayParentZone) ? $displayParentZone : true;
$displayWarningZone = isset($displayWarningZone) ? $displayWarningZone : true;

// Flags for first Column (static column)
$firstColumnDisplayParentZone = isset($firstColumnDisplayParentZone) ? $firstColumnDisplayParentZone : false;
$firstColumnDisplayWarningZone = isset($firstColumnDisplayWarningZone) ? $firstColumnDisplayWarningZone : false;
$firstColumnObjectType= isset($firstColumnObjectType) ? $firstColumnObjectType : 'postit';
$firstColumnEnableUpdateFunction= isset($firstColumnEnableUpdateFunction) ? $firstColumnEnableUpdateFunction : false;

// Flags for filters
$showFilterIssue = isset($showFilterIssue) ? $showFilterIssue : false; 
$showFilterUs = isset($showFilterUs) ? $showFilterUs : false;
$showFilterTask = isset($showFilterTask) ? $showFilterTask : false;
$showFilterFeatures = isset($showFilterFeatures) ? $showFilterFeatures : true;
$showFilterUsStatus = isset($showFilterUsStatus) ? $showFilterUsStatus : true;
$showFilterStakeHolders = isset($showFilterStakeHolders) ? $showFilterStakeHolders : true;
$showFilterTags = isset($showFilterTags) ? $showFilterTags : true;
$showFilterSearch['us'] = isset($showFilterSearch['us']) ? $showFilterSearch['us'] : true;
$showFilterSearch['task'] = isset($showFilterSearch['task']) ? $showFilterSearch['task'] : true;

// Flags for messages
$displayProtocolWarningMsg = isset($displayProtocolWarningMsg) ? $displayProtocolWarningMsg :false;
$displayUserWarningMsg = isset($displayUserWarningMsg) ? $displayUserWarningMsg :false;
$displayAttachmentWarningMsg = isset($displayAttachmentWarningMsg) ? $displayAttachmentWarningMsg :'';

// flag for displaying buttons
$allowShowHideColumns = isset($allowShowHideColumns) ? $allowShowHideColumns : false;

// this variable is used to display the Magic Wand for Magic moves
// It must not be displayed if the dashboard is an early dashboard with only one column
$colsMaxNumber = isset($colsMaxNumber) ? $colsMaxNumber : 99;
// Warning message if workshop mode
  if ($displayWorkshopSwitch)
  {
    if ($_SESSION['mode_pbl']=='workshop')
    { ?>
      <div class="MessageBox InformationMessageBox"><?php echo $msg_workshop_mode_is_on;?></div><?php
    }
  }	
/********************** MESSAGES **********************************/
// checl wrong protocol message
if ($displayProtocolWarningMsg)
{ ?>
  <div class="MessageBox WarningMessageBox"><?php echo $msg_protocol_not_allowed.' : '.getParameter('APROTO',$cnx->num);?></div><?php
}
  
// Check attachments message
if ($displayAttachmentWarningMsg!='')
{
  // There is a message regarding attachments
  switch ($displayAttachmentWarningMsg)
  {
    case 'FORMAT_KO':?>
      <div class="MessageBox WarningMessageBox"><?php echo $msg_format_not_allowed.' : '.$codeReturn[1];?></div><?php  
    break;

    case 'SIZE_KO':?>
      <div class="MessageBox WarningMessageBox"><?php echo $msg_size_too_big.' : '.$codeReturn[1];?></div><?php  
    break;
           
    case 'DIRECTORY_KO':?>
      <div class="MessageBox WarningMessageBox"><?php echo $msg_directory_not_created.' : '.$codeReturn[1];?></div><?php  
    break;      
  }     
}
// attachements errors messages
if (isset($filesErrors))
{
  if (count($filesErrors)!=0)
  {?>
    <div class="MessageBox WarningMessageBox"><?php echo $msg_errors_uploading_files.' : '.implode(', ',$filesErrors);?></div><?php      
  }
}
// attachments deletion confirmation messages
if (isset($attachmentDeleteConfirmationMsg))
{
  for($i=0;$i<count($attachmentDeleteConfirmationMsg);$i++)
  {?>
    <div class="MessageBox ConfirmationMessageBox"><?php echo $msg_file_has_been_deleted.' : '.$attachmentDeleteConfirmationMsg[$i];?></div><?php  
  }?>
  <script>$('.ConfirmationMessageBox').delay(<?php echo $delayMsg+1000;?>).slideUp("slow");</script><?php
}
  
// Check message for unknown user
if ($displayUserWarningMsg)
{?>
  <div class="MessageBox WarningMessageBox"><?php echo $msg_unknown_user;?></div><?php    
}?>
<div class="buttonsRow"><?php
// Generic buttons for creating items, cancelling deletion or ordering items 
  if ($displayTopButtons)
  {  
    // if adding is allowed for user, display add button  
    if ($allowAdd)
    {
      displayButton($buttonAdd,'',$targetAdd,'addButtonGeneric tsc_awb_small tsc_awb_blue tsc_flat');	
      if ($displayButtonExtraAdd)
      {
        displayButton($buttonExtraAdd,'',$targetExtraAdd,'addButtonGeneric tsc_awb_small tsc_awb_blue tsc_flat');	  
      }   
    }
    // if ordering is allowed for user, display ordering buttons
    if ($allowOrder)
    {
      // display standard ordering buttons  
      // use settings from other scripts or set to default values  
      $targetButtonOrder= isset($targetButtonOrder) ? $targetButtonOrder : $targetFileAction.'&action=order_all_compact';
      $targetButtonOrderExtended= isset($targetButtonOrderExtended) ? $targetButtonOrderExtended : $targetFileAction.'&action=order_all_extended';
      displayButton($buttonOrder,'',$targetButtonOrder,'tsc_awb_small tsc_awb_teal tsc_flat');	
      displayButton($buttonOrderExtended,'',$targetButtonOrderExtended,'tsc_awb_small tsc_awb_teal tsc_flat');
      // display 
      if (isset($buttonSortByPriority) || $displaySortByNumberButton)
      {
        displayButton($button_sorting,'','javascript:showHideOrderButtons()','tsc_awb_small tsc_awb_silver tsc_flat');		 
      }?>
      <div id="orderButtons" style="display:none"><?php
      // order by priority is not always display, it has a specific variable for choosing display
      if (isset($buttonSortByPriority))
      {
        displayButton($buttonSortByPriority,'',$targetFileAction.'&action=order_all_priority','tsc_awb_small tsc_awb_silver tsc_flat');	
        displayButton($button_sort_by_complexity,'',$targetFileAction.'&action=order_all_complexity','tsc_awb_small tsc_awb_silver tsc_flat');
        displayButton($button_sort_by_complexity_desc,'',$targetFileAction.'&action=order_all_complexity_desc','tsc_awb_small tsc_awb_silver tsc_flat');
        displayButton($button_sort_by_business_value,'',$targetFileAction.'&action=order_all_business_value','tsc_awb_small tsc_awb_silver tsc_flat');	
        displayButton($button_sort_by_business_value_desc,'',$targetFileAction.'&action=order_all_business_value_desc','tsc_awb_small tsc_awb_silver tsc_flat');	
      }	
      // Display specific button for ordering by number (it will cancel the user selected order for postit)
      if ($displaySortByNumberButton)
      {
        displayButton($button_sort_by_number,'',$targetFileAction.'&action=order_all_by_number','tsc_awb_small tsc_awb_silver tsc_flat');	          
        displayButton($button_sort_by_number_desc,'',$targetFileAction.'&action=order_all_by_number_desc','tsc_awb_small tsc_awb_silver tsc_flat');	
      }  ?>
      </div><?php
    }	
  }	
  // Button to display Workshop board
  if ($displayWorkshopSwitch)
  {
    // Workshop display situation is managed by a session variable  
    if ($_SESSION['mode_pbl']=='workshop')
    {
      displayButton($button_switch_to_std,'',$targetFileAction.'&mode_pbl=std','tsc_awb_small tsc_awb_purple tsc_flat');	
    }
    else	
    {
      displayButton($button_switch_to_workshop,'',$targetFileAction.'&mode_pbl=workshop','tsc_awb_small tsc_awb_pink tsc_flat');
    }
  }
  // Button for displaying priority on each postit (when computation is possible)
  if ($displayPriorityButton)
  {
    // session var managed the situation for displaying the correct button   
    if ($_SESSION['display_priority']=='block')
    {
      displayButton($button_hide_priority,'','javascript:hidePriority()','tsc_awb_small tsc_awb_orange tsc_flat','buttonPriority');	
    }
    else	
    {
      displayButton($button_show_priority,'','javascript:showPriority()','tsc_awb_small tsc_awb_yellow tsc_flat','buttonPriority');	
    }
  }
  // check if button back to roadmap is necessary
  if ($displayBackToRoadmapButton)
  {
    displayButton($button_back_to_roadmap,'',$targetFile,'tsc_awb_small tsc_awb_gray tsc_flat');	  
  }  ?>
</div>
    <div class="clearleft"></div><?php
  // Filter buttons on issues
  if ($showFilterIssue)
  {
    $shortItemType='issue';
    include PATHBASE.'filters/filter_note_color.php';
  }  
  // if filter allowed on US, display color filter
  if ($showFilterUs)
  {
    $shortItemType='us';
    include PATHBASE.'filters/filter_note_color.php';
  }
  // filters on features
  include PATHBASE.'filters/filter_features.php';
  // display filter switch for displaying closed US or not
  include PATHBASE.'filters/filter_status_us.php';  
  // display search on us text
  $searchTextFilterItem='us';
  include PATHBASE.'filters/filter_search_text.php';
  $tagFilterItem='us';
  include PATHBASE.'filters/filter_tags.php';  ?>
  <div class="clearleft"></div><?php  
  
  // tasks filters
  if ($showFilterTask)
  {
    $shortItemType='task';
    // filter on tasks
    if (isset($_SESSION['filter_task']))
    {
      $specialClause=" AND ".PARAM_DB_PREFIX."kados_tasks.color='".$_SESSION['filter_task']."'";	
    }  
    include PATHBASE.'filters/filter_note_color.php';
  }
  // display task stakeholders filter
  include PATHBASE.'filters/filter_stakeholders.php';
  // display search filter on task only if tasks dashboard
  if ($simpleItemType=='task')
  {
    $searchTextFilterItem='task';
    include PATHBASE.'filters/filter_search_text.php';
  }
  // tag filers on tasks
  if ($simpleItemType=='task')
  {
    $tagFilterItem='task';  
    include PATHBASE.'filters/filter_tags.php';  
  } ?>
  <div class="clearleft"></div>

<div style="width:<?php echo ($firstColumnStatic ? $dashboardWidth+$columnWidthSingle+10 : $dashboardWidth);?>px;position:relative;z-index:1;margin-top:5px;">
<div class="poof"></div> 
<span class="columnWidth"><?php echo $columnWidth;?></span>	
<span class="itemWidth"><?php echo $itemWidth;?></span>	
<span class="xInitDefaultPosition"><?php echo $xInitDefaultPosition;?></span>	
<span class="itemType"><?php echo $itemType;?></span>
<span class="masterItemType"><?php echo $masterItemType;?></span>
<span class="hidden-targetFile"><?php echo $targetFile;?></span>
<span class="hidden-allowUpdate"><?php echo $allowUpdateUS;?></span>
<span class="hidden-pathBase"><?php echo PATHBASE;?></span>
<span class="dashboardType"><?php echo (count($MultipleItemsArray)>1 ? 'multiple' : 'simple');?></span>
<?php
// Set a boucle on the list of items needing a dashboard
// It may be only one (simple dashboard) or multiple items
// init a comment object
$commentObject=new comment($cnx->num);
// init a relationship object
$relationshipObject=new relationship($cnx->num);
// init user object
$userObject=new appUser($cnx->num,$_SESSION['login']);

for ($k=0;$k<count($MultipleItemsArray);$k++)
{
  $activateParentZone=false;
  $activateWarningZone=false;
  // include a dashboard instance
  $parentId=$MultipleItemsArray[$k]['parent_id'];
  $clauseWhereElementsGetAllStd=$clauseWhereElementsGetAll;
  if ($parentId)
  {
    $clauseWhereElementsGetAllStd.=' AND '.$parentRefId.'='.$parentId;
  }	

  // Set the display of board Titles only for the first line
  $displayDashBoardTitles= $k==0 ? true : false;
  // If set, force the display of board titles on all lines
  if (isset($forceDisplayDashBoardTitles))
  {
    $displayDashBoardTitles=$forceDisplayDashBoardTitles;
  }
  // compute dashboard Height from the max number of item in a column
  $request=new sqlRequest("SELECT MAX(nb_item) AS max_item 
                        FROM (SELECT COUNT(*) AS nb_item,".$managedField." 
                              FROM ".$tableData." 
                              WHERE active=1 ".$clauseWhereElementsGetAllStd." 
                              GROUP BY ".$managedField.') count_table',$cnx->num);
  $objectCounter=$request->getObject();
  // Compute max ypos of items to choose the best height versus number of items * itemHeight
  $request->sqlGet("SELECT MAX(".$yPosField.") AS max_ypos FROM ".$tableData." WHERE active=1 ".$clauseWhereElementsGetAllStd);
  $objectMaxY=$request->getObject();  
  if ($_SESSION['mode_pbl']=='workshop' && $workshopView)
  {
	$columnsOfPostit=floor($columnWidth/($itemWidth+10));
	$dashboardHeight=max($usBlockMinHeight,100+$itemHeight+max($itemHeight*$objectCounter->max_item/$columnsOfPostit,$objectMaxY->max_ypos));
  }
  else
  {
    $dashboardHeight=max($usBlockMinHeight,90+$itemHeight+$objectMaxY->max_ypos);
  }  

  // set if there must be a first column just before each dashboard with static data 
  // (maybe a parent object of those manipulated in the dashboard)
  if ($firstColumnStatic)
  {
    $shiftPostitYpos=0;?>
    <!-- display the backlog in a column (static notes) !-->
    <div class="main_matrix" style="width:<?php echo $columnWidthSingle;?>px;height:<?php echo $dashboardHeight;?>px;z-index:12">
      <a class="block" name="Block<?php echo $k;?>"></a>	
      <span class="sprintBacklog" style="width:<?php echo $columnWidthSingle;?>px;height:<?php echo $dashboardHeight;?>px"><?php
      if ($displayDashBoardTitles)
      {?>
        <span class="colHeader" style="width:<?php echo $columnWidthSingle;?>px"><?php 
          // display column title if project od not one level
          if (($currentProject->level!=1 && $masterItemType=='us') || $masterItemType!='us')
          {
            echo $firstColumnTitle;
          }  ?>
        </span><?php
      }
      if ($firstColumnObjectType=='postit')
      {
	$parentZoneData=array();
	$warningZoneData=array();
        if ($masterItemType=='us')
        {
	  if ($firstColumnDisplayWarningZone)
	  {
	    $request->sqlGet("SELECT issue_id,issue_type,impact,issue_number,probability,text,status 
	                     FROM ".PARAM_DB_PREFIX."kados_issues 
	                     WHERE active=1 AND issue_us_id_fk=".$MultipleItemsArray[$k]['parent_id']);
            $warningZoneData=$request->getArrayFields();
	    $shiftPostitYpos= count($warningZoneData)!=0 ? 20 : 0;
	  }  
	  if ($firstColumnDisplayParentZone)
	  {
	    // Parent zone may be activated if link with an US
	    $request->sqlGet("SELECT us_feature_id_fk 
	                     FROM ".PARAM_DB_PREFIX."kados_user_stories 
	                     WHERE active=1 AND us_id=".$MultipleItemsArray[$k]['parent_id']);
            $linkedFeatureData=$request->getArrayFields();
		  
	    $request->sqlGet("SELECT feature_short_label,feature_description,feature_name 
	                     FROM ".PARAM_DB_PREFIX."kados_features 
	                     WHERE feature_id=".$linkedFeatureData[0]['us_feature_id_fk']);
	    $parentZoneData=$request->getArrayFields();
            if ($shiftPostitYpos==0)
	    {
	      $shiftPostitYpos= count($parentZoneData)!=0 ? 20 : 0;			  
	    }		
          }			
	}
	else if ($masterItemType=='issue')
        {
	  if ($firstColumnDisplayParentZone)
	  {
	    $request->sqlGet("SELECT issue_us_id_fk,issue_type 
	                     FROM ".PARAM_DB_PREFIX."kados_issues 
	                     WHERE active=1 AND issue_id=".$MultipleItemsArray[$k]['parent_id']);
            $linkedIssueData=$request->getArrayFields();
	    $request->sqlGet("SELECT us_number,us_id,status,business_value,text 
	                     FROM ".PARAM_DB_PREFIX."kados_user_stories 
	                     WHERE active=1 AND us_id=".$linkedIssueData[0]['issue_us_id_fk']);
            $parentZoneData=$request->getArrayFields();
            $parentZoneData[0]['issue_type']=$linkedIssueData[0]['issue_type'];
            if ($shiftPostitYpos==0)
	    {
	      $shiftPostitYpos= count($parentZoneData)!=0 ? 20 : 0;			  
	    }
          }  
	}	
        
        // postit infos
        $postitInfos='';			
        if ($MultipleItemsArray[$k]['creator']!='')
        {  
          $postitInfos=$text_created_on_m.format_date(dateFromDatetime($MultipleItemsArray[$k]['creation_date'])).' ';
          $postitInfos.=$text_by.' '.getUserName($MultipleItemsArray[$k]['creator']).'<br />';
          $postitInfos.=$text_last_updated_on_m.format_date(dateFromDatetime($MultipleItemsArray[$k]['last_update'])).' ';  
          $postitInfos.=$text_by.' '.getUserName($MultipleItemsArray[$k]['last_updater']).'<br />';
        }        
        
        // get Tags for the postit
        $request->sqlGet("SELECT tag_id,tag_label,tag_color,tag_group_id_fk
                          FROM ".PARAM_DB_PREFIX."kados_tags,".PARAM_DB_PREFIX."kados_tags_postit
		          WHERE tag_id_fk=tag_id AND postit_id_fk=".$MultipleItemsArray[$k]['parent_id']."
			    AND postit_type='".strtoupper($masterItemType)."'");
        $postitTagsList=$request->getArrayFields();        
        
        // compute display for zones		
        if (count($parentZoneData)!=0)
	{
	  if (file_exists(PATHBASE.'parent_zone_'.$masterItemType.'.php'))
	  {
	    require PATHBASE.'parent_zone_'.$masterItemType.'.php';
	  }
	}  
	if (count($warningZoneData)!=0)
	{
	  if (file_exists(PATHBASE.'warning_zone_'.$masterItemType.'.php'))
	  {
	    require PATHBASE.'warning_zone_'.$masterItemType.'.php';
	  }
        }?>
	<div class="note_static <?php echo $MultipleItemsArray[$k]['color'];?>" id="note_static<?php echo $MultipleItemsArray[$k]['parent_id'];?>" style="cursor:auto;width:<?php echo $itemWidth;?>px;height:<?php echo $itemHeight;?>px;left:20px;top:<?php echo ($displayDashBoardTitles ? 60 : 35)+$shiftPostitYpos;?>px;z-index:1">
	<div class="upper-header" style="width:<?php echo $itemWidth;?>px;">
	<!-- The PARENT ZONE --><?php
	if ($activateParentZone)
	{?>
	  <div class="parent_zone"><?php echo $parentZoneDisplay;?></div><?php
	}?>  
	<!-- The WARNING ZONE --><?php
     	if ($activateWarningZone)
	{?>
	  <div class="warning_zone"><?php echo $warningZoneDisplay;?></div><?php		
	}  ?>	
        </div>		
	<div class="item-header"> <?php 
         if ($firstColumnEnableUpdateFunction) { ?><span class="editspan bloc-header"><a href="<?php echo PATHBASE;?>boards_buttons/update_<?php echo $simpleItemParentType;?>.php?item_id=<?php echo $MultipleItemsArray[$k]['parent_id'];?>&item_type=us_project&blockId=<?php echo $k;?>" class="ulbtn"><img src="<?php echo $pathImages;?>app/update.png" border="0" /></a></span><?php }?>
         
	  <span class="deckAdd"><?php
  	   if ($deckIsAvailable)
	   {?>
	     <a href="<?php echo $targetFileAction.'&add_to_deck='.$MultipleItemsArray[$k]['parent_id'];?>" ><img src="<?php echo $pathImages.'app/minus_grey.png';?>" border="0"></a><?php
           }  ?>
	  </span> <?php
          // if there is some postit infos
                  if ($postitInfos!='')
		  {
                    // if postit is US or task, display history dialog  
                    if ($simpleItemType=='task')
                    {?>
                    <span class="postit_details bloc-header historyButttonMatrix" style="cursor:pointer"><img src="<?php echo $pathImages;?>app/history.png" border="0" /></span>	<?php
                    }
                    else
                    {?>
                      <span class="postit_details bloc-header"><img src="<?php echo $pathImages;?>app/history.png" border="0" tooltip="<?php echo changeDoubleQuote($postitInfos);?>" /></span>	<?php
                    }
                  }?>	         
	  <span class="postit_id bloc-header"><?php echo $firstColumnObjectTag.$MultipleItemsArray[$k]['display_number'];?></span>
	  <span class="postit_header-right"><?php 
	    if (isset($firstColumnFunctionForHeaderStamp))
	    {
	      call_user_func($firstColumnFunctionForHeaderStamp,array($MultipleItemsArray[$k]['parent_id'],$MultipleItemsArray[$k]['header_stamp'],$allowUpdateUS,$k)); 
	    }
            else
            {
              echo htmlspecialchars($MultipleItemsArray[$k]['header_stamp']);
            }?>
          </span>		  
	 </div>
	 <div class="postit_text_static" style="width:<?php echo ($itemWidth-$itemWidthBodyMargin);?>px;height:<?php echo ($itemHeight-$itemHeightBodyMargin);?>px;"><?php echo make_clickable(nl2br(htmlspecialchars($MultipleItemsArray[$k]['text'])));?></div>
	 <div class="item-footer">
	    <span class="postit_footer-left"><?php 
	    if (isset($MultipleItemsArray[$k]['infoBottomLeft']))
	    {
	      if (isset($firstColumnFunctionForBottomLeft)) 
	      { 
	        call_user_func($firstColumnFunctionForBottomLeft,$MultipleItemsArray[$k]['infoBottomLeft']);
	      }
	      else
	      {
	        echo $MultipleItemsArray[$k]['infoBottomLeft'];
	      }
	    } ?>			
            </span><?php
            // if postit is US, display footer items : link, rss, and attachments
            if ($masterItemType=='us')
            {
                $linkExists= isset($MultipleItemsArray[$k]['link']) ? ($MultipleItemsArray[$k]['link']!='' ? true : false ) : false;  ?>             
	      <span class="postit_footer-center1" style="position:relative;left:<?php echo (round($itemWidth/2,0)-15);?>px;top:2px;"><?php
                // If a link exists, display a small icon to go to the link target
 	        if ($linkExists)
		{
                  $linkForPostIt=$MultipleItemsArray[$k]['link'];  
                  // with a regex, check that link start with a protocol else add http://
                  if (!preg_match('/^('.getParameter('APROTO',$cnx->num).'):\/\/[^ "]+$/',$MultipleItemsArray[$k]['link']))
                  {  
                    $linkForPostIt="http://".$linkForPostIt;
                  }?>
		  <a href="<?php echo $linkForPostIt;?>" target="_ext"><img src="<?php echo $pathImages;?>app/link.png" title="<?php echo $MultipleItemsArray[$k]['link'];?>" border="0" /></a><?php
                } 
                
                // If there is any files attached to the postit, display an icon to open the files list
                $filesDirectoryName=getParameter('FLPATH',$cnx->num).'/'.strtoupper($masterItemType).'/'.strtoupper($masterItemType).$MultipleItemsArray[$k]['parent_id'];
                
                if (is_dir($filesDirectoryName))
                {
                  // scan directory to get files  
                  $attachmentFilesList=scandir($filesDirectoryName);
                  // check if there is more than 4 entries in the directory : ., .. , index.php and .htaccess at least
                  if (count($attachmentFilesList)>4)
                  {?>
                  <span class="attachments_icon attachementsButtonMatrix" style="cursor:pointer"><img src="<?php echo $pathImages;?>app/attached.png" title="" border="0" /></span> <?php     
                  }
                }                
                // RSS display icon
                if ($masterItemType=='us' && getParameter('RSSACT',$cnx->num))
                {?>  
                  <span style="padding-top:2px;"><a target="_ext_rss" href="rss.php?us_id=<?php echo $MultipleItemsArray[$k]['parent_id'];?>&language=<?php echo $_SESSION['language'];?>&token=<?php echo $currentProject->rssKey;?>"><img src="<?php echo $pathImages;?>app/small_rss.png"/></a></span><?php
                }?>
              </span><?php
              }?> 
             
	    <span class="postit_footer-right"><?php 
	    if (isset($MultipleItemsArray[$k]['infoBottomRight']))
	    {
	      if (isset($firstColumnFunctionForBottomRight)) 
	      { 
	        call_user_func($firstColumnFunctionForBottomRight,$MultipleItemsArray[$k]['infoBottomRight']);
	      }
	      else
	      {
	        echo $MultipleItemsArray[$k]['infoBottomRight'];
	      }
	    } ?>
	   </span>
	 </div>	<?php
	  // display tags if postit are US or TASKS 
	  if ($masterItemType=='us' && $currentProject->paramUseTags)
	  {
            // reinit tags ID table  
	    unset($postitTagsListIds);
            // reinit list of groups used by the postit
            unset($postitTagsGroups);
            $postitTagsListIds=array();
            $postitTagsGroups=array();
	    // TAGS of the Postit, follow the list of tags
	    for ($nbtags=0;$nbtags<count($postitTagsList);$nbtags++)
            {
	      // add to local postit tags table
	      $postitTagsListIds[]=$postitTagsList[$nbtags]['tag_id'];
              // add group in the array, if it is not empty 
              if (intval($postitTagsList[$nbtags]['tag_group_id_fk'])!=0 && !in_array($postitTagsList[$nbtags]['tag_group_id_fk'],$postitTagsGroups))
              {
                $postitTagsGroups[]=$postitTagsList[$nbtags]['tag_group_id_fk'];
              }    
	      // display tag if it has just been created
              // default is none
	      $tagDisplay='display:none;';
              // display the tag on the postit?>
	      <div class="tag-zone-out <?php echo $postitTagsList[$nbtags]['tag_color'];?>" style="left:<?php echo $itemWidth;?>px;top:<?php echo 22+$nbtags*22;?>px;"></div>			
	      <div class="tag-zone <?php echo $postitTagsList[$nbtags]['tag_color'];?>" style="left:<?php echo $itemWidth;?>px;top:<?php echo 22+$nbtags*22;?>px;<?php echo $tagDisplay;?>">
                <?php echo $postitTagsList[$nbtags]['tag_label']; ?>
	      </div><?php
            }
	  }
          // display comments 
          // display comments if postit are US or TASKS 
	  if ($masterItemType=='us')
	  {?>
	    <div class="comment-zone commentsButtonMatrix" style="left:-16px;top:2px;cursor:pointer;">
	      <img src="<?php echo $pathImages;?>app/comment.png" />
 
            <div class="new-comment-zone" style="left:-1px;top:-3px;"><?php
            $newCommentForUser=$commentObject->getPostitHasNewComment($MultipleItemsArray[$k]['parent_id'],$masterItemType,$userObject->getUserPreviousLoginDate(),$_SESSION['login']);
              if ($newCommentForUser[1]!=0)
              {?>
                <img src="<?php echo $pathImages;?>app/newCommentUser.png" /><?php
              }
              else if ($newCommentForUser[0]!=0)
              {?>
                <img src="<?php echo $pathImages;?>app/newComment.png" /><?php
              }     ?>  
            </div>  <?php
            // Number of comments 
            $countComment=$commentObject->getPostitCommentsCount($MultipleItemsArray[$k]['parent_id'],$masterItemType);?>
            <div class="comment-counter-zone" id="comments_master_counter_<?php echo $MultipleItemsArray[$k]['parent_id'];?>" style="left:<?php echo ($countComment>9 ? '0' : '4');?>px;top:16px;"><?php echo $countComment;?></div>
	    </div>     <?php
          } 
              
          // if postit are US, display relationships to US
	  if ($masterItemType=='us')
	  {
            // set US fro relationship computing
            $relationshipObject->setFirstUs($MultipleItemsArray[$k]['parent_id']);  
            // display relationships if postit are US                             ?>
	    <div class="relationship-zone relationshipsButtonMatrix" style="left:-16px;top:42px;cursor:pointer;">
	      <img src="<?php echo $pathImages;?>app/related.png" />   <?php
            // Number of relationships
            $countRel=$relationshipObject->getUsRelationshipsCount();?>
            <div class="relationship-counter-zone" id="relationships_master_counter_<?php echo $MultipleItemsArray[$k]['parent_id'];?>" style="left:<?php echo ($countRel>9 ? '0' : '4');?>px;top:16px;"><?php echo $countRel;?></div>
            </div> <?php
          }?>                  
          <span class="hidden-itemId"><?php echo $MultipleItemsArray[$k]['parent_id'];?></span>
       </div><?php // end of postit note (static)
      }
      else
      {?> 
	<div class="firstColumnInfo" style="left:14px;top:<?php echo ($displayDashBoardTitles ? 60 : 35);?>px;z-index:1"><?php 
        echo make_clickable(nl2br(htmlspecialchars($MultipleItemsArray[$k]['text'])));?>
	</div><?php
      }?>
	    <span class="hidden-item"><?php echo $MultipleItemsArray[$k]['parent_id'].':'.($displayDashBoardTitles ? 30 : 5);?></span>
	    <div class="add_task_button" style="width:<?php echo $columnWidthSingle;?>px;top:<?php echo ($displayDashBoardTitles ? 23 : -2);?>px"><?php
		 if ($allowAddInFirstColumn)
		 {  
		   $target=PATHBASE.'boards_buttons/add_'.$simpleItemType.'.php?object_id='.$MultipleItemsArray[$k]['parent_id'].'&item_type='.$itemType.'&blockId='.$k;
		   displayButtonImg($buttonAdd,$pathImages.$buttonAddImage,$target,'addButtonGeneric');	
		 }
		 if ($allowOrder)
		 {
		   $target=$targetFileAction.'&action=order_all_compact&object_id='.$MultipleItemsArray[$k]['parent_id'].'&ypos_ref='.($displayDashBoardTitles ? 30 : 5).'&a='.md5(time()).'#Block'.$k;
		   displayButtonImg($buttonOrder,$pathImages.'app/compress.png',$target,'');			 
		   $target=$targetFileAction.'&action=order_all_extended&object_id='.$MultipleItemsArray[$k]['parent_id'].'&ypos_ref='.($displayDashBoardTitles ? 30 : 5).'&a='.md5(time()).'#Block'.$k;
		   displayButtonImg($buttonOrderExtended,$pathImages.'app/expand.png',$target,'');			 		   
		   $target=$targetFileAction.'&action=order_all_by_number&object_id='.$MultipleItemsArray[$k]['parent_id'].'&ypos_ref='.($displayDashBoardTitles ? 30 : 5).'&a='.md5(time()).'#Block'.$k;
		   displayButtonImg($button_sort_by_number,$pathImages.'app/order.png',$target,'');	
                   if ($colsMaxNumber!=1 && $simpleItemType=='task')
                   {     
		     $target=PATHBASE.'boards_buttons/magic_moves_'.$simpleItemType.'.php?object_id='.$MultipleItemsArray[$k]['parent_id'].'&item_type='.$itemType.'&blockId='.$k;
		     displayButtonImg($button_tasks_actions,$pathImages.'app/copy-move.png',$target,'addButtonGeneric');			 		                      
                   }
		 }?> 
	    </div>
      </span>
    </div> <?php
  }   // end of static first column

  include PATHBASE.'dashboard_display.php';
    
}?>
</div>