<?php
/**
 * Popup to display relationships
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */    
define("PATHBASE",'./');
$pathClasses=PATHBASE.'libraries/classes/';
$pathCommons=PATHBASE.'common_scripts/';  
$pathAppClasses=PATHBASE.'classes/';
$pathImages=PATHBASE.'images/';

$targetFile='';

require_once PATHBASE.'popin_includes_presession.php';

if (isset($_SESSION['login']))
{
  require_once PATHBASE.'popin_includes.php';
  require_once $pathClasses.'class_sortColumn.php';
  require_once $pathCommons.'date_hour.php';
  require_once $pathAppClasses.'project.php';
  require_once $pathAppClasses.'history.php';  
  require_once $pathAppClasses.'relationship.php';
  // create relationship object
  $postitRelationships=new relationship($cnx->num);
  // set mode (Read/Write)
  $allowManageRelationShip = in_array('UPD_US',$_SESSION['user_actions']) || in_array('UPD_US',$_SESSION['user_local_actions']);
  // set master object 
  $masterObject = isset($_GET['l']) ? 'master_' : '';  
  // get current project Data
  $currentProject=new project($cnx->num,$_SESSION['current_project_id']);
  $currentProject->getData();  ?>

<html>
    <head>
    </head>
    <body><?php
  // set current US 
  $postitRelationships->setFirstUs(intval($_GET['i']));     
  // get relationship
  $relationshipsList=$postitRelationships->getUsRelationships();  
  // if any relationship, get US text and status
  if (count($relationshipsList)!=0)
  {
    $request= new sqlRequest("SELECT text,status,us_number,us_id FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE us_id IN(".implode(',', array_column($relationshipsList,'us_id')).")",$cnx->num);
    $usList=$request->getArrayFields();?>    
        
    <table class="zebraTable">
      <tr>
         <th></th>  
         <th><?php echo $text_us; ?></th> 
         <th><?php echo $text_status;?></th>
         <th></th>
      </tr><?php

    // set orderby     
    //$postitHistory->setOrderBy($sortColumn->returnSqlOrderBy());
    // get history
    for ($i=0;$i<count($usList);$i++)
    { ?>
         <tr>
           <td>US<?php echo $usList[$i]['us_number'];?></td>  
           <td><?php echo $usList[$i]['text'];?></td>
           <td><?php echo $usStatusTable[$usList[$i]['status']];?></td>
           <td><?php
           // if right is OK, display form
             if ($allowManageRelationShip)
             {?>
               <img src="<?php echo $pathImages;?>delete.png" id="removeRelationship_<?php echo  $usList[$i]['us_id'];?>" class="removeRelationship" /><?php
             }?>
           </td>    
         </tr><?php
    }?>
    </table>   <?php
  }
  else
  {
    echo $text_no_relationships;
  }?>
  
        
<div class="MessageBox WarningMessageBox hidden-div" id="MsgWarning"><?php echo $msg_fill_in_a_relationship;?></div>    <?php        
  
// if write mode, display form
if ($allowManageRelationShip)
{  
  // Set initial scope as minimum scope and get linked US
  // The initial scope is the lower level of project
  $displaySprintChoice=false;
  $displayReleaseChoice=false;
    
  $scope=' us_project_id_fk='.$_SESSION['current_project_id'];
  if (isset($_SESSION['current_release_id'])) 
  {
    $scope=' us_release_id_fk='.$_SESSION['current_release_id'];
    $displayReleaseChoice=true;
  }
  if (isset($_SESSION['current_sprint_id']))
  {
    $scope=' us_sprint_id_fk='.$_SESSION['current_sprint_id'];
    $displaySprintChoice=true;
  }
  // get list of US from the same release
  // build array with US to ignore (the current one and those already in relation to the current one
  $ignoredUs= array_merge(array(intval($_GET['i'])), array_column($relationshipsList,'us_id'));
  $request=new sqlRequest("SELECT us_id,".PARAM_DB_PREFIX."kados_user_stories.text,us_number FROM ".PARAM_DB_PREFIX."kados_user_stories 
                           WHERE ".PARAM_DB_PREFIX."kados_user_stories.active=1 
                             AND us_id NOT IN(".implode(',',$ignoredUs).") 
	                     AND ".$scope,$cnx->num);
  $listUs=$request->getArrayFields();  ?>        
<br/>
<form class="pure-form pure-form-aligned" action="<?php echo $targetFile;?><?php echo (isset($_REQUEST['blockId']) ? '&a='.md5(time()).'#Block'.$_REQUEST['blockId'] : '');?>" method="post" name="form_copy_tasks" enctype="multipart/form-data">
      <fieldset class="fieldset">
     <legend class="legend"><?php echo $legend_adding_f.' '.lcfirst($text_relationships);?></legend>
<input type="hidden" id="item_id" value="<?php echo $_GET['i'];?>" />
<label class="label"><?php echo $text_search_scope;?></label> <?php 

if ($currentProject->level==3 && $displaySprintChoice) 
{?>
  <input type="radio" class="action_scope" name="action_scope" id="sprint" value="sprint" checked="checked"><label for="sprint"><?php echo $text_sprint;?></label><?php
}
if ($currentProject->level>1 && $displayReleaseChoice) 
{?>
  <input type="radio" class="action_scope" name="action_scope" id="release" value="release"  <?php if ($currentProject->level==2 || !$displaySprintChoice) {echo 'checked="checked"';}?>><label for="release"><?php echo $text_release;?></label><?php
}?>
<input type="radio" class="action_scope" name="action_scope" id="project" value="project" <?php if ($currentProject->level==1 || !$displayReleaseChoice) {echo 'checked="checked"';}?>><label for="project"><?php echo $text_project;?></label>
<br />

<label class="label"><?php echo $text_source_user_story;?></label>
<select name="form_item_relationship" id="form_item_relationship">
  <option value="0"></option><?php
  for ($i=0;$i<count($listUs);$i++)
  {?>
    <option value="<?php echo $listUs[$i]['us_id'];?>" >US<?php echo $listUs[$i]['us_number'].':'.substr($listUs[$i]['text'],0,60);?></option><?php
  }?>
</select><div class="clearleft"></div>

<br />
<div id="addRelationship" class="tsc_awb_medium tsc_awb_green tsc_flat"><?php echo $button_submit;?></div>
      </fieldset>
</form>
    
    <script>
    $('input').customInput();
        
    $('input[name=action_scope]:radio').live('change', function() { 
        $('#form_item_relationship').html('');
        
        $.post('xmlhttprequest/get_us_to_link.php',{scope:$(this).attr('value'),us_id:<?php echo intval($_GET['i']);?>},function(msg)
        {
	  if(msg!='')
	  {
            var AnswerObject=jQuery.parseJSON(msg);  
            $('#form_item_relationship').html('');
            var us_list_content='<option value="0"></option>';
            for (i=0;i<AnswerObject.length;i++)
            {
              us_list_content+='<option value="'+AnswerObject[i].us_id+'">'+AnswerObject[i].us_text+'</option>';
            }
            $('#form_item_relationship').html(us_list_content);
          } 
	});         
        
    });

    </script>    <?php
  }?>


    <div class="hidden-div" id="reloadDialog" onclick="$(this).parent().load('postit_relationships.php?i=<?php echo $_GET['i'];?>');"></div>
    <script>
    $('#addRelationship').click(function(){
      if ($('#form_item_relationship  option:selected').text()!='')
      {
        $.post('<?php echo PATHBASE;?>xmlhttprequest/add_relationship.php',{us_id:<?php echo $_GET['i'];?>,us_target:$('#form_item_relationship').val()},function(msg){
          if(msg=='OK')
          {
            // update count of relatiuonships in the current US
            var count=parseInt($('#relationships_<?php echo $masterObject;?>counter_<?php echo intval($_GET['i']);?>').html());
            count++;
            $('#relationships_<?php echo $masterObject;?>counter_<?php echo intval($_GET['i']);?>').html(count);
            if (count==10)
            {
              $('#relationships_<?php echo $masterObject;?>counter_<?php echo intval($_GET['i']);?>').css('left','0');
            }
            // update count of relationships in the target US
            var targetUS=$('#form_item_relationship').val();
            var count=parseInt($('#relationships_<?php echo $masterObject;?>counter_'+targetUS).html());
            count++;
            $('#relationships_<?php echo $masterObject;?>counter_'+targetUS).html(count);
            if (count==10)
            {
              $('#relationships_<?php echo $masterObject;?>counter_'+targetUS).css('left','0');
            }            
            $('#reloadDialog').click();
          }  
	});
      }
      else
      {
         $('#MsgWarning').show();
      }      
    });

    $('.removeRelationship').click(function(){
      var tmp=$(this).attr('id');
      var usTarget=tmp.split('_')[1];
      if (confirm('<?php TextDisplay($msg_confirm_delete_object);?>'))
      {
        $.post('<?php echo PATHBASE;?>xmlhttprequest/remove_relationship.php',{us_id:<?php echo $_GET['i'];?>,us_target:usTarget},function(msg){
          var result=msg.split("_");
          if(result[0]=='OK')
          {
            // update count of relatiuonships in the current US
            var count=parseInt($('#relationships_<?php echo $masterObject;?>counter_<?php echo intval($_GET['i']);?>').html());
            count--;
            $('#relationships_<?php echo $masterObject;?>counter_<?php echo intval($_GET['i']);?>').html(count);
            if (count==10)
            {
              $('#relationships_<?php echo $masterObject;?>counter_<?php echo intval($_GET['i']);?>').css('left','0');
            }
            // update count of relationships in the target US
            var usTarget=parseInt(result[1]);
            var count=parseInt($('#relationships_<?php echo $masterObject;?>counter_'+usTarget).html());
            count--;
            $('#relationships_<?php echo $masterObject;?>counter_'+usTarget).html(count);
            if (count==10)
            {
              $('#relationships_<?php echo $masterObject;?>counter_'+usTarget).css('left','0');
            }            
            $('#reloadDialog').click();
          }  
	});
        }
    });

    </script>
    </body>   
</html>
<?php
}
else
{ ?>
  <script>
    window.location.replace('<?php echo PATHBASE;?>/index.php?warning_message=SESSION_END');
  </script>   <?php
}?>