<?php
/**
 * log data for us progress
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */

if (isset($_SESSION['current_release_id']))
{
  /************* BASELINES ***************************************/
  // list of US in the scope
  $sqlUs2Update="SELECT us_id, us_release_id_fk,us_sprint_id_fk,business_value,complexity,status,us_number 
                 FROM ".PARAM_DB_PREFIX."kados_user_stories  
		 WHERE active=1 
                   AND us_sprint_id_fk IN(SELECT sprint_id 
                                          FROM ".PARAM_DB_PREFIX."kados_sprints 
                                          WHERE sprint_release_id_fk=".$_SESSION['current_release_id'].")";
  // List of US id
  $sqlUs2UpdateSimple="SELECT us_id 
                       FROM ".PARAM_DB_PREFIX."kados_user_stories  
	               WHERE active=1 
                         AND us_sprint_id_fk IN(SELECT sprint_id 
                                                FROM ".PARAM_DB_PREFIX."kados_sprints 
                                                WHERE sprint_release_id_fk=".$_SESSION['current_release_id'].")";
  // get list of US for the scope
  $request->sqlGet($sqlUs2Update);
  $usList=$request->getArrayFields();
	
  // Get baselines for that list of US
  $request->sqlGet("SELECT * 
                   FROM ".PARAM_DB_PREFIX."kados_baselines ref 
                   WHERE us_id_fk IN (".$sqlUs2UpdateSimple.") 
                     AND baseline_date=(SELECT MAX(baseline_date) 
		                        FROM ".PARAM_DB_PREFIX."kados_baselines 
		                        WHERE us_id_fk=ref.us_id_fk) 
		   GROUP BY us_id_fk");	
  $request->getArrayFields();
  $usBaselines=array();

  // get final status for the current project
  $finalStatusTag=getFinalStatus($_SESSION['current_project_id']);
  
  // reorganize the list of baselines
  for ($i=0;$i<$request->rowCount;$i++)
  {
    $usBaselines[$request->array[$i]['us_id_fk']]=$request->array[$i];
  }
	

  // Update baselines (if same date and change), or create if new date and change, else do nothing
  for ($i=0;$i<count($usList);$i++)
  {
    // If baseline exists
    if (isset($usBaselines[$usList[$i]['us_id']]))
    {
      $baseline=$usBaselines[$usList[$i]['us_id']];
      // check if there is any change in US data
      if ($baseline['us_release_id_fk']!=$usList[$i]['us_release_id_fk'] ||
	  $baseline['us_sprint_id_fk']!=$usList[$i]['us_sprint_id_fk'] ||
	  $baseline['us_status']!=$usList[$i]['status'] || 
	  $baseline['us_business_value']!=$usList[$i]['business_value'] ||
	  $baseline['us_complexity']!=$usList[$i]['complexity'] )
      {	
        // then if thre is any change to record, check if baseline exists or if you have to create a new one  
	if ($baseline['baseline_date']==aujourdhui())
	{
          // Baseline  already exists
     	  // update baseline
	  $request->sqlGet("UPDATE ".PARAM_DB_PREFIX."kados_baselines SET
	                       us_release_id_fk=".$usList[$i]['us_release_id_fk'].", 
	                       us_sprint_id_fk=".$usList[$i]['us_sprint_id_fk'].", 
	                       us_business_value=".$usList[$i]['business_value'].", 
	                       us_complexity=".$usList[$i]['complexity'].", 
	                       us_status='".$usList[$i]['status']."' 
	                   WHERE baseline_date='".aujourdhui()."' AND us_id_fk=".$usList[$i]['us_id']);
        }
        else
	{
          // there is no baseline for that US and the current day  
     	  // create baseline
	  $request->sqlGet("INSERT INTO ".PARAM_DB_PREFIX."kados_baselines 
		                 (baseline_date, 
		                 us_id_fk, 
		                 us_release_id_fk, 
		                 us_sprint_id_fk, 
		                 us_business_value, 
		                 us_complexity, 
		                 us_status,
				 us_number) 
		                 VALUES (
				 '".aujourdhui()."',
				 ".$usList[$i]['us_id'].",
				 ".$usList[$i]['us_release_id_fk'].",
				 ".$usList[$i]['us_sprint_id_fk'].",
				 ".$usList[$i]['business_value'].",
				 ".$usList[$i]['complexity'].",
				 '".$usList[$i]['status']."',
				 ".$usList[$i]['us_number'].")");
        }
      }  
    }
    else
    {
      // thre is no baseline at all for that US, start a new one
      // create baseline
      $request->sqlGet("INSERT INTO ".PARAM_DB_PREFIX."kados_baselines 
                                (baseline_date, 
		                 us_id_fk, 
		                 us_release_id_fk, 
		                 us_sprint_id_fk, 
		                 us_business_value, 
		                 us_complexity, 
		                 us_status,
				 us_number) 
		                 VALUES (
				 '".aujourdhui()."',
				 ".$usList[$i]['us_id'].",
				 ".$usList[$i]['us_release_id_fk'].",
				 ".$usList[$i]['us_sprint_id_fk'].",
				 ".$usList[$i]['business_value'].",
				 ".$usList[$i]['complexity'].",
				 '".$usList[$i]['status']."',
				 ".$usList[$i]['us_number'].")");
    }
  }
}