<?php
/**
 * log data for graphs
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */

if (isset($currentSprintId))
{
  // Get sprint info
  $request->sqlGet("SELECT * FROM ".PARAM_DB_PREFIX."kados_sprints WHERE sprint_id=".$currentSprintId);
  $sprintData=$request->getObject();
  // SET counter strings
  $countTasks="SELECT COUNT(task_id) FROM ".PARAM_DB_PREFIX."kados_user_stories,".PARAM_DB_PREFIX."kados_tasks WHERE ".PARAM_DB_PREFIX."kados_user_stories.active=1 AND ".PARAM_DB_PREFIX."kados_tasks.active=1 AND us_id_fk=us_id AND us_sprint_id_fk=".$currentSprintId;
  $countUS="SELECT COUNT(us_id) FROM ".PARAM_DB_PREFIX."kados_user_stories WHERE active=1 AND us_sprint_id_fk=".$currentSprintId;
  $sumLoad="SELECT SUM(task_load) FROM ".PARAM_DB_PREFIX."kados_user_stories,".PARAM_DB_PREFIX."kados_tasks WHERE ".PARAM_DB_PREFIX."kados_user_stories.active=1 AND ".PARAM_DB_PREFIX."kados_tasks.active=1 AND us_id_fk=us_id AND us_sprint_id_fk=".$currentSprintId;
  $sumDone="SELECT SUM(task_done) FROM ".PARAM_DB_PREFIX."kados_user_stories,".PARAM_DB_PREFIX."kados_tasks WHERE ".PARAM_DB_PREFIX."kados_user_stories.active=1 AND ".PARAM_DB_PREFIX."kados_tasks.active=1 AND us_id_fk=us_id AND us_sprint_id_fk=".$currentSprintId;
  $sumRaf="SELECT SUM(task_raf) FROM ".PARAM_DB_PREFIX."kados_user_stories,".PARAM_DB_PREFIX."kados_tasks WHERE ".PARAM_DB_PREFIX."kados_user_stories.active=1 AND ".PARAM_DB_PREFIX."kados_tasks.active=1 AND us_id_fk=us_id AND us_sprint_id_fk=".$currentSprintId;
  
  if ($sprintData->sprint_end_date>=aujourdhui())
  {  
    // Delete all sprints logs done for dates prior to and after the sprint
	$request->sqlGet("DELETE FROM ".PARAM_DB_PREFIX."kados_sprints_progress 
	                 WHERE (log_date<'".$sprintData->sprint_start_date."' 
					 OR log_date>'".$sprintData->sprint_end_date."' ) 
					 AND log_sprint_id_fk=".$currentSprintId);
	// Set DateRef to today or the sprint start date if today is prior to sprint start date
    $dateRef=aujourdhui();
    if ($sprintData->sprint_start_date>aujourdhui())
	{
	  $dateRef=$sprintData->sprint_start_date;
	}
    // log sprint consolidated situation
    $request->sqlGet("SELECT log_sprint_id_fk FROM ".PARAM_DB_PREFIX."kados_sprints_progress WHERE log_date='".$dateRef."' AND log_sprint_id_fk=".$currentSprintId);
	$request->countRows();
	if ($request->rowCount==0)
	{
	  $request->sqlGet("INSERT INTO ".PARAM_DB_PREFIX."kados_sprints_progress 
	                  (log_sprint_id_fk,
					  log_date, 
	                  log_task_count, 
	                  log_us_count, 
	                  log_initial_forecast, 
                  	  log_spent, 
	                  log_new_forecast)
					  VALUES
					  (".$currentSprintId.",
					  '".$dateRef."',
					  (".$countTasks."),
					  (".$countUS."),
					  (".$sumLoad."),
					  (".$sumDone."),
					  (".$sumRaf.")
					  )");
	}
	else
	{

	  $request->sqlGet("UPDATE ".PARAM_DB_PREFIX."kados_sprints_progress SET 
	                  log_task_count=(".$countTasks."),
	                  log_us_count=(".$countUS."),
	                  log_initial_forecast=(".$sumLoad."),
                  	  log_spent=(".$sumDone."),
	                  log_new_forecast=(".$sumRaf.")
					  WHERE log_date='".$dateRef."' AND log_sprint_id_fk=".$currentSprintId);	
	}
  }
  
  // Always check that there is a log for the first day of the sprint.
  // It could create some funny graph, but at least, if the first day of logging is forgotten, the graph will be displayed anyway.
  // Showing the delay
  $request->sqlGet("SELECT log_sprint_id_fk FROM ".PARAM_DB_PREFIX."kados_sprints_progress WHERE log_date='".$sprintData->sprint_start_date."' AND log_sprint_id_fk=".$currentSprintId);
  $request->countRows();
  if ($request->rowCount==0)
  {
	$request->sqlGet("INSERT INTO ".PARAM_DB_PREFIX."kados_sprints_progress 
	                  (log_sprint_id_fk,
					  log_date, 
	                  log_task_count, 
	                  log_us_count, 
	                  log_initial_forecast, 
                  	  log_spent, 
	                  log_new_forecast)
					  VALUES
					  (".$currentSprintId.",
					  '".$sprintData->sprint_start_date."',
					  (".$countTasks."),
					  (".$countUS."),
					  (".$sumLoad."),
					  (".$sumDone."),
					  (".$sumRaf.")
					  )");
  }
}

include PATHBASE.'progress_log.php';?>