<?php
/**
 * Main page to manage user stories of a project
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement:ObjectSettings
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  

// set item
$itemType='us_miniboard';
  
$masterItemType=getMasterItemType($itemType);
$simpleItemType=getSimpleItemType($itemType);
/* set dashboard settings */
include PATHBASE.'dashboard_settings.php';

$arrayStatusX[0]=$columnWidth*0;
$arrayStatus[0]['colName']=$text_subjects_list;
// Check is at least one column for tasks exists
$request->sqlGet("SELECT column_tag_fk FROM ".PARAM_DB_PREFIX."kados_projects_columns WHERE project_id_fk=".$_SESSION['current_project_id']);
$request->countRows();
if ($request->rowCount!=0)
{
  $arrayStatus[0]['link']='manage_kanban.php?menu_lev2=prj_kanban';
}  
  
	
// Set visible Release Array
$visibleReleasesArray[0]=0;

// Prepare a filter for getting only the US of the visible releases
$visibleReleases=implode(',',$visibleReleasesArray);

$columnWidth=($itemWidth+15)*3;

$displayTopButtons=true;

$allowAdd=in_array('ADD_US',$_SESSION['user_actions']) || in_array('ADD_US',$_SESSION['user_local_actions']);
$targetAdd=PATHBASE.'boards_buttons/add_us.php?item_type='.$itemType.'&us_from='.($itemType=='us_release' ? 'release' : '');
$buttonAdd=$button_add_user_story;
$buttonAddImage='app/new_user_story.png';

$allowDelete=in_array('DEL_US',$_SESSION['user_actions']) || in_array('DEL_US',$_SESSION['user_local_actions']);
$allowOrder=in_array('ORD_US',$_SESSION['user_actions']) || in_array('ORD_US',$_SESSION['user_local_actions']);
$allowUpdate=in_array('UPD_US',$_SESSION['user_actions']) || in_array('UPD_US',$_SESSION['user_local_actions']);
$allowMove=in_array('MOVE_US',$_SESSION['user_actions']) || in_array('MOVE_US',$_SESSION['user_local_actions']);
$allowActionHeaderStamp=$allowUpdate;

$displayPriorityButton=TRUE;
$displayWorkshopSwitch=FALSE;
$buttonOrder=$button_reorder;
$buttonOrderExtended=$button_reorder_flat;
$buttonSortByPriority=$button_reorder_priority;

$otherFieldsInsertUS=',us_project_id_fk';
$otherFieldsInsertValuesUS=','.$_SESSION['current_project_id'];

$MultipleItemsArray[0]=array('parent_id'=>0,'name'=>'','header_stamp'=>'','text'=>'','color'=>'');
$firstColumnStatic=false;
$functionForHeaderStamp='displayStatusImageButton';

include PATHBASE.'boards_settings/settings_'.$itemType.'.php';
include PATHBASE.'boards_actions/actions_items.php';
include PATHBASE.'boards_actions/actions_us.php';

$showFilterUs=true;
include PATHBASE.'matrix_display.php';
