<?php
/**
 * Main page to manage user stories of a project
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement:ObjectSettings
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  


define("PATHBASE",'./');
$targetFile='project_features.php?menu_lev2=prj_feature';

$flagCheckCurrentProject=true;
include PATHBASE.'header.php';

  $showOnlyProjectLevel=true;  
  include PATHBASE.'railway_display.php';

  $itemType='us_features';
  
  $masterItemType=getMasterItemType($itemType);
  $simpleItemType=getSimpleItemType($itemType);
  /* set dashboard settings */
  include PATHBASE.'dashboard_settings.php';
  $columnWidth=$itemWidth+40;

  // Set visible Features Array
  $visibleFeaturesArray[0]=0; 
  // Get hidden features for user to hide columns of the dashboard
  $request=new sqlRequest("SELECT feature_id_fk 
                            FROM ".PARAM_DB_PREFIX."kados_users_hidden_features,".PARAM_DB_PREFIX."kados_features
	  		    WHERE feature_project_id_fk=".$_SESSION['current_project_id']." 
                              AND feature_id=feature_id_fk",$cnx->num);  
  $hiddenFeaturesIds=$request->getArrayFirstFieldOnly();
  
  // init invisible columns array
  $invisibleColumnsArray=array();  
  
  $arrayStatusX[0]=$columnWidth*0;
  $arrayStatus[0]['colName']=$text_no_feature;

  // Get features to display columns of the dashboard
  $request=new sqlRequest("SELECT feature_id,feature_short_label,feature_name,feature_description 
                            FROM ".PARAM_DB_PREFIX."kados_features 
	  		    WHERE feature_project_id_fk=".$_SESSION['current_project_id']." 
                            ORDER BY feature_name",$cnx->num);
  $resultArray=$request->getArrayFields();
  $cpt=0;
  for ($i=0;$i<count($resultArray);$i++)
  {
    if (!in_array($resultArray[$i]['feature_id'],$hiddenFeaturesIds))
    {
      // set column width  
      $arrayStatusX[$resultArray[$i]['feature_id']]=$columnWidth*($cpt+1);
      // set column name
      $arrayStatus[$cpt+1]['colName']=$resultArray[$i]['feature_name'];
      // set column tip
      $arrayStatus[$cpt+1]['colMeaning']=$resultArray[$i]['feature_name'].'<br />'.$resultArray[$i]['feature_description'];
      // add the link used to hide the column
      $arrayStatus[$cpt+1]['link2hide']='&action=hide_in_kanban&feature2hide='.$resultArray[$i]['feature_id'];      
      // add feature id to 
      $visibleFeaturesArray[$cpt+1]=(int)$resultArray[$i]['feature_id'];
      $cpt++;
    }
    else
    {
      // store column invisibility
      $invisibleColumnsArray[]=array('column_id' => $resultArray[$i]['feature_id'],'column_position' =>$cpt+1,'column_type' => 'feature','column_name' =>$resultArray[$i]['feature_name']);  
    }
  }

  // Prepare a filter for getting only the US of the visible releases

  $displayTopButtons=true;

  $allowAdd=in_array('ADD_US',$_SESSION['user_actions']) || in_array('ADD_US',$_SESSION['user_local_actions']);
  $targetAdd=PATHBASE.'boards_buttons/add_us.php?item_type='.$itemType.'&us_from='.($itemType=='us_release' ? 'release' : '');
  $buttonAdd=$button_add_user_story;
  $buttonAddImage='app/new_user_story.png';

  $allowDelete=in_array('DEL_US',$_SESSION['user_actions']) || in_array('DEL_US',$_SESSION['user_local_actions']);
  $allowOrder=in_array('ORD_US',$_SESSION['user_actions']) || in_array('ORD_US',$_SESSION['user_local_actions']);
  $allowUpdate=in_array('UPD_US',$_SESSION['user_actions']) || in_array('UPD_US',$_SESSION['user_local_actions']);
  $allowMove=in_array('MOVE_US',$_SESSION['user_actions']) || in_array('MOVE_US',$_SESSION['user_local_actions']);
  $allowActionHeaderStamp=$allowUpdate;
  $allowShowHideColumns=true;

  $displayPriorityButton=true;
  $displayWorkshopSwitch=false;
  $buttonOrder=$button_reorder;
  $buttonOrderExtended=$button_reorder_flat;
  $buttonSortByPriority=$button_reorder_priority;

  $otherFieldsInsertUS=',us_project_id_fk';
  $otherFieldsInsertValuesUS=','.$_SESSION['current_project_id'];

  $MultipleItemsArray[0]=array('parent_id'=>0,'name'=>'','header_stamp'=>'','text'=>'','color'=>'');
  $firstColumnStatic=false;
  $functionForHeaderStamp='displayStatusImageButton';

  $displayParentZone=false;

  include PATHBASE.'boards_settings/settings_'.$itemType.'.php';
  include PATHBASE.'boards_actions/actions_items.php';
  include PATHBASE.'boards_actions/actions_us.php';

  $showFilterUs=true;
  $showFilterFeatures=false;
  include PATHBASE.'matrix_display.php';

include PATHBASE.'footer.php';?>