<?php
/**
 * Main page to manage risks in a dashboard
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  DashBoardItemManagement:ObjectSettings
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  

define("PATHBASE",'./');
$targetFile='project_issues_progress.php?menu_lev2=prj_issues_progress';
	  
include PATHBASE.'header.php';

if (isset($_SESSION['current_project_id']))
{
  $showOnlyProjectLevel=true;  
  include PATHBASE.'railway_display.php';
    
  if (!isset($_REQUEST['object_id'])) 
  {
    $_REQUEST['object_id']=0;
  }

  $itemType='issues_actions'; 
  $masterItemType=getMasterItemType($itemType);
  $simpleItemType=getSimpleItemType($itemType);
  /* Dashboard settings */
  include PATHBASE.'dashboard_settings.php';

// Select list of columns					 
$arrayStatusX['TODO']=$columnWidth*0;
$arrayStatusX['PROG']=$columnWidth*1;
$arrayStatusX['DONE']=$columnWidth*2;
$arrayStatus[]['colName']=$text_action_todo;
$arrayStatus[]['colName']=$text_action_in_progress;
$arrayStatus[]['colName']=$text_action_done;  

$initialValue='TODO';
$actionFinalStatusTag='DONE';  
  
/* Buttons settings */
$displayTopButtons=false;
$allowAddInFirstColumn=in_array('ADDACTION',$_SESSION['user_actions']) || in_array('ADDACTION',$_SESSION['user_local_actions']);
$allowAdd=false;
$buttonAdd=$button_add_action;
$buttonAddImage='app/new_action.png';

$allowDelete=in_array('DELACTION',$_SESSION['user_actions']) || in_array('DELACTION',$_SESSION['user_local_actions']);
$allowOrder=in_array('ORDACTION',$_SESSION['user_actions']) || in_array('ORDACTION',$_SESSION['user_local_actions']);
$allowUpdate=in_array('UPDACTION',$_SESSION['user_actions']) || in_array('UPDACTION',$_SESSION['user_local_actions']);
$allowMove=in_array('MOVE_ACTION',$_SESSION['user_actions']) || in_array('MOVE_ACTION',$_SESSION['user_local_actions']);

$allowActionHeaderStamp=true;

$buttonAdd=$button_add_action;
$buttonOrder=$button_reorder;
$buttonOrderExtended=$button_reorder_flat;

$otherFieldsInsert=',issue_id_fk';
$otherFieldsInsertValues=','.$_REQUEST['object_id'];

$firstColumnStatic=true;
$firstColumnDisplayParentZone=true;
$firstColumnDisplayWarningZone=true;
$firstColumnObjectTag='I';
$firstColumnTitle=$text_issues;
$firstColumnFunctionForHeaderStamp='displayIssueStatusImageButton';
$firstColumnFunctionForBottomLeft='displayImpactImage';
$firstColumnFunctionForBottomRight='displayProbability';
	
include PATHBASE.'boards_settings/settings_'.$itemType.'.php';
include PATHBASE.'boards_actions/actions_items.php';
include PATHBASE.'boards_actions/actions_actions.php';
  
if (!isset($_SESSION['issue_deck_content']))
{
  $_SESSION['issue_deck_content']=array();
  $_SESSION['issue_deck_content'][0]=0;
  // Get the deck storage of the user
  $request->sqlGet("SELECT item_id_fk FROM ".PARAM_DB_PREFIX."kados_users_decks WHERE user_login_fk='".$_SESSION['login']."' AND item_type='issue'");
  $deckList=array();
  $deckList=$request->getArrayFirstFieldOnly();
  $_SESSION['issue_deck_content']=array_merge($_SESSION['issue_deck_content'],$deckList);
}
if (isset($_REQUEST['add_to_deck']))
{
  if (!array_search((int)$_REQUEST['add_to_deck'],$_SESSION['issue_deck_content']))
  {
    array_push($_SESSION['issue_deck_content'],(int)$_REQUEST['add_to_deck']);
	// Add US to the deck storage of the user
	$request->sqlGet("INSERT INTO ".PARAM_DB_PREFIX."kados_users_decks 
	                 (user_login_fk,item_id_fk,item_type)
					 VALUES ('".$_SESSION['login']."',".($_REQUEST['add_to_deck']).",'issue')");
  }	
}
if (isset($_REQUEST['remove_from_deck']))
{
  $pos=array_search((int)$_REQUEST['remove_from_deck'],$_SESSION['issue_deck_content']);
  if ($pos>0)
  {
    unset($_SESSION['issue_deck_content'][$pos]);
	// Delete US in the deck storage of the user 
	$request->sqlGet("DELETE FROM ".PARAM_DB_PREFIX."kados_users_decks 
	                 WHERE user_login_fk='".$_SESSION['login']."' AND item_type='issue' AND item_id_fk=".$_REQUEST['remove_from_deck']);
  }	
}

// 
$clauseWhereIssueFilter='';
if (isset($_SESSION['filter_issue']))
{
  $clauseWhereIssueFilter=" AND ".PARAM_DB_PREFIX."kados_issues.color='".$_SESSION['filter_issue']."'";
}
 
// Get US of the sprint in deck
$request=new sqlRequest("SELECT issue_id AS parent_id,issue_number AS display_number,text,status AS header_stamp,color,impact AS infoBottomLeft,
                             probability AS infoBottomRight 
                      FROM ".PARAM_DB_PREFIX."kados_issues 
					  WHERE active=1 AND issue_project_id_fk=".$_SESSION['current_project_id']." AND status!='AWAY' 
					   AND issue_id IN (".implode(',',$_SESSION['issue_deck_content']).") ".$clauseWhereIssueFilter." 
					  ORDER BY zpos ASC",$cnx->num);
$deckItemsArray=$request->getArrayFields();

// Get US of the sprint
$request=new sqlRequest("SELECT issue_id AS parent_id,
                                issue_number AS display_number,
                                text,status AS header_stamp,
                                color,impact AS infoBottomLeft,
                                probability AS infoBottomRight ,
                                issue_creator AS creator,
                                issue_creation_date AS creation_date,
                                issue_last_update_date AS last_update,
                                issue_last_updater AS last_updater  
                         FROM ".PARAM_DB_PREFIX."kados_issues 
			 WHERE active=1 AND issue_project_id_fk=".$_SESSION['current_project_id']." 
                           AND status!='AWAY' 
			   AND issue_id NOT IN (".implode(',',$_SESSION['issue_deck_content']).") 
                           ".$clauseWhereIssueFilter." 
			 ORDER BY zpos ASC",$cnx->num);
$MultipleItemsArray=$request->getArrayFields();

// If deck is not empty and board is empty, get an item out of the deck
if (count($deckItemsArray)!=0 && count($MultipleItemsArray)==0)
{
  // si aucune US dans le board, mais il y en a dans le deck, on en sort un du deck
  $deckOut=array_pop($_SESSION['issue_deck_content']);
  // Delete the US from the deck storage for the user
  $request->sqlGet("DELETE FROM ".PARAM_DB_PREFIX."kados_users_decks 
	               WHERE user_login_fk='".$_SESSION['login']."' AND item_id_fk=".$deckOut);  
  $request=new sqlRequest("SELECT issue_id AS parent_id,issue_number AS display_number,text,status AS header_stamp,color,impact AS infoBottomLeft,
                             probability AS infoBottomRight
                        FROM ".PARAM_DB_PREFIX."kados_issues WHERE active=1 AND issue_project_id_fk=".$_SESSION['current_project_id']." AND status!='AWAY' 
						AND issue_id IN (".implode(',',$_SESSION['issue_deck_content']).") 
						".$clauseWhereIssueFilter." ORDER BY zpos ASC",$cnx->num);
  $deckItemsArray=$request->getArrayFields();
  
  $request=new sqlRequest("SELECT issue_id AS parent_id,issue_number AS display_number,
                                  text,status AS header_stamp,color,
                                  impact AS infoBottomLeft,
                                  probability AS infoBottomRight,
                                  issue_creator AS creator,
                                  issue_creation_date AS creation_date,
                                  issue_last_update_date AS last_update,
                                  issue_last_updater AS last_updater                              
                           FROM ".PARAM_DB_PREFIX."kados_issues 
                           WHERE active=1 
                             AND issue_project_id_fk=".$_SESSION['current_project_id']." 
                             AND status!='AWAY' 
			     AND issue_id NOT IN (".implode(',',$_SESSION['issue_deck_content']).") 
                             ".$clauseWhereIssueFilter." 
                           ORDER BY zpos ASC",$cnx->num);
  $MultipleItemsArray=$request->getArrayFields();
}
  
// Display the deck
include PATHBASE.'deck_display_issues.php';
// get project stakeholders
$displayNoUser=true;
$stakeholdersProjects=$currentProject->getStakeholdersAllowedToMoveTasksUsernames();
$projectUsers=$currentProject->getStakeholders();

$showFilterIssue=true;

$displayActionFilter=true;
$showFilterSearch['us']=false;
include PATHBASE.'matrix_display.php';

}
else
{?>
  <div class="MessageBox WarningMessageBox"><?php echo $msg_no_project_selected;?></div><?php
}
include PATHBASE.'footer.php';?>