<?php
/**
 * Page to manage poker planning : allocate compelxity to US
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  ProjectManagement:ObjectSettings
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */  
define("PATHBASE",'./');
$targetFile='project_poker_planning.php?menu_lev2=poker_plan';
$displayTable=true;
	  
include PATHBASE.'header.php';

if (isset($_SESSION['current_project_id']))
{

  /* actions for the page */
  switch ($_REQUEST['action'])
  {
  }

  if ($displayTable)
  {
    $itemType='us_poker';
	$masterItemType=getMasterItemType($itemType);
    $simpleItemType=getSimpleItemType($itemType);

    /* set dashboard settings */
    include PATHBASE.'dashboard_settings.php';
    // Width of a column in a dashboard
    $columnWidth=$itemWidth+40;
	
   	$dashboardProjectValues=explode(";",getProjectSetting('PP_VAL',$_SESSION['current_project_id'],$cnx->num));
	for ($count=0;$count<count($dashboardProjectValues);$count++)
	{
      $arrayStatusX[$dashboardProjectValues[$count]]=$columnWidth*$count;
      $arrayStatus[$count]['colName']=$dashboardProjectValues[$count];
    }     

    $displayTopButtons=false;
    $allowAdd=false;
    $targetAdd='';
    $buttonAdd='';
    $buttonAddImage='';
	
    $allowDelete=false;
    $allowOrder=in_array('ORD_US',$_SESSION['user_actions']) || in_array('ORD_US',$_SESSION['user_local_actions']);
    $allowUpdate=false;
    $allowMove=in_array('SET_COMPLEXITY',$_SESSION['user_actions']) || in_array('SET_COMPLEXITY',$_SESSION['user_local_actions']);
    $allowActionHeaderStamp=false;
    
    $buttonAdd=$button_add_user_story;
    $buttonOrder=$button_reorder;
    $buttonOrderExtended=$button_reorder_flat;

    $firstColumnStatic=true;
	$firstColumnTitle=$text_business_value;
	$displayPriorityButton=true;
	$functionForHeaderStamp='displayStatusImageButton';
	
    include PATHBASE.'boards_settings/settings_'.$itemType.'.php';
    include PATHBASE.'boards_actions/actions_items.php';
    include PATHBASE.'railway_display.php';?>
    <div class="hidden-updateStatusField">postit_footer-right</div><?php
	
    // Get business value
    $MultipleItemsArray=array();
    $request=new sqlRequest("SELECT business_value AS parent_id,business_value AS text,'' AS header_stamp,'' AS color,'' AS infoBottomLeft,'' AS infoBottomRight,
                                    COUNT(us_id) AS nb_us,
                                    us_creator AS creator,
                                    us_creation_date AS creation_date,
                                    us_last_update_date AS last_update,
                                    us_last_updater AS last_updater  
                             FROM ".PARAM_DB_PREFIX."kados_user_stories 
                             WHERE active=1 ".$clauseWhereElementsGetAll." AND business_value!=0 
			     GROUP BY business_value HAVING nb_us>0 
                             ORDER BY business_value DESC",$cnx->num);
    $MultipleItemsArray=$request->getArrayFields();		
    $showFilterUs=true;
    $firstColumnObjectType='info';
    $forceDisplayDashBoardTitles=true;
    $allowAddInFirstColumn=false;
    include PATHBASE.'matrix_display.php';
  }
}
else
{?>
  <div class="MessageBox WarningMessageBox"><?php echo $msg_no_project_selected;?></div><?php
}  


include PATHBASE.'footer.php';?>