<?php
/**
 * RSS generator
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  RSS
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */     

define("PATHBASE",'./');

$pathLibraries=PATHBASE.'libraries/';
$pathClasses=PATHBASE.'libraries/classes/';
$pathCommons=PATHBASE.'common_scripts/';
$pathAppClasses=PATHBASE.'classes/';

require_once $pathCommons.'getDefaultLanguage.php';
include PATHBASE.'conf/connect.conf';
require_once $pathClasses.'class_connexion_mysql.php';
require_once $pathCommons.'functions.php';
// create a database connexion
$cnx=new connexion_db();   
require_once PATHBASE.'session_settings.php';

require_once $pathAppClasses.'project.php';
require_once $pathLibraries.'FeedGenerator/FeedWriter.php';


// Set default language using the browser language 
if (isset($_GET['language']))
{
  $defaultLanguage=strtolower(substr($_GET['language'],0,2));
}
else
{   
  $defaultLanguage=substr(getDefaultLanguage(),0,2);        
}
$request=new sqlRequest("SELECT language_tag FROM ".PARAM_DB_PREFIX."framework_languages WHERE language_status=1 ",$cnx->num);
$availableLanguages=$request->getArrayFirstFieldOnly();
$displayLanguage= in_array($defaultLanguage,$availableLanguages) ? $defaultLanguage : 'en' ;
$_SESSION['language']=$displayLanguage;

require_once $pathCommons.'date_hour.php';
require_once PATHBASE.'messages/'.$displayLanguage.'_ihm_messages.php';
require_once PATHBASE.'messages/'.$displayLanguage.'_app_messages.php';
require_once $pathCommons.'functions.php';
require_once $pathCommons.'app_functions.php';
 
// init var for RSS flow
$ChannelTitle='';
$ChannelDesc='';
$itemsList=array();

// init check for rss Key
$isRssKeyOk=false;

// init check for data
$isParameterOk=false;

$allowRss=getParameter('RSSACT',$cnx->num);
// display RSS if allowed
if ($allowRss)
{
  if (isset($_GET['us_id']))
  {
    $request=new sqlRequest("SELECT us_id,us_number AS title,text AS description,status,us_project_id_fk  
                          FROM ".PARAM_DB_PREFIX."kados_user_stories 
                          WHERE us_id=".intval($_GET['us_id']),$cnx->num);
    $request->countRows();
    if ($request->rowCount!=0)
    {    
      $usData=$request->getObject();
      $ChannelTitle='US'.$usData->title.' '.$usStatusTable[$usData->status];
      $ChannelDesc=$usData->description;
  
      $request->sqlGet("SELECT task_id,task_number AS title,text AS description,column_name,status 
                       FROM ".PARAM_DB_PREFIX."kados_tasks,".PARAM_DB_PREFIX."kados_template_columns 
                       WHERE active=1 
                         AND us_id_fk=".intval($_GET['us_id'])." 
                         AND column_tag=status     
                       ORDER BY status");
      $itemsList=$request->getArrayFields();						
    
      // get token of project
      $projectData=new project($cnx->num,$usData->us_project_id_fk);
      $projectData->getData();    
      // check if token is OK  
      $isRssKeyOk=($_GET['token']==$projectData->rssKey);
      $isParameterOk=true;
    }  
  } 
  else if (isset($_GET['sprint_id']))
  {
    $request=new sqlRequest("SELECT project_name,release_name,release_due_date,release_project_id_fk, 
                                 sprint_name,sprint_start_date,sprint_end_date
                          FROM ".PARAM_DB_PREFIX."kados_projects,".PARAM_DB_PREFIX."kados_releases,".PARAM_DB_PREFIX."kados_sprints 
                          WHERE project_id=release_project_id_fk 
	                    AND release_id=sprint_release_id_fk 
                            AND sprint_id=".intval($_GET['sprint_id']),$cnx->num);
    $request->countRows();
    if ($request->rowCount!=0)
    {    
      $sprintData=$request->getObject();
      $ChannelTitle=$text_sprint_content.' '.$sprintData->sprint_name;
      $ChannelDesc=$text_sprint_content.' '.$sprintData->sprint_name.' '.$text_of.' '.$text_the_f.' '.$text_release.' '.$sprintData->release_name.' '.$text_of_the.' '.$text_project.' '.$sprintData->project_name;
  
      $request->sqlGet("SELECT us_id,us_number AS title,text AS description,status  
                       FROM ".PARAM_DB_PREFIX."kados_user_stories 
                       WHERE active=1 
                         AND us_sprint_id_fk=".intval($_GET['sprint_id'])." 
                       ORDER BY status");
      $itemsList=$request->getArrayFields();						
    
      // get token of project
      $projectData=new project($cnx->num,$sprintData->release_project_id_fk);
      $projectData->getData();    
      // check if token is OK  
      $isRssKeyOk=($_GET['token']==$projectData->rssKey);
      $isParameterOk=true;
    }  
  } 
  elseif (isset($_GET['release_id']))
  {
    $request=new sqlRequest("SELECT project_name,release_name,release_due_date,
                                 release_project_id_fk 
                          FROM ".PARAM_DB_PREFIX."kados_projects,".PARAM_DB_PREFIX."kados_releases 
                          WHERE project_id=release_project_id_fk 
			    AND release_id=".intval($_GET['release_id']),$cnx->num);
    $request->countRows();
    if ($request->rowCount!=0)
    {      
      $releaseData=$request->getObject();
      $ChannelTitle=$text_release_content.' '.$releaseData->release_name;
      $ChannelDesc=$text_release_content.' '.$releaseData->release_name.' '.$text_of_the.' '.$text_project.' '.$releaseData->project_name;
    
      $request->sqlGet("SELECT us_id,us_number AS title,text AS description,status  
                       FROM ".PARAM_DB_PREFIX."kados_user_stories 
                       WHERE active=1 
                         AND us_release_id_fk=".intval($_GET['release_id'])." 
                       ORDER BY status");
      $itemsList=$request->getArrayFields();	
      // get token of project
      $projectData=new project($cnx->num,$releaseData->release_project_id_fk);
      $projectData->getData();    
      // check if token is OK  
      $isRssKeyOk=($_GET['token']==$projectData->rssKey);      
      $isParameterOk=true;
    }  
  }
  elseif (isset($_GET['project_id']))
  {
    $projectData=new project($cnx->num,intval($_GET['project_id']));
    $projectData->getData();    
    $ChannelTitle=$text_project.' '.$projectData->name;
    $ChannelDesc=$text_project.' '.$projectData->name;
  
    $request->sqlGet("SELECT us_id,us_number AS title,text AS description,status  
                     FROM ".PARAM_DB_PREFIX."kados_user_stories 
                     WHERE active=1 
                       AND us_project_id_fk=".intval($_GET['project_id'])." 
                     ORDER BY status");
    $itemsList=$request->getArrayFields();		

    // check if token is OK  
    $isRssKeyOk=($_GET['token']==$projectData->rssKey);         
    $isParameterOk=($projectData->projectId!=0);
  }
  
  // if parameter exists
  if ($isParameterOk)
  {
    // If rss key is OK, display RSS flow
    if ($isRssKeyOk)
    {
      //Creating an instance of FeedWriter class. 
      //The constant RSS2 is passed to mention the version
      $TestFeed = new FeedWriter(RSS2);
  
      //Setting the channel elements
      //Use wrapper functions for common channel elements
      $TestFeed->setTitle($ChannelTitle);
      //$TestFeed->setLink('http://www.ajaxray.com/projects/rss');
      $TestFeed->setDescription($ChannelDesc);
  
      //Use core setChannelElement() function for other optional channels
      $TestFeed->setChannelElement('language', $_SESSION['language'].'-'.$_SESSION['language']);
      $TestFeed->setChannelElement('pubDate', date(DATE_RSS, time()));        
 
      // add items with data comin from items list
      for ($i=0;$i<count($itemsList);$i++)
      {
        //Elements which have attribute cannot be added by this way
        $newItem = $TestFeed->createNewItem();
        
        if (isset($_GET['us_id']))
        {
          $newItem->addElementArray(array('title'=>'TSK'.$itemsList[$i]['title'].' - '.$itemsList[$i]['column_name'], 'link'=>'', 'description'=>$itemsList[$i]['description']));   
        }
        else
        {
          // get final status
          $finalStatus=getFinalStatus($projectData->projectId);
          $newItem->addElementArray(array('title'=>'US'.$itemsList[$i]['title'].' - '.$usStatusTable[$itemsList[$i]['status']], 'link'=>'', 'description'=>$itemsList[$i]['description']));   
        }  
	$TestFeed->addItem($newItem);
      }		

      //OK. Everything is done. Now genarate the feed.
      $TestFeed->genarateFeed();          
    }
    else
    {
      // RSS Key is KO
      echo utf8_decode($msg_rss_key_is_incorrect);
    }  
  }
  else
  {
    // Parameter sent to rss is incorrect, wrong project or release or sprint or US id  
    echo utf8_decode($msg_parameter_is_incorrect);      
  }
}	  
else
{
  echo $msg_rss_is_not_available;
}
?>