<?php
// Init step check right to write in conf/
// First Step : connect.conf 
// Second Step : update DB
// Third Step : update LDAP conf
// Fourth Step : update VERSION file with new version
define("PATHBASE","../../../");

$errorMessages['ERR_FINDFILE_LDAP']="Error : unable to find ldap conf file => Sorry, you'll have to do it manually.";
$errorMessages['ERR_CONNECTDB']='Error : unable to connect to DB';
$errorMessages['ERR_CONNECTDATA']='Error : no conf file for connection';
$errorMessages['ERR_RENAME']= "Error : impossible to rename connect.conf => Sorry, you'll have to do it manually.";
$errorMessages['ERR_FINDFILE_CONF']="Error : unable to find conf file => Sorry, you'll have to do it manually.";

function rrmdir($dir) {
 if (is_dir($dir)) { // si le paramtre est un dossier
     $objects = scandir($dir); // on scan le dossier pour rcuprer ses objets
     foreach ($objects as $object) { // pour chaque objet
          if ($object != "." && $object != "..") { // si l'objet n'est pas . ou ..
               if (filetype($dir."/".$object) == "dir") rrmdir($dir."/".$object);else unlink($dir."/".$object); // on supprime l'objet
              }
     }
     reset($objects); // on remet  0 les objets
     rmdir($dir); // on supprime le dossier
     }
 }

// STEP 1
echo 'STEP1 : Starting connection data update.<br />';
require 'update_connect_conf.php';
if ($result=='OK' || $result=='WARN_DONE')
{?>
  <img src='<?php echo PATHBASE;?>images/tick.png'/> <?php  
  if ($result=='OK')
  {
    echo 'Connection data update OK, going to next step.<br /><br />';
  }
  else if($result=='WARN_DONE')
  {
    echo 'Connection data update already done, going to next step.<br /><br />';  
  }
  // STEP 2
  echo 'STEP2 : Starting DB update.<br />';
  
  $mysqli = new mysqli(PARAM_CNX_HOST, PARAM_CNX_USER, PARAM_CNX_PASS, PARAM_CNX_DB);  
  $mysqli->query("SET NAMES '".PARAM_CNX_CHARSET."'");
  // check if update already done
  // check db version (parameter DBVERS added in R9) 
  $resultCheck=$mysqli->query("SELECT parameter_value FROM ".PARAM_DB_PREFIX."framework_parameters
                               WHERE  parameter_tag_id= 'DBVERS'");
if ($resultCheck->num_rows!=0)
{
  $row = $resultCheck->fetch_row();
  if ($row[0]=='9')
  {
    $queries=file('upgrade.sql');

    $overallResult=true;
    $file=fopen('upgrade_sql_error.txt','w');
    for ($i=0;$i<count($queries);$i++)
    {
      $resultQuery=$mysqli->query($queries[$i]);
      $overallResult= $overallResult && $resultQuery;
      if (!$resultQuery)
      {
        fwrite($file,"REQUEST #".($i+1).' : '.$mysqli->error."\n");
      }
    }  
    fclose($file);
    // update parameter
    $mysqli->query("UPDATE ".PARAM_DB_PREFIX."framework_parameters SET parameter_value='10' WHERE parameter_tag_id= 'DBVERS'");
    // update missing translations
    $mysqli->query("DELETE FROM ".PARAM_DB_PREFIX."framework_menus_translations WHERE menu_tag_fk='chg_pass' AND menu_translation_language IN('es','br')");
    $mysqli->query("INSERT INTO ".PARAM_DB_PREFIX."framework_menus_translations  (menu_tag_fk,menu_translation_language,menu_translation_value) VALUES ('chg_pass','br','Modificar a senha');");
    $mysqli->query("INSERT INTO ".PARAM_DB_PREFIX."framework_menus_translations  (menu_tag_fk,menu_translation_language,menu_translation_value) VALUES ('chg_pass','es','Cambiar la contraseña');");
    $mysqli->query("DELETE FROM ".PARAM_DB_PREFIX."framework_menus_translations WHERE menu_tag_fk='prj_exports' AND menu_translation_language IN('br')");
    $mysqli->query("INSERT INTO ".PARAM_DB_PREFIX."framework_menus_translations  (menu_tag_fk,menu_translation_language,menu_translation_value) VALUES ('prj_exports','br','Exportaes');");
    
    $mysqli->close();
    if ($overallResult)
    {?>
      <img src='<?php echo PATHBASE;?>images/tick.png'/> <?php  
      echo 'DB update OK, going to next step.<br /><br />'; 
    }      
    else
    {?>
      <img src='<?php echo PATHBASE;?>images/error.png'/> <?php  
      echo "At least one request was not correctly executed.<br />Here are the errors found. You will have to manually complete the upgrade.<br /><i>";
      include 'upgrade_sql_error.txt';
      echo '</i><br /><br />';
    }
  }
  else
  {
     echo 'DB update already done, going to next step.<br /><br />'; 
  }
}
  // STEP 3 
  echo 'STEP 3 : Delete obsolete themes files.<br />';  
  rrmdir(PATHBASE.'themes/blue');
  rrmdir(PATHBASE.'themes/blue2014');
  rrmdir(PATHBASE.'themes/blue2014Full');
  rrmdir(PATHBASE.'themes/blueFull');
  rrmdir(PATHBASE.'themes/blueMinimalHeader');
  rrmdir(PATHBASE.'themes/blueMinimalHeaderFull');
  rrmdir(PATHBASE.'themes/default');
  rrmdir(PATHBASE.'themes/default2014');
  rrmdir(PATHBASE.'themes/default2014Full');
  rrmdir(PATHBASE.'themes/defaultFull');
  rrmdir(PATHBASE.'themes/defaultMinimalHeader');
  rrmdir(PATHBASE.'themes/defaultMinimalHeaderFull');  
  rrmdir(PATHBASE.'themes/default2015');
  rrmdir(PATHBASE.'themes/green');
  rrmdir(PATHBASE.'themes/green2014');
  rrmdir(PATHBASE.'themes/orange');
  rrmdir(PATHBASE.'themes/orange2014');   ?>
  <img src='<?php echo PATHBASE;?>images/tick.png'/> <?php  
  echo 'Deletion of obsolete themes finished.<br /><br />';?><br />  <?php
  // STEP 4 
  echo 'STEP 4 : Update VERSION file.<br />';
  unlink(PATHBASE.'VERSION');
  copy(PATHBASE.'VERSION_NEW',PATHBASE.'VERSION');?>
  <img src='<?php echo PATHBASE;?>images/tick.png'/> <?php  
  echo 'Update VERSION file, upgrade is finished.<br /><br />';?><br />
  <a href="<?php echo PATHBASE;?>index.php" >CONNECT TO KADOS</a><?php
}
else
{?>
  <img src='<?php echo PATHBASE;?>images/error.png'/> <?php  
  echo $errorMessages[$result];
  echo '<br />You will have to proceed with a manual upgrade, please refer to upgrade_FR.txt or upgrade_EN.txt in the upgrade release package';
}?>