<?php
// Init step check right to write in conf/
// First Step : create connect.conf
// Second Step : load DB
// Third Step : update VERSION file with new version
define("PATHBASE","../../../");

$errorMessages['ERR_FINDFILE_LDAP']="Error : unable to find ldap conf file => Sorry, you'll have to do it manually.";
$errorMessages['ERR_CONNECTDB']='Error : unable to connect to DB';
$errorMessages['ERR_CONNECTDATA']='Error : no conf file for connection';
$errorMessages['ERR_RENAME']= "Error : impossible to rename connect.conf => Sorry, you'll have to do it manually.";
$errorMessages['ERR_FINDFILE_CONF']="Error : unable to find conf file => Sorry, you'll have to do it manually.";

$doToStep3=true;

  // STEP 2
  echo 'STEP2 : Starting DB install.<br />';
  require PATHBASE."conf/connect.conf";
  $mysqli = new mysqli(PARAM_CNX_HOST, PARAM_CNX_USER, PARAM_CNX_PASS, PARAM_CNX_DB);  
  $mysqli->query("SET NAMES '".PARAM_CNX_CHARSET."'");
  // check if update already done
  $resultCheck=$mysqli->query("SELECT COUNT(*) FROM information_schema.tables
                               WHERE table_schema = '".PARAM_CNX_DB."' 
							     AND (table_name LIKE '".PARAM_DB_PREFIX."framework_%' OR table_name LIKE 'kados_%');");
  $row = $resultCheck->fetch_row();
  if ($row[0]==0)
  {
    // replace with prefix
    $string_file=file_get_contents("install_source.sql");
    $string_file=str_replace('[DB_PREFIX]',PARAM_DB_PREFIX,$string_file);  
    $file=fopen("install.sql","w");
    fwrite($file,$string_file);   
    fclose($file);      
      
    $queries=file('install.sql');

    $overallResult=true;
    $file=fopen('install_sql_error.txt','w');
    for ($i=0;$i<count($queries);$i++)
    {
      $resultQuery=$mysqli->query($queries[$i]);
      $overallResult= $overallResult && $resultQuery;
      if (!$resultQuery)
      {
        fwrite($file,"REQUEST #".($i+1).' : '.$mysqli->error."\n");
      }
    }  
    fclose($file);
    $mysqli->close();
    if ($overallResult)
    {?>
      <img src='<?php echo PATHBASE;?>images/tick.png'/> <?php  
      echo 'DB install OK, going to next step.<br /><br />'; 
    }      
    else
    {?>
      <img src='<?php echo PATHBASE;?>images/error.png'/> <?php  
      echo "At least one request was not correctly executed.<br />Here are the errors found. You will have to manually complete the installation.<br /><i>";
      include 'install_sql_error.txt';
      echo '</i><br /><br />';
    }
  }
  else
  {
    $resultCheck=$mysqli->query("SELECT parameter_value FROM ".PARAM_DB_PREFIX."framework_parameters
                                 WHERE parameter_tag_id = 'BDVERS';");
    // if exists, then bd already installed since it has been created for R9
    if ($resultCheck->num_rows)
    {
      // no need to check value, it can only be 9
      echo 'DB install already done, going to next step.<br /><br />';   
    }  
    else
    {?>
      <img src='<?php echo PATHBASE;?>images/warning.gif'/> <?php 
      echo 'You are in an Install process with an already existing Database from a previous release. <br />This situation is not managed by the automatic process. <br />To protect your database, the automatic process stops here. <br />Please follow the manual install or update instructions.<br /><br />';     
      $doToStep3=false;
    }
  }
// If step3 is allowed, do it !
if ($doToStep3)
{
  // STEP 3
  echo 'STEP3 : Create VERSION file.<br />';
  copy(PATHBASE.'VERSION_NEW',PATHBASE.'VERSION');?>
  <img src='<?php echo PATHBASE;?>images/tick.png'/> <?php  
  echo 'Update VERSION file, installation is finished.<br /><br />';?><br />
  <a href="<?php echo PATHBASE;?>index.php" >CONNECT TO KADOS</a><?php  
}
