<?php
/**
 * Creates an excel file with  the result list of a search on an information
 * 
 * PHP version 5
 * 
 * @category Exports
 * @package  exportCsv
 * @author   Charles Santucci <charles.santucci@renault.com>
 * @license  GPL v3, MIT
*/

set_time_limit(600);
ini_set('memory_limit','64M');
define("PATHBASE",'../');
$pathLibraries=PATHBASE.'libraries/';
$pathImages=PATHBASE.'images/';
$pathAppClasses=PATHBASE.'classes/';
$pathCommons=PATHBASE.'common_scripts/';
  
require_once $pathCommons.'functions.php';



  $listeLangues=array('fr','en');
  $listeFichiers=array();
  $ffs = scandir('../messages/');
  foreach($ffs as $ff)
  {
      if(!in_array($ff,array('.','..','index.php')))
      {
         $data=explode('_',$ff);
         $tag=$data[0];
         if (!in_array($tag,$listeLangues))
         {
            $listeLangues[]=$tag;   
         }
         $reste=$data[1];
         if (!in_array($reste,$listeFichiers))
         {
            $listeFichiers[]=$reste;   
         }         
      }
    }

  $matrice=array();  
  for($j=0;$j<count($listeFichiers);$j++)  
  {
    for ($i=0;$i<count($listeLangues);$i++)  
    {
       $file=fopen('../messages/'.$listeLangues[$i].'_'.$listeFichiers[$j].'_messages.php','r');  
       while($line=fgets($file)) 
       {
         // if ligne is a variable  
         if ($line[0]=='$')  
         {
           $data=explode('=',$line);
           $chaine=explode('encode(',$data[1]);
           $matrice[$listeFichiers[$j]][ltrim($data[0],'$')][$listeLangues[$i]]= trim(trim(rtrim(rtrim(trim($chaine[1]),';'),')'),'\''),'"');
         }
       }
    }
  }
  
  $displayAll=false;
  $langueRef='fr';
  

// BUILD FILE
$filename='export.csv';
$fname=PATHBASE.'tmp/'.$filename;
$fh = fopen($fname,'w');


  
  foreach($matrice as $key => $sous_matrice) 
  {
    fputcsv($fh,array_merge(array($key),array_fill(0,5,'')),';');
    fputcsv($fh,array_merge(array('LABEL'),$listeLangues),';');
    foreach($sous_matrice as $cle=>$var)  
    {
      $display=false; 
      $line[0]=$cle;
      
      for ($i=0;$i<count($listeLangues);$i++)  
      {
        if (isset($valeur[$listeLangues[$i]]))
        {
          $line[$i+1]= $valeur[$listeLangues[$i]];
        }
        else
        {
           $line[$i+1]='';  
           $display=true;
        }
      }
      if ($display ||$displayAll)
      {
        fputcsv($fh,$line,';');
      }  
    }
    fputcsv($fh,array_fill(0,6,''),';');
  }

fclose($fh);

header("Content-Type: application/octet-stream");
header('Content-Disposition: inline; filename="'.$filename.'"');
readfile($fname); 
unlink($fname);