<?php
/**
 *
 * PHP versions 4 and 5
 *
 * @category Scripts
 * @package  Project_Mngt:index
 * @author   Charles Santucci <charles.santucci@marmotte-technologies.org>
 * @license  GPL v3, MIT
 * */
define("PATHBASE",'./');
require_once PATHBASE.'constants.php';
$pathClasses=PATHBASE.'libraries/classes/';
$pathCommons=PATHBASE.'common_scripts/';  
$pathImages=PATHBASE.'images/';


require_once $pathCommons.'getDefaultLanguage.php';
include PATHBASE.'conf/connect.conf';
require_once $pathClasses.'class_connexion_mysql.php';
require_once $pathCommons.'functions.php';
$cnx=new connexion_db();
require_once PATHBASE.'session_settings.php';

$_SESSION['charset']=$cnx->charset;

// Set default language using the browser language 
$request=new sqlRequest("SELECT language_tag FROM ".PARAM_DB_PREFIX."framework_languages  ",$cnx->num);
$availableLanguages=$request->getArrayFirstFieldOnly();
// if URL gives a language use it
if (isset($_GET['lg']))
{
  $browserLanguage=$_GET['lg'];
}   
else
{    
  // else use the default language for app  
  $browserDefaultLanguage=strtolower(getDefaultLanguage());
}
// set language in session var 
$_SESSION['language']= in_array($browserLanguage,$availableLanguages) ? $browserLanguage : getParameter('DFLANG',$cnx->num) ;

if (isset($_GET['change_language']))
{  
  $request=new sqlRequest("SELECT language_tag FROM ".PARAM_DB_PREFIX."framework_languages  ",$cnx->num);
  $availableLanguages=$request->getArrayFirstFieldOnly();
  $changeLanguage=strtolower(substr($_GET['change_language'],0,2));
  $_SESSION['language']=in_array($changeLanguage,$availableLanguages) ? $changeLanguage : getParameter('DFLANG',$cnx->num) ;
} 

require_once $pathClasses.'class_ldap.php';
require_once $pathCommons.'date_hour.php';
require_once PATHBASE.'messages/'.$_SESSION['language'].'_ihm_messages.php';
require_once PATHBASE.'messages/'.$_SESSION['language'].'_app_messages.php';
require_once PATHBASE.'messages/'.$_SESSION['language'].'_js_messages.php';
require_once $pathCommons.'functions.php';
require_once $pathCommons.'app_functions.php';

$targetFile='validate.php?';

$msg_error=$msg_unknown_request;

if (!isset($_REQUEST['connexion']))
{
  $_REQUEST['connexion']='';
}  

// id parameter is k
if (isset($_GET['k']))
{
  $keyFromUser=$_GET['k'];  
  // check key format : only alphanumeric
  if (!preg_match("/^[a-z0-9]+$/",strtolower($keyFromUser)))
  {
    // error : key format is incorrect  
    $msg_error=$text_key_not_valid;  
  }
  else
  {
    // check if there is any user with that key
    $request->sqlGet("SELECT user_login,user_confirmation_key_stamp,user_confirmed,user_language 
                     FROM ".PARAM_DB_PREFIX."framework_users WHERE user_confirmation_key='".$keyFromUser."'");  
    $request->countRows();
    if ($request->rowCount==0)
    {
      // error : key does not exists  
      $msg_error=$text_key_not_valid;  
    }    
    else
    {
      $userData=$request->getObject();
      // is the key valid ?
      $today=new DateTime();
      $keyValidityDate=new DateTime($userData->user_confirmation_key_stamp);
      // add 48h to key date
      $keyValidityDate->add(new DateInterval("PT48H"));
      // check if time of check is before due date
      if ($today>$keyValidityDate)  
      {
        // error : key not valid anymore  
        $msg_error=$text_key_no_more_valid;  
      }
      else
      {
        // check is user is already confirmed 
        if ($userData->user_confirmed==1)  
        {
          // error : user is already confirmed
          $msg_error=$msg_user_already_confirmed;  
        }
        else
        {
          // Activate and display for password  
          unset($msg_error);
        }    
      }
    }
  }
}
else
{      
switch($_REQUEST['connexion'])
{
  case 'on':
    $formKey=$_POST['key'];
    // check if there is any user with that key
    $request=new sqlRequest("SELECT user_login
                          FROM ".PARAM_DB_PREFIX."framework_users 
                          WHERE user_confirmation_key='".$formKey."'",$cnx->num);  
    $request->countRows();
    if ($request->rowCount==0)
    {
      // error : key does not exists  
      $msg_error=$text_key_not_valid;  
    }    
    else
    {
      $userData=$request->getObject();  
      $formLogin=$userData->user_login;
      // update password and confirm account
      $request->sqlGet("UPDATE ".PARAM_DB_PREFIX."framework_users 
                       SET user_confirmed=1,user_password='".md5($_POST['form_item_new_password'])."' 
                       WHERE user_login='".$formLogin."'");        
      // get user data  
      $request->sqlGet("SELECT user_password,user_name,user_firstname,user_profile_id_fk,
                               user_language,profile_tag,user_theme  
                        FROM ".PARAM_DB_PREFIX."framework_users,
                             ".PARAM_DB_PREFIX."framework_profiles                                   
	                WHERE user_login='".$formLogin."' 
	                  AND user_profile_id_fk=profile_id");
      $request->getObject();
      $_SESSION['login']=strtolower($formLogin);     
      $_SESSION['user_fullname']=$request->objet->user_firstname.' '.$request->objet->user_name;
      $_SESSION['language']=$request->objet->user_language;
      $_SESSION['user_rights']=array();
      $_SESSION['user_theme']=$request->objet->user_theme;
      $_SESSION['user_profile']=intval($request->objet->user_profile_id_fk);
      $_SESSION['user_profile_tag']=$request->objet->profile_tag;
      $request->sqlGet("SELECT action_tag_fk 
                       FROM ".PARAM_DB_PREFIX."framework_profiles_constitution_actions 
                       WHERE profile_id_fk=".$_SESSION['user_profile']);
      $_SESSION['user_actions']=$request->getArrayFirstFieldOnly();
      $menu_lev1=array();
      $sqlMenus="SELECT menu_tag AS tag,menu_translation_value AS titre,menu_file AS file 
                 FROM ".PARAM_DB_PREFIX."framework_menus,".PARAM_DB_PREFIX."framework_menus_translations,".PARAM_DB_PREFIX."framework_profiles_constitution_menus 
                 WHERE menu_father='' AND menu_translation_language='".$_SESSION['language']."' 
                   AND menu_tag=".PARAM_DB_PREFIX."framework_menus_translations.menu_tag_fk 
                   AND menu_tag=".PARAM_DB_PREFIX."framework_profiles_constitution_menus.menu_tag_fk 
                   AND profile_id_fk=".$_SESSION['user_profile']." 
                 ORDER BY menu_order 
                 LIMIT 0,1";
      $request=new sqlRequest($sqlMenus,$cnx->num);
      $menu_lev1=$request->getArrayFields();	
      $_SESSION['menu_lev1']=$menu_lev1[0]['tag'];	
      $targetStartFile=$menu_lev1[0]['file'];
      header('location:'.$targetStartFile);
    }
  break;  
}
}?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<title><?php TextDisplay($appName);?></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link rel="icon" type="image/png" href="<?php echo $pathImages;?>app/favicon.png" />

<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/global.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/bulle.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/form.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/sweetalert/sweet-alert.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/app.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/buttons.css" />
<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>css/forms.css" />

<link rel="stylesheet" type="text/css" href="<?php echo PATHBASE;?>themes/<?php echo getParameter('THEME',$cnx->num);?>/theme.css" />

<?php require_once PATHBASE."js/messages.js.php"; ?>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/global.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/app.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/jquery/jquery.min.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/jquery/jquery-ui.min.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/validate.js"></script>
<script type="text/javascript" src="<?php echo PATHBASE;?>js/sweet-alert.min.js"></script>
</head>

<body>

<div class="global">

<!-- START HEADER!-->
<div class="display_header">
  <div class="logo"><img src="<?php echo PATHBASE;?>themes/<?php echo getParameter('THEME',$cnx->num);?>/images/logo.png" border="0" /></div>
  <div class="title"><?php TextDisplay($appName);?></div>  
  <div class="subtitle"><?php if (isset($appSubTitle)) { TextDisplay($appSubTitle);}?></div>
  <div class="languages"><?php
   $request=new sqlRequest("SELECT language_tag FROM ".PARAM_DB_PREFIX."framework_languages   ORDER BY language_tag",$cnx->num); 
   $resultsArray=$request->getArrayFields();
   // list languages with link to switch language
   for ($i=0;$i<count($resultsArray);$i++)
   {?>
     <a href="<?php echo setUrlForParam($_SERVER['REQUEST_URI']);?>change_language=<?php echo $resultsArray[$i]['language_tag'];?>" class="std_link link_flag"><img src="<?php echo $pathImages;?>flags/<?php echo $resultsArray[$i]['language_tag'];?>-small.png" border="0"/></a> <?php
   }?>	 
  </div>    
</div>
<div class="sol"></div>
<div class="clearleft"></div>
<!-- END HEADER!-->


<div class="display_body"><?php
        if (isset($msg_error))
        {?>
           <div class="MessageBox ErrorMessageBox"><?php TextDisplay($msg_error);?></div><br />
           <div class="back_home std_link"><a href="index.php"><?php TextDisplay($text_back_home);?></a></div> <?php
        }
        else
        {
          if (isset($msg_warning))
          {?>
            <div class="MessageBox WarningMessageBox"><?php TextDisplay($msg_warning);?></div><?php
          }?>
          <div class="MessageBox WarningMessageBox"><?php TextDisplay($msg_password_rules);?></div>  
          <form class="pure-form pure-form-aligned" action="<?php echo $targetFile;?>"  method="POST" name="form_user_password" onkeypress="javascript:if(event.keyCode == 13){CheckFormPassword();}">
	     <fieldset class="fieldset">
	     <input type="hidden" name="connexion" value="on" />
             <input type="hidden" name="key" value="<?php echo $_GET['k'];?>" /> 
             
           <legend class="legend"><?php TextDisplay($legend_change_password);?></legend><?php
           $currentPasswordCheck=false;
           include PATHBASE.'administration/user_change_password_form.php';?>
	    <div style="margin-top:15px"><?php
              displayButton($button_submit,'','javascript:CheckFormPassword()','tsc_awb_medium tsc_awb_green tsc_flat');	?>
            </div>  		   
		   
		  </fieldset> 
          </form>
          <script type="text/javascript">document.form_user_password.form_item_new_password.focus();</script>   <?php 
        }
        
require_once PATHBASE.'footer.php';?>

